// Константы типов фигур CorelDRAW
// Для использования в проектах wpanel

var cdrNoShape = 0;                    // Нет фигуры
var cdrRectangleShape = 1;             // Прямоугольник
var cdrRectangle = 1;             // Прямоугольник
var cdrEllipseShape = 2;               // Эллипс
var cdrEllipse = 2;               // Эллипс
var cdrCurveShape = 3;                 // Кривая
var cdrCurve = 3;                 // Кривая
var cdrPolygonShape = 4;               // Полигон
var cdrPolygon = 4;               // Полигон
var cdrBitmapShape = 5;                // Битмап
var cdrBitmap = 5;                // Битмап
var cdrTextShape = 6;                  // Текст
var cdrText = 6;                  // Текст
var cdrGroupShape = 7;                 // Группа
var cdrGroup = 7;                 // Группа
var cdrSelectionShape = 8;             // Выделение
var cdrGuidelineShape = 9;             // Направляющая
var cdrBlendGroupShape = 10;           // Группа перетекания
var cdrExtrudeGroupShape = 11;         // Группа выдавливания
var cdrOLEObjectShape = 12;            // OLE объект
var cdrContourGroupShape = 13;         // Группа контура
var cdrLinearDimensionShape = 14;      // Линейный размер
var cdrBevelGroupShape = 15;           // Группа фаски
var cdrDropShadowGroupShape = 16;      // Группа тени
var cdr3DObjectShape = 17;             // 3D объект
var cdrArtisticMediaGroupShape = 18;   // Группа художественных медиа
var cdrConnectorShape = 19;            // Соединитель
var cdrMeshFillShape = 20;             // Сетчатая заливка
var cdrCustomShape = 21;               // Пользовательская фигура
var cdrCustomEffectGroupShape = 22;    // Группа пользовательских эффектов
var cdrSymbolShape = 23;               // Символ
var cdrHTMLFormObjectShape = 24;       // HTML форма
var cdrHTMLActiveObjectShape = 25;     // HTML активный объект
var cdrPerfectShape = 26;              // Идеальная фигура
var cdrEPSShape = 27;                  // EPS

// Функция для получения имени типа фигуры по числу (для отладки)
function getShapeTypeName(shapeType) {
    switch(shapeType) {
        case cdrNoShape: return "NoShape";
        case cdrRectangleShape: return "Rectangle";
        case cdrEllipseShape: return "Ellipse";
        case cdrCurveShape: return "Curve";
        case cdrPolygonShape: return "Polygon";
        case cdrBitmapShape: return "Bitmap";
        case cdrTextShape: return "Text";
        case cdrGroupShape: return "Group";
        case cdrSelectionShape: return "Selection";
        case cdrGuidelineShape: return "Guideline";
        case cdrBlendGroupShape: return "BlendGroup";
        case cdrExtrudeGroupShape: return "ExtrudeGroup";
        case cdrOLEObjectShape: return "OLEObject";
        case cdrContourGroupShape: return "ContourGroup";
        case cdrLinearDimensionShape: return "LinearDimension";
        case cdrBevelGroupShape: return "BevelGroup";
        case cdrDropShadowGroupShape: return "DropShadowGroup";
        case cdr3DObjectShape: return "3DObject";
        case cdrArtisticMediaGroupShape: return "ArtisticMediaGroup";
        case cdrConnectorShape: return "Connector";
        case cdrMeshFillShape: return "MeshFill";
        case cdrCustomShape: return "CustomShape";
        case cdrCustomEffectGroupShape: return "CustomEffectGroup";
        case cdrSymbolShape: return "Symbol";
        case cdrHTMLFormObjectShape: return "HTMLFormObject";
        case cdrHTMLActiveObjectShape: return "HTMLActiveObject";
        case cdrPerfectShape: return "PerfectShape";
        case cdrEPSShape: return "EPS";
        default: return "Unknown (" + shapeType + ")";
    }
}

// Константы типов контуров CorelDRAW
var cdrNoOutline = 0;                      // Нет контура
var cdrOutline = 1;                        // Обычный контур  
var cdrEnhancedOutline = 2;                // Расширенный контур

// Константы типов заливок CorelDRAW
var cdrNoFill = 0;                         // Нет заливки
var cdrUniformFill = 1;                    // Однородная заливка
var cdrFountainFill = 2;                   // Градиентная заливка
var cdrPatternFill = 3;                    // Узорная заливка
var cdrTextureFill = 4;                    // Текстурная заливка
var cdrPostScriptFill = 5;                 // PostScript заливка
var cdrTwoColorPatternFill = 6;            // Двухцветная узорная заливка
var cdrBitmapFill = 7;                     // Bitmap заливка
var cdrFullColorPatternFill = 8;           // Полноцветная узорная заливка
var cdrMeshFill = 9;                       // Сетчатая заливка

// Функция для получения имени типа контура (для отладки)
function getOutlineTypeName(outlineType) {
    switch(outlineType) {
        case cdrNoOutline: return "NoOutline";
        case cdrOutline: return "Outline";
        case cdrEnhancedOutline: return "EnhancedOutline";
        default: return "Unknown (" + outlineType + ")";
    }
}

// Функция для получения имени типа заливки (для отладки)
function getFillTypeName(fillType) {
    switch(fillType) {
        case cdrNoFill: return "NoFill";
        case cdrUniformFill: return "UniformFill";
        case cdrFountainFill: return "FountainFill";
        case cdrPatternFill: return "PatternFill";
        case cdrTextureFill: return "TextureFill";
        case cdrPostScriptFill: return "PostScriptFill";
        case cdrTwoColorPatternFill: return "TwoColorPatternFill";
        case cdrBitmapFill: return "BitmapFill";
        case cdrFullColorPatternFill: return "FullColorPatternFill";
        case cdrMeshFill: return "MeshFill";
        default: return "Unknown (" + fillType + ")";
    }
} 