/******* Woodman Docker for CorelDraw Copyright (c) by DukereD 2023 mailto: laserman@tut.by *******/

/*Corel functions*/
/*
function RegisterEvent(){
    // tell coreldraw to call OnSelectionChange when the selection changes
	window.external.RegisterEventListener( "SelectionChange", "OnSelectionChange()" );
}
function UnregisterEvent(){
    // if you want to stop listening for the selection change event, call this function
    window.external.UnregisterEventListener( "SelectionChange" );
}
*/


function select_colors(){
    if(glFullDbg) dbg("select_colors");
    var sr = do_select_colors();
    setGlobalSelection(sr);
    do_cure();
}

function do_select_colors(selall, reverse, ingroup, grmode){
    if(selall === undefined) selall = true;
    if(reverse === undefined) reverse = false;
    var shft = Shift();
    if(ingroup === undefined) ingroup = (isShift(shft)) ? true : false;
    if(grmode === undefined) grmode = [];

	var srr;
	var arro = [];
	var arrf = [];
	var arff = [];
	var arrh = [];
	var arre = [];
	var arrt = [];
    if (document.getElementById("ch_selcol_group")!==null) {
        var byGroups = (getVal(ch_selcol_group) || getVal(ch_selcol_move)) ? true : false;
    } else {
        var byGroups = false;
    }
    var selMove = (document.getElementById("ch_selcol_move")!==null) ? getVal(ch_selcol_move) : false;
	
    cfnd=false;

    if (shft==16) ingroup = true;

	var srr = get_OS(false, selall, reverse, ingroup, grmode);

	if(byGroups) do_begin("group colors",true,glOptim);

	var elems = document.getElementsByTagName('*');
    var ci=0;
    var cfnd = false;
    var glcfnd = false;

    if (selMove) var sgap = calcGap(srr.SizeWidth);
	for (var i = 0; i < elems.length; i++){
		var elem = elems[i];
		if(elem.name=="outl_sel") {arro.push(elem.src); cfnd=true; select_color(elem); grAr = [arro, false, false, false, false, false]}
		if(elem.name=="fill_sel") {arrf.push(elem.src); cfnd=true; select_color(elem); grAr = [false, arrf, false, false, false, false]}
		if(elem.name=="ffill_sel") {arff.push(elem.src); cfnd=true; select_color(elem); grAr = [false, false, arff, false, false, false]}
		if(elem.name=="other_sel") {arrh.push(elem.src); cfnd=true; select_color(elem); grAr = [false, false, false, arrh, false, false]}
		if(elem.name=="effects_sel") {arre.push(elem.src); cfnd=true; select_color(elem); grAr = [false, false, false, false, arre, false]}
		if(elem.name=="texts_sel") {arrt.push(elem.src); cfnd=true; select_color(elem); grAr = [false, false, false, false, false, arrt]}
        if (cfnd){
            glcfnd = true;
            if(shft==11){
                //alert(elem.title);
            }
        }
		if(byGroups && cfnd){
			var sr = do_each("select_colors",grAr,srr,undefined, false);
            if (sr.Shapes.Count>0){
                if (getVal(ch_selcol_move)) sr.Move(sgap*ci++, 0);
                if (getVal(ch_selcol_group)) sr.Group();
            }
			arro = [];
			arrf = [];
			arff = [];
			arrh = [];
			arre = [];
			arrt = [];
		}
        cfnd = false;
	}

	if(byGroups) do_end(true);
	if (glcfnd){
		host.ActiveDocument.ClearSelection();
        var oss = srr;
        var cArr = [arro,arrf,arff,arrh,arre,arrt];
    var seconds = new Date().getTime()/1000;
		var srr = do_each((isCtrl(shft)) ? "select_no_colors" : "select_colors", cArr, srr, undefined, false );
    var cnt = " ";
    var seconds2 = new Date().getTime()/1000;
    //warn("Time : " +  getRound(seconds2 - seconds,3) + "s" + cnt, false);
		if(shft==5 || shft==7){
            srr= SRclear(srr, ['ingroup'], true);
            if (srr.Shapes.Count>0){
                do_begin("ungroup object",true,glOptim);
                srr.Cut();
                host.ActiveLayer.Paste();
                srr = host.ActiveSelectionRange;
                getInGroup(oss);
                do_end(true);
            }
		}
	}
	return srr;
}

function SRclear(os, types, add){
	if(os === undefined) os = get_OS(false, false, false, false);
	if(types === undefined) types = [5, 7];
	if(add === undefined) add = false;
    var sr = host.ActiveSelectionRange;
    sr.RemoveAll();
    for (var i=1;i<=os.Shapes.Count;i++){
        s = os.Shapes(i);
        if (inArray(s.Type, types)==add)sr.Add(s);
        for (var ig=0;ig<types.length;ig++){
            switch (types[ig]){
                case "ingroup": if ((s.ParentGroup!=null)==add) sr.Add(s); break;
            }
        }
    }
    return sr;
}


// ✅ make_contur функция перенесена в cat_contur.js


function make_rotate(ang, OS, undogroup){
	if(undogroup === undefined) undogroup = true;
	if(OS === undefined) OS = get_OS();
    if (ang=="center"){
        make_each("rotate_center",'',OS,undefined,undefined,undogroup);
    }else{
        if(getVal(ch_rotate_break) && ang>=0){
            make_each("change_start_node",[vall(ang), !isCtrl(Shift())], OS, undefined, true,undogroup);
        }else{
            make_each("rotate",ang,OS,undefined,undefined,undogroup);
        }
    }
    do_save(val_rotate);
    do_cure();
}

function each_find_wide(s, accuracy, num_templ, nodel){
    if (accuracy===undefined) accuracy = 0;
    if (nodel===undefined) nodel = true;
    var svirt = host.ActiveVirtualLayer.CreateLineSegment(0, 0, 1, 1);
    svirt.curve.CopyAssign(s.DisplayCurve);

    if (accuracy > 0) {
        for (var i = svirt.curve.Segments.Count; i >= 1; i--) {
            if (accuracy > 1) svirt.curve.Segments(i).AddNodeAt(0.66);
            svirt.curve.Segments(i).AddNodeAt();
        }
    }

    var maxDist = 0;
    var centerX = 0;
    var centerY = 0;
    var maxcenterX = svirt.LeftX;
    var maxcenterY = svirt.TopY;

    var nodes = svirt.curve.nodes;

    for (var i = 1; i <= nodes.Count; i++) {
        for (var j = i + 1; j <= nodes.Count; j++) {
            // Рассчитываем расстояние между точками (i, j)
            var x0 = nodes(i).PositionX;
            var y0 = nodes(i).PositionY;
            var x1 = nodes(j).PositionX;
            var y1 = nodes(j).PositionY;

            // var dist = Math.pow((x1 - x0), 2) + Math.pow((y1 - y0), 2);

            // Обновляем максимальное расстояние и координаты центра, если необходимо
            var lin = host.ActiveVirtualLayer.CreateLineSegment(x0, y0, x1, y1);
            var spcnt = 0;
            for (var spi=1;spi<=svirt.curve.SubPaths.Count;spi++) {
                spcnt += lin.curve.SubPaths(1).GetIntersections(svirt.curve.SubPaths(spi)).Count;
            }

            if (spcnt === 4) {
                centerX = (x0 +x1) / 2;
                centerY = (y0 + y1) / 2;
                if (s.IsOnShape(centerX, centerY, -1)) {
                    var off=0;
                    var pt = vbFindClosestSegmentXY(svirt, centerX, centerY);
                    var dist = Math.pow((vall(pt[0],false) - centerX), 2) + Math.pow((vall(pt[1],false) - centerY), 2);
                    if (dist > maxDist) {
                        maxDist = dist;
                        maxcenterX = centerX;
                        maxcenterY = centerY;
                    }
                }
            }
            lin.Delete();
        }
    }

    svirt.Delete();
    if(maxDist>0){
        if (nodel){
            var crcle = host.ActiveLayer.CreateEllipse2(maxcenterX, maxcenterY, Math.sqrt(maxDist));
            crcle.Outline.CopyAssign(s.Outline);
            crcle.Fill.CopyAssign(s.Fill);
        }
        if (num_templ!==undefined){
            var crcle = host.ActiveLayer.CreateArtisticText(0,0,num_templ,undefined,undefined,undefined,undefined,undefined,undefined,undefined,3);
            moveC(crcle,maxcenterX,maxcenterY);
            crcle.Outline.CopyAssign(s.Outline);
            crcle.Fill.CopyAssign(s.Fill);
        }
        return crcle;
    }else{
        return s;
    }
}


function setFill(S, color){
    setColor(S, color, "fill");
}

function setColor(S, color, mode){
    if(mode === undefined) mode = "outline";
    color = getColor(color);
    if(color){
        if (S.type!==undefined){
            if(mode=="outline" || mode=="both") S.Outline.Color = color;
            if(mode=="fill" || mode=="both") S.Fill.Color = color;
        }else if(S.Shapes.Count>0){
            var fir = S.Shapes(1);
            if(mode=="outline" || mode=="both"){
                fir.Outline.Color.CopyAssign(color);
                S.ApplyOutline (fir.Outline);
            }   
            if(mode=="fill" || mode=="both"){
                fir.Fill.UniformColor.CopyAssign(color);
                S.ApplyFill (fir.Fill);
            }
        }
    }
}


function getColor(color) {
    if ( typeof color == "object") return color;
    var arr = color;
    if (arr === undefined) arr = [100, 100, 100];
    if (typeof arr == "string"){
        arr = document.getElementById(color);
        if (!arr) arr = document.getElementById("color" + color);
    }
    arr = (arr) ? hextorgb(arr.value) : [100, 100, 100];

    if (arr.length == 3) return host.CreateRGBColor(arr[0], arr[1], arr[2]);
    if (arr.length == 4) return host.CreateCMYKColor(arr[0], arr[1], arr[2], arr[3]);
    return host.CreateRGBColor(100, 100, 100);
}


function pazy(sx, sy, stx, sty, qty_or_len, ph, clo, sgap, lgap, rgap, bylen, colr) {
    if (clo === undefined) clo = true;
    if (qty_or_len === undefined) { qty_or_len = 3; bylen = false; }
    if (bylen === undefined) bylen = false;
    if (colr === undefined) colr = false;
    if (sgap === undefined) sgap = 0;
    if (lgap === undefined) lgap = 0;
    if (rgap === undefined) rgap = 0;
    
    var first_lgap = 0;
    var first_rgap = 0;
    
    // Обработка массивов для lgap и rgap
    if(lgap instanceof Array){
        first_lgap = lgap[1];
        lgap = lgap[0];
    }
    if(rgap instanceof Array){
        first_rgap = rgap[1];
        rgap = rgap[0];
    }
    
    // Расчет базовой длины и угла
    var dx = stx - sx;
    var dy = sty - sy;
    var baseLen = Math.sqrt(dx*dx + dy*dy);
    var angleRad = Math.atan2(dy, dx);
    var angle = angleRad * 180 / Math.PI; // угол в градусах для CorelDRAW
    
    // Расчет координат с учетом удлинений концов
    var startX = sx;
    var startY = sy;
    var endX = stx;
    var endY = sty;
    
    if (lgap != 0) {
        startX = sx - lgap * Math.cos(angleRad);
        startY = sy - lgap * Math.sin(angleRad);
    }
    if (rgap != 0) {
        endX = stx + rgap * Math.cos(angleRad);
        endY = sty + rgap * Math.sin(angleRad);
    }
    
    // Итоговая длина с учетом удлинений
    var le = Math.sqrt((endX - startX)*(endX - startX) + (endY - startY)*(endY - startY));
    
    var qty = bylen ? getRound(le / qty_or_len, 0) : qty_or_len;

    if (qty % 2 === 0) qty--;
    if (qty < 3) qty = 3;

    var pl = le / qty;
    var sr = get_EOS();

    for (var i = 1; i <= qty; i++) {
        var even = (i % 2 === 0);
        var draw = (clo && even) || (!clo && !even);

        if (draw) {
            // Расчет позиции точки на линии
            var t = (pl * i) / le;
            var x = startX + t * (endX - startX);
            var y = startY + t * (endY - startY);

            // Смещение перпендикулярно линии (sgap)
            if (sgap != 0) {
                x += sgap * Math.cos(angleRad - Math.PI/2);
                y += sgap * Math.sin(angleRad - Math.PI/2);
            }

            // Расчет координат прямоугольника с учетом first_lgap и first_rgap
            var rectLeft = x - pl + (i == 1 ? first_lgap : 0);
            var rectRight = x - (i == qty ? first_rgap : 0);
            var rectTop = y + ph;
            var rectBottom = y;
            
            var rect = host.ActiveLayer.CreateRectangle(rectLeft, rectTop, rectRight, rectBottom);
            rect.SetRotationCenter(x, y);
            rect.Rotate(angle);
            rect.SetRotationCenter(rect.centerX, rect.centerY);
            sr.Add(rect);
        }
    }
    
    if (colr instanceof Array) var colr = getColor(colr);
    if (colr) sr.ApplyUniformFill(colr);
    
    return sr;
}

function getEndXY(X, Y, L, ANG) {
    var angleRad = ANG * (Math.PI / 180);
    return [X + L * Math.cos(angleRad), Y + L * Math.sin(angleRad)];
}

function addLenSeg(subpath, len, start, end){
    if(start === undefined) start = true;
	if(end === undefined) end = true;
    var scurv = false;
    var ecurv = false;

    if (start){
        var segment = subpath.segments.first;
        var arrXY = getEndXY(segment.StartNode.PositionX, segment.StartNode.PositionY,len,segment.StartingControlPointAngle+180);
        if (!segment.SubPath.Closed){
            if (segment.type==0){
                segment.StartNode.PositionX = arrXY[0];
                segment.StartNode.PositionY = arrXY[1];
            }else{
                segment.SubPath.AppendLineSegment(arrXY[0],arrXY[1],true);
            }
        }else{
            scurv = segment.SubPath.GetCopy();
            scurv = host.ActiveLayer.CreateCurve(scurv);
            if (len<scurv.curve.length){
                scurv.curve.Nodes.First.BreakApart();
                scurv.curve.SubPaths.First.BreakApartAt (1-len/scurv.curve.length);
                var sss = scurv.BreakApartEx();
                sss.FirstShape.Delete();
                scurv = sss.LastShape;
            }
        }
    }
    if (end){
        var segment = subpath.segments.last;
        var arrXY = getEndXY(segment.EndNode.PositionX, segment.EndNode.PositionY,len,segment.EndingControlPointAngle+180);
        if (!segment.SubPath.Closed){
            if (segment.type==0){
                segment.EndNode.PositionX = arrXY[0];
                segment.EndNode.PositionY = arrXY[1];
            }else{
                segment.SubPath.AppendLineSegment(arrXY[0],arrXY[1],false);
            }
        }else{
            ecurv = segment.SubPath.GetCopy();
            ecurv = host.ActiveLayer.CreateCurve(ecurv);
            if (len<ecurv.curve.length){
                ecurv.curve.Nodes.First.BreakApart();
                ecurv.curve.SubPaths.First.BreakApartAt (len/ecurv.curve.length);
                var sss = ecurv.BreakApartEx();
                sss.LastShape.Delete();
                ecurv = sss.FirstShape;
            }
        }
    }

    if (scurv || ecurv){
        subpath.StartNode.BreakApart();
        if (scurv){
            for (var i=scurv.curve.segments.Count;i>0;i--){
                var sig = scurv.curve.segments(i);
                if (sig.type==0)
                    subpath.AppendLineSegment(sig.StartNode.PositionX,sig.StartNode.PositionY, true);
                else
                    subpath.AppendCurveSegment2(sig.StartNode.PositionX,sig.StartNode.PositionY, sig.EndingControlPointX, sig.EndingControlPointY, sig.StartingControlPointX, sig.StartingControlPointY, true);
            }
            scurv.Delete();
        }
        if (ecurv){
            for (var i=1;i<=ecurv.curve.segments.Count;i++){
                var sig = ecurv.curve.segments(i);
                if (sig.type==0)
                    subpath.AppendLineSegment(sig.EndNode.PositionX,sig.EndNode.PositionY);
                else
                    subpath.AppendCurveSegment2(sig.EndNode.PositionX,sig.EndNode.PositionY, sig.StartingControlPointX, sig.StartingControlPointY, sig.EndingControlPointX, sig.EndingControlPointY);
            }
            ecurv.Delete();
        }
    }

    return true;
}


function do_points(s, type, mode, args, undogroup){
    if(s === undefined) s = host.ActiveShape;
    if(type === undefined) type = "center";
    if(mode === undefined) mode = (Shift()==2) ? "noadd" : "add";
    if(args === undefined) args = [];
    if(undogroup === undefined) undogroup = true;
//alert(undogroup);
    do_begin(type, undogroup, glOptim);
    if (s.Type==3){
        var spstart = 1;
        var spend = s.Curve.SubPaths.Count;
        for (var i=1; i<=s.Curve.Nodes.Count; i++){
            if (s.Curve.Nodes(i).Selected){
                spstart = s.Curve.Nodes(i).subPath.Index;
                spend = s.Curve.Nodes(i).subPath.Index;
                mode = (type=="corners_off") ? "add" : "noadd";
                break;
            }
        }

        for (var spi=spstart; spi <=spend; spi++){
            var sp = s.Curve.SubPaths(spi);
            var ndarr = getSelNodes(sp, mode);
            var nlen = ndarr.length;
            //alert(type + "="+spi+ ":"+mode + "=" + nlen);
            if (nlen>2){
                switch (type){
                    case "corners_off": var retar = removeRounds(ndarr); break;
                    case "size": var retar = resizePoints(ndarr,args[0], args[1]); break;
                    case "center": var retar = centerPoints(ndarr); break;
                    case "change_thikness": var retar = change_thikness(ndarr, args[0], args[1], args[2]);break;
                }
                //alert(ndarr.length +"-"+retar.length);
                for (var i=1;i<retar.length;i++){
                    //warn(ndarr[i][2]);
                    if (ndarr[i][0] != retar[i][0]) sp.Nodes(ndarr[i][2]).PositionX = retar[i][0];
                    if (ndarr[i][1] != retar[i][1]) sp.Nodes(ndarr[i][2]).PositionY = retar[i][1];
                }
            }
        }
    }
    do_end(undogroup);
    return nlen;
}


function getSelNodes(sp, mode){
    if(sp === undefined) sp = host.ActiveShape.Curve.SubPaths(1);
    if(mode === undefined) mode = "noadd";

    var fstInd = -1;
    var ndarr = [];
    var selcnt = 0;
    if (sp.Nodes(1).Selected && mode!="all"){
        for(var i = sp.Nodes.Count;i>1;i--){
            if (!sp.Nodes(i).Selected){
                fstInd = (i==sp.Nodes.Count) ? 1 : i+1;
                break;
            }
            if (fstInd<0) fstInd = 1;
        }
    }else{
        for(var i=1;i<=sp.Nodes.Count;i++){
            if (mode=="all"){
                ndarr[i] = [];
                var nd = sp.Nodes(i);
                ndarr[i][0] = nd.PositionX;
                ndarr[i][1] = nd.PositionY;
                ndarr[i][2] = i;
                ndarr[i][3] = nd.PositionX;
                ndarr[i][4] = nd.PositionY;
            }
            if (sp.Nodes(i).Selected){
                selcnt++;
                if (selcnt==1) fstInd = i;
                if (mode!="all") break;
            }
        }
    }
//    alert(selcnt);
    if (fstInd>0 && mode!="all" || selcnt>3){

        var ndarr = [];
        var curInd = fstInd;
        var ndsel= (mode=="add") ? 2 : 1;
        do{
            var nd = sp.Nodes(curInd);
            if (nd.Selected){
                ndarr[ndsel] = [];
                ndarr[ndsel][0] = nd.PositionX;
                ndarr[ndsel][1] = nd.PositionY;
                ndarr[ndsel][2] = curInd;
                ndsel++;
            }
            curInd++;
            if (curInd > sp.Nodes.Count) curInd = 1; // Переходим к началу кривой
        } while (curInd !== fstInd)

        if (mode=="add"){
            var ind = (ndarr[2][2]==1) ? sp.Nodes.Count : ndarr[2][2]-1;
            var nd = sp.Nodes(ind);
            ndarr[1] = [];
            ndarr[1][0] = nd.PositionX;
            ndarr[1][1] = nd.PositionY;
            ndarr[1][2] = nd.Index;

            var ind = (ndarr[ndsel-1][2]>=sp.Nodes.Count) ? 1 : ndarr[ndsel-1][2]+1;
            var nd = sp.Nodes(ind);
            ndarr[ndsel] = [];
            ndarr[ndsel][0] = nd.PositionX;
            ndarr[ndsel][1] = nd.PositionY;
            ndarr[ndsel][2] = nd.Index;
            ndsel++;
        }
    }
    return ndarr;
}


function replace_by_arr(txt, farr){
    var ret = txt;
    for (var nam in farr){
        if (ret.indexOf(nam+"[")>=0){
            for (var k in farr[nam]) ret = ret.replace(nam+"["+k+"]",farr[nam][k]);
        }else{
            ret = replaceAll(ret,nam,farr[nam], true);
        }
    }
    return ret;
}


function do_cure_shape(s){
    s.ConvertToCurves();
    s.Curve.AutoReduceNodes(2);
    var maxsp = 0;
    for(var i=1;i<=s.Curve.SubPaths.Count;i++){
        var sp = s.Curve.SubPaths(i);
        if (maxsp < sp.Area){
            var sp_max = sp.IsClockwise;
            maxsp = sp.Area;
        }
    }
    for(var i=1;i<=s.Curve.SubPaths.Count;i++){
        var sp = s.Curve.SubPaths(i);
        var icnt = 0;
        for(var ii=1;ii<=s.Curve.SubPaths.Count;ii++){
            var spp = s.Curve.SubPaths(ii);
            var px = sp.FirstSegment.StartNode.PositionX;
            var py = sp.FirstSegment.StartNode.PositionY;
            if (spp.IsPointInside(px, py)) icnt++;
        }
        if (icnt % 2 > 0 && sp.IsClockwise == sp_max)
            sp.ReverseDirection();
        else if (icnt % 2 == 0 && sp.IsClockwise != sp_max)
            sp.ReverseDirection();
    }
    return s;
}

function do_application(mode){
    if(mode === undefined) mode = 'only';
    var shft = Shift();
    var OS = get_OS(true, false,false,false);
    var arr = getArrOS(OS, ["size"]);
    //dbg(arr.length + ":" + OS.Shapes.Count);
    if(arr.length>2){
        var seconds = new Date().getTime()/1000;
        do_begin("make application",true, glOptim);
        for(var i=1;i<arr.length-1;i++){
            var s = arr[i];
            for(var j=i+1;j<arr.length;j++){
                var ss = arr[j];
                if(i!=j){
                    if (arrInBound(ss,s,0.1)){
                        //dbg("cnt " + arr[i]['id'] +":" + j + " - " + OS.Shapes.Count + " = ");
                        var sss = OS.Shapes(j).Trim(OS.Shapes(arr[i]['id']));
                        if (sss){
                            OS.Add(sss);
                            arr[i]['id'] = OS.Shapes.Count;
                            //dbg( OS.Shapes.Count, false);
                        }
                    }
                }
            }
            if (mode=="cure") do_cure_shape(OS.Shapes(arr[i]['id']));
        }
    do_end(true);
    var seconds2 = new Date().getTime()/1000;
    //warn("Time : " +  getRound(seconds2 - seconds,4) + "s");
    }
    do_cure();
}


function sort_align(OS, first, second, reverse, tolerance, snake, sorting){
    if (first === undefined) first = "centerx";
    if (second === undefined) second = "centery";
    if (reverse === undefined) reverse = false;
    if (tolerance === undefined) tolerance = OS.FirstShape.SizeHeight*0.8;
    if (snake === undefined) snake = false;
    if (sorting === undefined) sorting = true;

    var gcnt = OS.Shapes.Count;

    var firstCoord = (first == "centerx") ? "centerx" : "centery";
    var secondCoord = (second == "centerx") ? "centerx" : "centery";

    OS.Sort("@shape1."+firstCoord+".value() > @shape2."+firstCoord+".value()");
    var shapes = [];
    var lines = [];
    for (var i = 1; i <= gcnt; i++) {
        var s = OS.Shapes(i);
        shapes.push({
            x: s.CenterX,
            y: s.CenterY,
            index: i
        });
    }
    shapes.sort(function(a, b) {
        var diffFirst = (firstCoord == "centerx") ? a.x - b.x : b.y - a.y;
        if (Math.abs(diffFirst) < tolerance) {
            // Если в одной строке/колонке — сортируем по второму признаку
            return (secondCoord == "centerx") ? a.x - b.x : b.y - a.y;
        }
        return diffFirst;
    });
    if (reverse) shapes.reverse();

    if (snake) {
        var line = [], last = (firstCoord == "centery") ? shapes[0].y : shapes[0].x;

        for (var i = 0; i < shapes.length; i++) {
            var s = shapes[i], coord = (firstCoord == "centery") ? s.y : s.x;
            if (!line.length || Math.abs(coord - last) < tolerance) {
                line.push(s);
            } else {
                lines.push(line);
                line = [s];
                last = coord;
            }
        }
        if (line.length) lines.push(line);

        shapes = [];
        for (var j = 0; j < lines.length; j++) {
            if(sorting) lines[j].sort(function(a, b) { return (secondCoord == "centerx" ? a.x - b.x : b.y - a.y);});
            if (snake!==1) if (j % 2) lines[j].reverse();
            shapes = shapes.concat(lines[j]);
        }
    }
    return [shapes, lines];
}

function make_autogroup(type){
    var sr = do_autogroup(type, undefined, undefined, undefined, Shift());
    do_save(val_groupgap);
    setGlobalSelection(sr);
    do_cure();
}

function do_autogroup(group,OS,undogroup,param, shft){
    if (shft === undefined) shft = 0;
	if(group != undefined && host.ActiveDocument!=null){
        var seconds = new Date().getTime()/1000;
		if(undogroup === undefined) undogroup = true;
		do_events(group);
        do_begin(group,undogroup, glOptim);
        var sr_all = get_EOS();
        if(OS === undefined) OS = get_OS(true, false,false,false);
        var gcnt = OS.Shapes.Count;
        if(gcnt<1 && !getVal(radio_sett_doc)) return OS;
        if (inArray(group, ["grp_sort", "grp_align"]) && !getVal(radio_sett_doc)) {
            var qry = "";

            if (shft == 10 || shft == 11) {
                qry = "@shape1.width " + ((shft == 10) ? "<" : ">") + " @shape2.width";
            } else if (shft == 12 || shft == 13) {
                qry = "@shape1.height " + ((shft == 12) ? "<" : ">") + " @shape2.height";
            } else if (shft == 14 || shft == 15) {
                qry = "@shape1.width*@shape1.height " + ((shft == 14) ? "<" : ">") + " @shape2.width*@shape2.height";
            }

            if (qry != "") OS.Sort(qry);

            if (shft<10){
                if (group=="grp_sort"){
                    var firstCoord = (isAlt(shft)) ? "centerx" : "centery";
                    var secondCoord = (isAlt(shft)) ? "centery" : "centerx";
                    var reverse = (isCtrl(shft)) ? true : false;
                    var tolerance = (firstCoord == "centery") ? OS.FirstShape.SizeHeight*0.8 : OS.FirstShape.SizeWidth*0.8;

                    var retrn = sort_align(OS, firstCoord, secondCoord, reverse, tolerance, isShift(shft));
                    var shapes = retrn[0];
                    for (var j = shapes.length-1; j>0; j--) {
                        OS.Shapes(shapes[j].index).OrderFrontOf(OS.Shapes(shapes[0].index));
                    }
                }else if (group=="grp_align"){
                    var tolerance = (firstCoord == "centery") ? OS.FirstShape.SizeHeight*0.8 : OS.FirstShape.SizeWidth*0.8;

                    var align_mode = (isShift(shft)) ? 0 : 1;
                    var swtch = (isAlt(shft)) ? true : false;

                    var endi = (shft<2) ? 3 : 1;
                    for (var i = 0; i < endi; i++) {
                        var firstCoord = (swtch) ? "centerx" : "centery";
                        var secondCoord = (swtch) ? "centery" : "centerx";

                        var retrn = sort_align(OS, firstCoord, secondCoord, false, tolerance, true, false);
                        var lines = retrn[1];
                        //dbg("fst:" + firstCoord + ":" +lines.length);
                        var firstAlign = get_EOS();
                        for (var j = 0; j < lines.length; j++) {
                            firstAlign.RemoveALl();
                            for (var k = 0; k < lines[j].length; k++) firstAlign.Add(OS.Shapes(lines[j][k].index));
                            //C = 3, DC = 6, DS= 7 //центр 3, распре по центру 6, распре по растоянию 7
                            var hAlign = (isCtrl(shft)) ? 0 : 6+align_mode;
                            var vAlign = 3-align_mode;
                            if (firstCoord == "centerx"){
                                hAlign = 3-align_mode;
                                vAlign = (isAlt(shft)) ? 0 : 6+align_mode;
                            }
//проверить!!! нужны ли эти выделения                            
                            firstAlign.CreateSelection();
                            vbAlign(hAlign, vAlign);
                        }
                        swtch = !swtch;
                    }
                    OS.CreateSelection();
                }
            }

        }else if(getVal(radio_sett_doc) && (group=="grp_byframe" || group=="grp_byform")){
            var cur_page = host.ActivePage.Index;
            for (var i=1;i<=host.ActiveDocument.Pages.Count;i++){
                host.ActiveDocument.Pages(i).Activate();
                var srg = host.ActiveDocument.Pages(i).SelectableShapes.All();
                if (srg.Shapes.Count>0) srg.Group();
            }
            host.ActiveDocument.Pages(cur_page).Activate();
		}else{
            var sr = get_EOS();
            var arr_all = [];

            var sgap = (param=="zero") ? 0.01 : vall(val_groupgap.value);
            grpsimpl = false;
            if (group =="grp_simpl"){group = "grp_byform"; grpsimpl = true;}

            if (group=="grp_addto"){
                if (shft==4){
                    OS = vbdoQuery(OS.Shapes,"@com.powerclip!=null", false);
                    for(var i=1;i<=OS.Shapes.Count;i++){
                        s = OS.Shapes(i);
                        var sr = host.ActivePage.SelectShapesFromRectangle(s.LeftX - sgap, s.BottomY - sgap, s.RightX + sgap, s.TopY + sgap, true).Shapes.All();
                        sr.RemoveRange(OS);
                        sr.AddToPowerClip(s);
                        sr_all.Add (s);
                    }
                }else if (shft==2){
                    for(var i=1;i<=OS.Shapes.Count;i++){
                        s = OS.Shapes(i);
                        ss = host.ActivePage.SelectShapesFromRectangle(s.LeftX - sgap, s.BottomY - sgap, s.RightX + sgap, s.TopY + sgap, true);
                        sr.RemoveAll();
                        sr.Add(ss);
                        if (ss.Shapes.Count>0){
                            sr.RemoveRange(OS);
                            sr.AddToPowerClip(s, 0);
                        }
                        sr_all.Add(s);
                    }
                }else{
                    OS = OS.Shapes.FindShapes("", 7, false);
                    for(var i=1;i<=OS.Shapes.Count;i++){
                        s = OS.Shapes(i);
                        sr.RemoveAll();
                        sr.AddRange(s.UngroupEx());
                        sr.Add(host.ActivePage.SelectShapesFromRectangle(sr.LeftX - sgap, sr.BottomY - sgap, sr.RightX + sgap, sr.TopY + sgap, true));
                        var gr = sr.Group();
                        if (gr.Shapes.Count > 0 ) sr_all.Add (gr);
                    }
                }
            }else{
                if (shft==1 || shft==3){
                    for(var i=1;i<=OS.Shapes.Count;i++){
                        s = OS.Shapes(i);
                        ss = host.ActivePage.SelectShapesFromRectangle(s.LeftX - sgap, s.BottomY - sgap, s.RightX + sgap, s.TopY + sgap, true);
                        sr.Add(ss);
                    }
                    if (sr.Shapes.Count > 0 ) OS.AddRange (sr);
                    gcnt = OS.Shapes.Count;
                }
                var arr = getArrOS(OS, ["size"]);
                for(var i=1;i<arr.length;i++){
                    var s = arr[i];
                    arr_all[i] = [];
                    arr_all[i][i] = i;
                    for(var j=1;j<arr.length;j++){
                        var ss = arr[j];
                        if(i!=j){
                            add = false;
                            arr_all[i][j] = 0;
                           if (arrInBound(ss,s,sgap)){
                                if(group == "grp_byform"){
                                    isec = OS.Shapes(i).Intersect(OS.Shapes(j));
                                    if (isec){
                                        add = true;
                                        isec.Delete();
                                    }
                                }else{
                                    add = true;
                                }
                            }
                            if (add) arr_all[i][j] = j;
                        }
                    }
                }

                for(var i=1;i<=gcnt;i++){
                    arr_all = collect_arr(arr_all, i, i);
                }
                for(var i=1;i<=gcnt;i++){
                    sr.RemoveAll();
                    inar =0;
                    for(var j=1;j<=gcnt;j++){
                        if (arr_all[i][j]>0){
                            sr.Add(OS.Shapes(j));
                            inar++;
                        }
                    }

                    if (inar > 1) {
                        if (shft == 4 && (group == "grp_weld" || group == "grp_byform" || group == "grp_byframe")){
                            sr.Combine();
                        }else{
                            if (group == "grp_byframe" || group == "grp_byform") {
                                if (shft<2)  sr_all.Add(sr.Group()); else sr_all.AddRange (sr);
                            } else {
                                if(isCtrl(shft)){
                                    sr = sr.ReverseRange;
                                }else if(!isAlt(shft)){
                                    sr.sort("@shape1.width*@shape1.height < @shape2.width*@shape2.height");
                                }

                                fs = sr.FirstShape;
                                ls = sr.LastShape;

                                for(var k=1;k<=sr.Shapes.Count;k++){
                                    s = sr.Shapes(k);
                                    if (s != ls && s != fs) {
                                        fs = s.Weld(fs, false, false);
                                    }
                                }
                                var rx = ls.RotationCenterX;
                                var ry = ls.RotationCenterY;
                                if (group == "grp_weld") {
                                    ls = fs.Weld(ls, false);
                                } else {
                                    ls = fs.Trim(ls, false);
                                }
                                ls.SetRotationCenter(rx,ry);
                                if (ls) sr_all.add(ls);
                            }
                        }
                    }else if (inar==1){
                        if (param=="zero") sr_all.AddRange(sr);
                        if (sr(1).type == 6) sr(1).Weld(sr(1));
                    }
                }
            }

            if (group =="grp_byform" && grpsimpl){
                var cnt = sr_all.Shapes.Count;
                for(var g=1;g<=cnt;g++){
                    gcnt = sr_all.Shapes(g).Shapes.Count;
                    if (gcnt>0){
                        for(var i=1;i<=gcnt;i++){
                            s = sr_all.Shapes(g).Shapes(i);
                            for(var j=i+1;i<=gcnt;i++){
                                ss = sr_all.Shapes(g).Shapes(j);
                            }
                        }
                    }
                }
            }
        }
        var seconds2 = new Date().getTime()/1000;
        //warn("Time : " +  getRound(seconds2 - seconds,4) + "s", false);
		do_end(undogroup);
		return sr_all;
	}else{
		return 	get_EOS();
	}
}
// system functions

// ✅ calc_fast функция перенесена в cat_calc.js (более современная версия)

function dos_contur(s, size, dir, cname, split, todel, round, reduce, cut, smart, nofill, uselayers, chfocus){
	if (dir=="in") dir = 0;
	if (dir=="out") dir = 1;
	if(split === undefined) split = true;
	if(todel === undefined) todel = true;
	if(round === undefined) round = true;
	if(reduce === undefined) reduce = false;
	if(cut === undefined) cut = false;
	if(smart === undefined) smart = false;
    if(nofill === undefined) nofill = false;
    if(uselayers === undefined) uselayers = false;
    if(chfocus === undefined) chfocus = false;
    var s_src = s;

    var sr = get_EOS();
    var isBitmap = false;
    if (s.Type == 5){
        isBitmap = true;
        var srt = s.Bitmap.Trace(5, 40, 92, 2, 0, 10, false, cut, true).Finish().UngroupAllEx();
        if (srt.Shapes.Count>0) var ss = vbCustomCommand(srt,"Boundary", "CreateBoundary");
        srt.Delete();
        if (ss){
            ss.Outline.color = host.CreateCMYKColor(0, 100, 0, 0);
            ss.name = s.name;
            s = ss;
        }else{
            return s;
        }
    }else if (smart){
		size = size / 2;
		dir = 1;
	}

    if (size==0){
        var olds = host.ActiveLayer.CreateCurve(s.DisplayCurve);
        if (!chfocus) s = olds;
    }else{
        if(round){
            s.CreateContour(dir, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 1, 2);
        }else{
            s.CreateContour(dir, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 2, 4, 15);
        }
        if(s.Effects.Count > 0 && split){
            var spr = s.Effects(1).Separate()(1);
            if (s.Type==3){
                sx = s.DisplayCurve.Nodes.First.PositionX;
                sy = s.DisplayCurve.Nodes.First.PositionY;
                vbFindClosestSegmentXY(spr, sx, sy, true, true);
            }
            if (smart && s.DisplayCurve.Closed){
                if(round){
                    s.CreateContour(0, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 1, 2);
                }else{
                    s.CreateContour(0, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 2, 4, 15);
                }
                if(s.Effects.Count > 0) spr = s.Effects(1).Separate()(1).Trim(spr, false);
            }
            if(reduce && spr.Type==3) spr.Curve.AutoReduceNodes(2);
            if(spr.Fill && nofill) spr.Fill.ApplyNoFill(); else spr.Fill.CopyAssign (s.Fill);
            if (cut && !isBitmap) spr = (dir==1) ? s.Trim(spr,true) : spr.Trim(s,false,true);
            if (s.name!="") spr.name = s.name;
            if(cname !== undefined && !uselayers){
                spr.Name = cname;
            }else if (cname !== undefined && uselayers){
                MoveToLayer(cname, spr);
            }

            if(s.PowerClip==null){
                if (todel) s.Delete(); else sr.Add (s);
                s = spr;
            }else{
                s.ConvertToCurves();
                if (!todel && !chfocus){
                    var olds = host.ActiveLayer.CreateCurve(s.DisplayCurve);
                    if (s.name!="") olds.name = s.name;
                    sr.Add (olds);
                }
                if (!chfocus || todel){
                    s.Curve.CopyAssign(spr.DisplayCurve);
                    spr.Delete();
                }
                if(cname !== undefined){
                    s.Name = cname;
                }
            }
        }
    }
    sr.Add (s);
    var shft = Shift();

    if (shft==10 || shft==11){
        var cOS = host.ActivePage.SelectShapesFromRectangle(s.leftx, s.bottomy, s.rightx, s.topy, true).Shapes.All().ReverseRange;
        cOS.RemoveRange(sr);
        var cos_cnt = cOS.Shapes.Count;
        for (var i=1;i<=cos_cnt;i++){
            s.Intersect(cOS.Shapes(i), true, false);
        }
        if (shft!=11){
            s.Delete();
            s = s_src;
        }
    }
	return s;
}

function dos_rotate(s, ang, param, rotate_rel){
	if(param === undefined) param = 0;
	if(rotate_rel === undefined) rotate_rel = true;
	shft = Shift();
	if (param=="long"){
		s.Rotate(-max_ang(s,true));
	}else if (param=="ang"){
		if(shft>0) s.Rotate(ang); else s.Rotate(-ang);
	}else{
		if(isCtrl(shft)) s = s.Duplicate();
		if(rotate_rel) s.Rotate(ang); else  s.RotationAngle = ang;
	}
	return s;
}

function dos_punktir(s,punkt_dash,punkt_gap,punkt_size,punkt_trim,punkt_del,punkt_join,punkt_line){
	if(punkt_gap === undefined) punkt_gap = 0;
	if(punkt_size === undefined) punkt_size = true;
	if(punkt_trim === undefined) punkt_trim = false;
	if(punkt_del === undefined) punkt_del = true;
	if(punkt_join === undefined) punkt_join = true;
	if(punkt_line === undefined) punkt_line = false;

	s.ConvertToCurves();
	var ss = s.BreakApartEx();
	var srp = host.ActiveSelectionRange;
	srp.RemoveAll();

	var cnt_sps = ss.Count;
	for(var i=1;i<=cnt_sps;i++){
		var ssp = ss(i);
		var sp = ssp.Curve.Subpaths(1);
		var sp_len = sp.length;
		if(punkt_trim && sp_len>punkt_gap*2){
            sp = sub_trim(sp,punkt_gap);
		    sp_len = sp.length;
		}
        var dashs = getRound((punkt_size) ? (sp_len - punkt_dash) / (punkt_dash + punkt_gap) : punkt_dash,0);
		if(dashs>0 && punkt_dash>0 && sp_len>punkt_gap*(dashs+1)){
			sp.EqualDivide (dashs, punkt_gap);
			var todel = [];
			var bynode = false;
			if(punkt_del){
				for(var n=1;n<=ssp.Curve.Nodes.Count;n++){
					if (!ssp.Curve.Nodes(n).IsEnding){
						todel.push(n);
						bynode = true;
					}
				}
				if (bynode){
					var nr = ssp.Curve.Nodes.Range(1);
					nr.RemoveAll();
					for (var key in todel){
						nr.AddRange(ssp.Curve.Nodes.Range(todel[key]));
					}
					nr.Delete(); 
				}
				
			}
			
			if(punkt_line){
				for(var n=1;n<=ssp.Curve.Segments.Count;n++){
					seg = ssp.Curve.Segments(n);
					if(seg.Type > 0) seg.Type = 0;
				}
			}
		}
		srp.Add(ssp);
	}
	if (srp.Shapes.Count>1) s = srp.Combine();
	if(punkt_join) s.CustomCommand ("ConvertTo", "JoinCurves", punkt_gap + 0.1);	
	return s;
}


function make_cmnborder(){
    var sr = do_cmnborder();
    setGlobalSelection(sr);
    do_cure();
}

function weldOS(OS){
    var wld = OS.Shapes(1);
    for(var i=2;i<=OS.Shapes.Count;i++){
        wld = OS.Shapes(i).weld(wld, false, false);
    }
    //OS.Delete();
    return wld;
}


function do_cmnborder(mode, OS, shft, undogroup){
    if(!defdoc()) return false;
	if(mode === undefined) mode = 'weld';
	if(OS === undefined) OS = get_OS();
	if(shft === undefined) shft = Shift();
	if(undogroup === undefined) undogroup = true;

	var cnt_os = OS.Shapes.Count;
	var sr = get_EOS();
	if(cnt_os>0){
		do_begin("make common border",undogroup, glOptim);
		var ln = OS.FirstShape;
        ln.ConvertToCurves();
		//OS.Sort("@shape1.width*@shape1.height > @shape2.width*@shape2.height");
		//OS.Remove(1);
        var srtmp = get_EOS();
		for(var i=2;i<=cnt_os;i++){
            //sr.Add(ln);
			var wr = OS.Shapes(i);
            wr.ConvertToCurves();

            if(wr.Curve.closed && shft!==2) wr = dos_contur(wr, 0.005, 1, undefined, true, true, false, false, false, false);
            var fp = wr.Duplicate();
            if (fp.Shapes.Count==0){
                for (p=1;p<=fp.Curve.Subpaths.Count;p++){
                    var sp = fp.Curve.Subpaths(p);
                    if (sp.Closed && sp.Nodes.Count>1) sp.Nodes(1).BreakApart();
                }
                var isec = fp.Intersect(ln, true, true);
                fp.Delete();
                if (isec!=null){
                    srtmp.Add(isec);
                    isec.Outline.Color = host.CreateRGBColor(50, 50, 250);
                }
                ln = ln.Weld(wr);
            }
		}
        if(srtmp.Shapes.Count>0){
            srtmp.OrderFrontOf(ln);
            var S = srtmp.Combine();
            S.Curve.JoinTouchingSubpaths (1,0.1);
            sr.Add(S);
            sr.Add(ln);
        }
		do_end(undogroup);
	}
	return sr;
}


function ShapesUnlock(OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();	
	do_begin("unlock all", undogroup, glOptim);
	for(var i=1;i<=OS.Shapes.Count;i++){
		OS.Shapes(i).locked = false;
	}
	do_end(undogroup);
	return OS;
}



function clear_template(mode, OS, shft, undogroup){
    if(!defdoc()) return false;
	if(mode === undefined) mode = getVal(ch_razryv_nedorez);
	if(OS === undefined) OS = get_OS();
	if(shft === undefined) shft = Shift();	
	if(undogroup === undefined) undogroup = true;
		
	var cnt_os = OS.Shapes.Count;
	var sr = get_EOS();
	do_save(val_nest_qty);
	if(cnt_os>0){
		do_begin("make nest ",undogroup, glOptim);
		var cont = OS.FirstShape;
		//OS.Sort("@shape1.width*@shape1.height > @shape2.width*@shape2.height");
		OS.Remove(1);
        var cnt_os = OS.Shapes.Count;
		for(var i=1;i<=cnt_os;i++){
			var s = OS.Shapes(i);
		}
		do_end(undogroup);
	}
	return sr;
}

function run_test(){
    var seconds = new Date().getTime()/1000;

    var seconds2 = new Date().getTime()/1000;
    //warn("Time : " +  getRound(seconds2 - seconds,3) + "s", false);
}


function fitScale(W1, H1, W2, H2) {
    var scaleX = W1 / W2;
    var scaleY = H1 / H2;
    return Math.min(scaleX, scaleY);
  }

tmrs.push({name:"funcs end",time:new Date().getTime()});