// Глобальный объект для хранения всех SHAPE-объектов и счетчиков
var lastObject =  null

// Счетчики для генерации уникальных ID
var _idCounters = {};

// Конструктор SHAPE
function SHAPE(corelShape, type) {
this.name = function(val) {
  if (val === undefined) return this.shape.Name;

  this.shape.Name = val;

  var code = genNum(val);
  this.code =  (code) ? parseInt(code) : 0;

  return this;
};

this.syncName = function() {
  var val = this.shape.Name;
  var code = genNum(val);
  this.code = (code) ? parseInt(code) : 0;
  this.name(val);
  return this;
};

  this.shape = (corelShape instanceof SHAPE) ? corelShape.shape : corelShape;
  this.type = type;
  this.code = 0;
  this.id = generateId(type);
  this.syncName();

this.W = function(val) {
  if (val === undefined) return this.shape.SizeWidth;
  this.shape.SizeWidth = val;
  return this;
};

this.H = function(val) {
  if (val === undefined) return this.shape.SizeHeight;
  this.shape.SizeHeight = val;
  return this;
};

this.L = function(val) {
  if (val === undefined) return this.shape.LeftX;
  this.shape.LeftX = val;
  return this;
};

this.R = function(val) {
  if (val === undefined) return this.shape.RightX;
  this.shape.RightX = val;
  return this;
};

this.T = function(val) {
  if (val === undefined) return this.shape.Topy;
  this.shape.Topy = val;
  return this;
};

this.B = function(val) {
  if (val === undefined) return this.shape.Bottomy;
  this.shape.Bottomy = val;
  return this;
};

this.X = function(val) {
  if (val === undefined) {
    return (typeof ch_sett_center !== "undefined" && getVal(ch_sett_center))
      ? this.shape.CenterX
      : this.shape.RotationCenterX;
  }
  if (typeof ch_sett_center !== "undefined" && getVal(ch_sett_center)) {
    this.shape.CenterX = val;
  } else {
    var dx = val - this.shape.RotationCenterX;
    this.shape.Move(dx, 0);
  }
  return this;
};

this.Y = function(val) {
  if (val === undefined) {
    return (typeof ch_sett_center !== "undefined" && getVal(ch_sett_center))
      ? this.shape.CenterY
      : this.shape.RotationCenterY;
  }
  if (typeof ch_sett_center !== "undefined" && getVal(ch_sett_center)) {
    this.shape.CenterY = val;
  } else {
    var dy = val - this.shape.RotationCenterY;
    this.shape.Move(0, dy);
  }
  return this;
};



  this.setColor = function(arr) {
    if (arr instanceof Array) {
      if (arr.length === 3) {
        colr = host.CreateRGBColor(arr[0], arr[1], arr[2]);
      } else if (arr.length === 4) {
        colr = host.CreateCMYKColor(arr[0], arr[1], arr[2], arr[3]);
      }
    }else{
      colr = arr;
    }

    if (arr===false){
      if (this.shape.type===undefined){
        this.shape.ApplyNoOutline();
        this.shape.Shapes(1).ApplyNoOutline();
        this.shape.ApplyOutline(this.shape.Shapes(1).Outline);
      }else{
        this.shape.Outline.SetNoOutline();
      }
    }else{
      if (this.shape.type===undefined){
        this.shape.Shapes(1).Outline.color = colr;
        this.shape.ApplyOutline(this.shape.Shapes(1).Outline);
      }else{
        this.shape.Outline.Color = colr;
      }
    }
    return this;
  };

  this.setFill = function(arr) {
    if (arr instanceof Array) {
      if (arr.length === 3) {
        colr = host.CreateRGBColor(arr[0], arr[1], arr[2]);
      } else if (arr.length === 4) {
        colr = host.CreateCMYKColor(arr[0], arr[1], arr[2], arr[3]);
      }
    }else{
      colr = arr;
    }

    if (arr===false){
      if (this.shape.type===undefined){
        this.shape.ApplyNoFill();
      }else{
        this.shape.Fill.ApplyNoFill();
      }
    }else{
      if (this.shape.type===undefined){
        this.shape.ApplyUniformFill(colr);
      }else{
        this.shape.Fill.UniformColor = colr;
      }
    }
    return this;
  };

  this.setFont = function(font, size) {
    if (font === undefined) font = "Arial";
    if (size === undefined) size = 24;
    if(this.shape.type==cdrTextShape){
        this.shape.Text.Story.Font = font;
        this.shape.Text.Story.Size = size;
    }
    return this;
  };

  this.cut = function(shape, leavesrc, leavetarget) {
    if (leavetarget===undefined) leavetarget = false;
    if (leavesrc===undefined) leavesrc = false;
    if (!shape) shape = lastObject;
    var ret = shape.shape.Trim(this.shape, leavetarget, leavesrc);
    if (!leavesrc) this.shape = ret;
    return createShape(ret, "cut");
  } 

  this.weld = function(shape, leavesrc, leavetarget) {
    if (leavetarget===undefined) leavetarget = false;
    if (leavesrc===undefined) leavesrc = false;
    if (!shape) shape = lastObject;
    var ret = shape.shape.Weld(this.shape, leavetarget, leavesrc);
    if (!leavesrc) this.shape = ret;
    return createShape(ret, "weld");
  } 

  this.intersect = function(shape, leavesrc, leavetarget) {
    if (leavesrc===undefined) leavesrc = false;
    if (leavetarget===undefined) leavetarget = false;
    if (!shape) shape = lastObject;
    var ret = shape.shape.Intersect(this.shape, leavetarget, leavesrc);
    if (!leavesrc) this.shape = ret;
    return createShape(ret, "intersect");
  }

    this.removeHoles = function() {
      var w = this.shape.SizeWidth;
      var h = this.shape.SizeHeight;
      for (var i=1;i<=this.shape.Curve.SubPaths.Count;i++){
            var sp = this.shape.Curve.SubPaths(i);
            if (Math.abs(sp.SizeWidth-w)<0.01 && Math.abs(sp.SizeHeight-h)<0.01){
                continue;
            }
            sp.Delete();
            i--;
      }
      return this;
    };

    this.add = function(sr) {
      if (sr instanceof SHAPE) sr = sr.shape;
      sr.Add(this.shape);
      return this;
    };


  this.copyTo = function(X, Y) {
    var c = getShapeCenter(this.shape);
    if (X === undefined || X=== false) X = c.x; 
    if (Y === undefined || Y=== false) Y = c.y;
    return new SHAPE(this.shape.Duplicate(X - c.x, Y - c.y), this.type);
  };

    this.copy = function(X, Y) {
      if (X === undefined || X=== false) X = 0; 
      if (Y === undefined || Y=== false) Y = 0;
      return new SHAPE(this.shape.Duplicate(X, Y), this.type);
    };


    this.moveTo = function(X, Y) {
      var c = getShapeCenter(this.shape);
      if (X === undefined || X=== false) X = c.x; 
      if (Y === undefined || Y=== false) Y = c.y;
      this.shape.Move(X - c.x, Y - c.y);
      return this;
    };

    this.move = function(X, Y) {
      if (X === undefined || X=== false) X = 0; 
      if (Y === undefined || Y=== false) Y = 0;
      this.shape.Move(X, Y);
      return this;
    };

    this.resize = function(W, H, aspect) {
      var newW = this.shape.SizeWidth + (W || 0);
      var newH = this.shape.SizeHeight + (H || 0);
      return this.setSize(newW, newH, aspect);
    };

    this.setSize = function(W, H, aspect) {
      var width = this.shape.SizeWidth;
      var height = this.shape.SizeHeight;
    
      if (W === undefined) W = 0;
      if (H === undefined) H = 0;
    
      if (aspect) {
        var ratio = width / height;
        if (W === 0 && H !== 0) {
          W = H * ratio;
        } else if (H === 0 && W !== 0) {
          H = W / ratio;
        } else if (W !== 0 && H !== 0) {
          return this.fitScale(W, H);
        } else {
          return this;
        }
      }
    
      if (W > 0) this.shape.SizeWidth = W;
      if (H > 0) this.shape.SizeHeight = H;
    
      return this;
    };    


    this.scale = function(scale) {
      this.shape.SizeHeight = this.shape.SizeHeight * scale;
      this.shape.SizeWidth = this.shape.SizeWidth * scale;
      return this;
    };

    this.fitScale = function(W, H) {
      var scale = fitScale(W, H, this.shape.SizeWidth, this.shape.SizeHeight);
      this.scale(scale);
      return this;
    };

    this.repeat = function(dx, dy, hCnt, vCnt, glue) {
      if (hCnt === undefined) hCnt = 1;
      if (vCnt === undefined) vCnt = 1;
      vCnt --;
      hCnt --;
      var sr = get_EOS();
      if (vCnt === 0) {
        if (dx) sr.AddRange(this.shape.StepAndRepeat(hCnt, dx, 0, 1, 1, 0));
        sr.Add(this.shape);
      } else {
        if (dy) sr.AddRange(this.shape.StepAndRepeat(vCnt, 0, dy, 0, 0, 1, 2));
        sr.Add(this.shape);
        if (dx) sr.AddRange(sr.StepAndRepeat(hCnt, dx, 0, 1, 1, 0, 2));
      }
      if(glue) this.shape = sr.Combine();
      this.type = "repeat";
      return this;
    }

    this.flipX = function(x, mode) {
      var cx = getShapeCenter(this.shape).x;
      var fx = (typeof x === 'number') ? x : cx;

      function mirror(s) {
        s.Stretch(-1, 1);
        s.Move(2 * (fx - cx), 0);
      }

      if (mode === "copy") {
        var dup = new SHAPE(this.shape.Duplicate(), this.type);
        mirror(dup.shape);
        return dup;
      }

      if (mode === "join") {
        var dup = new SHAPE(this.shape.Duplicate(), this.type);
        mirror(dup.shape);
        return this.join(dup);
      }

      mirror(this.shape);
      return this;
    };

    this.flipY = function(y, mode) {
      var cy = getShapeCenter(this.shape).y;
      var fy = (typeof y === 'number') ? y : cy;

      function mirror(s) {
        s.Stretch(1, -1);
        s.Move(0, 2 * (fy - cy));
      }

      if (mode === "copy") {
        var dup = new SHAPE(this.shape.Duplicate(), this.type);
        mirror(dup.shape);
        return dup;
      }

      if (mode === "join") {
        var dup = new SHAPE(this.shape.Duplicate(), this.type);
        mirror(dup.shape);
        return this.join(dup);
      }

      mirror(this.shape);
      return this;
    };

    this.flip = function(line, mode) {
      if (!line || line.length !== 4) return this;

      var cx = getShapeCenter(this.shape).x;
      var cy = getShapeCenter(this.shape).y;

      var x1 = line[0], y1 = line[1], wi = line[2], hi = line[3];
      var dx = wi - x1, dy = hi - y1, lenSq = dx * dx + dy * dy;
      if (lenSq === 0) return this;

      var t = ((cx - x1) * dx + (cy - y1) * dy) / lenSq;
      var projX = x1 + t * dx, projY = y1 + t * dy;
      var angle = Math.atan2(dy, dx);

      function mirror(s) {
        s.Stretch(-1, 1);
        s.Move(2 * (projX - cx), 0);
        if (typeof s.Rotate === 'function') {
          s.Rotate(2 * angle * 180 / Math.PI, projX, projY);
        }
      }

      if (mode === "copy") {
        var dup = new SHAPE(this.shape.Duplicate(), this.type);
        mirror(dup.shape);
        return dup;
      }

      if (mode === "join") {
        var dup = new SHAPE(this.shape.Duplicate(), this.type);
        mirror(dup.shape);
        return this.join(dup);
      }

      mirror(this.shape);
      return this;
    };


    this.join = function(otherShape, reduce) {
      if (reduce === undefined) reduce = false;
      if (!this.shape) return this;
      if (otherShape && otherShape.shape) this.shape = otherShape.shape.Weld(this.shape, false, false);
      if (!this.shape.Curve.Closed) {
        this.shape.Curve.JoinTouchingSubpaths(1, 0.1);
        if (reduce) this.shape.Curve.AutoReduceNodes(0.1);
      }
      return this;
    };

    this.breakNodes = function(nodes, split2) {
      if (!this.shape) return this;
      var OS = vbBreakSNodes(this.shape, nodes, split2);
      this.shape = OS.FirstShape;
      var curves = [];
      for (var i = 1; i <= OS.Shapes.Count; i++) {
          curves.push(createShape(OS.Shapes.Item(i), "curve"));
      }
      return curves;
    };


    this.group = function(arr) {
      if (!(arr instanceof Array)) arr = [arr];
      var group = get_EOS();
      group.Add(this.shape);
      for (var i = 0; i < arr.length; i++) {
        group.Add(arr[i].shape);
      }
      this.shape = group.Group();
      this.type = "group";  
      this.shape.CreateSelection();
      return this;
    }

    this.del = function() {
      if (this.shape)  this.shape.Delete();
      this.shape = null;
    };

    this.rotate = function(angle, centerX, centerY, copies, join, reduce) {
      if (reduce === undefined) reduce = false;
      var center = getShapeCenter(this.shape);
      if (centerX === undefined || centerY === undefined) {
        if (centerX === undefined) centerX = center.x;
        if (centerY === undefined) centerY = center.y;
      }
      if (copies === undefined) copies = 0;
      if (join === undefined) join = false;
      
      if (copies!==0) {
        copies = Math.abs(copies);
        if(angle==0 || angle==360) angle = 360/copies;
        var obj = this.copy();
        for (var i = 1; i < copies; i++) {
          //dbg(angle*i);
          var dup = obj.copy();
          dup.rotate(angle*i, centerX, centerY);
          var newCenter = rotatePoint(center.x, center.y, angle*i, centerX, centerY);
          dup.moveTo(newCenter.x, newCenter.y);
          if (join) this.join(dup, reduce);
        }
        obj.del();
      }else if(angle!==0){
        // Поворачиваем фигуру вокруг собственного центра
        this.shape.Rotate(angle);
        var newCenter = rotatePoint(center.x, center.y, angle, centerX, centerY);
        // Перемещаем фигуру в новое положение
        this.moveTo(newCenter.x, newCenter.y);
      }

      return this;
    };

    this.angle = function(val) {
      if (val === undefined) {
        return this.shape.RotationAngle;
      }
      return this.rotate(val - this.shape.RotationAngle);
    };

  lastObject = this;
}

// Управление последним объектом
function lastColor(arr) { if (lastObject)  lastObject.setColor(arr);}
function lastFill(arr) { if (lastObject)  lastObject.setFill(arr); }
function lastFlip(lineCoords, mode) { if (lastObject) return lastObject.flip(lineCoords, mode); }
function lastFlipX(xCoord, mode) { if (lastObject) return lastObject.flipX(xCoord, mode);}
function lastFlipY(yCoord, mode) { if (lastObject) return lastObject.flipY(yCoord, mode);}
function lastJoin(otherShape, leavetarget, leavesrc) { if (lastObject) return lastObject.join(otherShape, leavetarget, leavesrc);}
function lastWeld(otherShape, leavetarget, leavesrc) { if (lastObject) return lastObject.weld(otherShape, leavetarget, leavesrc);}
function lastIntersect(otherShape, leavetarget, leavesrc) { if (lastObject) return lastObject.intersect(otherShape, leavetarget, leavesrc);}
function lastMove(X, Y) { if (lastObject) return lastObject.move(X, Y);}
function lastCopy(X,Y) { if (lastObject) return lastObject.copy(X,Y);}
function lastRotate(angle, centerX, centerY, copies, join) { if (lastObject) return lastObject.rotate(angle, centerX, centerY, copies, join);}

function lastDel(otherShape) {
    if (otherShape && typeof otherShape.del === 'function') {
        otherShape.del();
        return true;
    } else if (lastObject && typeof lastObject.del === 'function') {
        lastObject.del();
        return true;
    }
    return false;
}

function lastAngle() { 
  if (lastObject) return lastObject.angle(); 
  return 0;
}

function lastAngle(val) { 
  if (lastObject) return lastObject.angle(val); 
}


function byName(name, OS, ingroup){
  var ret = getbyName(name, OS, ingroup);
  if (ret.Shapes.Count===0) return false;
  return createShape(ret.Shapes(1), "object by name");
}

function text(X, Y, text, size, font, params){
    if (params === undefined) params = [];

    var bySize = false;
    var byTop = false;
    var byRight = false;
    var byWide = false;
    var bold = false;
    var italic = false;
    var underline = false;
    var align = 1;

    for (var i=0;i<params.length;i++){
        switch (params[i].toLowerCase()){
            case "mm": bySize = true; break;
            case "top": byTop = true; break;
            case "right": byRight = true; align=2; break;
            case "width":
            case "wide": byWide = true; bySize = true; break;
            case "b":
            case "bold": bold = true; break;
            case "i":
            case "cursive":
            case "italic": italic = true; break;
            case "u":
            case "under": underline = true; break;
            case "underline": underline = true; break;
            case "r":
            case "textright": align=2; break;
            case "l":
            case "textleft": align=1; break;
            case "c":
            case "textcenter": align=3; break;
        }
    }

    var txt = createShape(host.ActiveLayer.CreateArtisticText(X, Y, text, undefined, undefined, font, size, bold, italic, underline, align),"text");

    if (bySize){
        if(byWide) txt.shape.SetSize(size, undefined); else txt.shape.SetSize(undefined, size);
        if(!byRight)txt.shape.LeftX=X;
        if(!byTop)txt.shape.BottomY=Y;
    }
    if (byTop) txt.shape.TopY=Y;
    if (byRight) txt.shape.RightX=X;
    return txt;
}

function perf(s,punkt_dash,punkt_gap){
  var obj = (s instanceof SHAPE) ? s.shape : s;
  return createShape(dos_punktir(obj, punkt_dash, punkt_gap, true, true, false, false, false), "perf");
}

function contur(s, gap, dir){//dir: 0 or "in"- inner contur, 1 or any other- outer contur
  var obj = (s instanceof SHAPE) ? s.shape : s;
  if (dir!==0 && dir!==1) dir = (dir==="in") ? 0 : 1;
  return createShape(dos_contur(obj, gap, dir, "inner line", true, false, true, true, false, false), "contur");
};

function raspred(s, line, gap, mode, even){
  var obj = (s instanceof SHAPE) ? s.shape : s;
  var line = (line instanceof SHAPE) ? line.shape : line;
  if (mode === undefined) mode = "qty";
  if (mode!="qty" && mode!="qty_by_gap") mode = "dist";
  if (even === undefined) even = true;
  var mode2 = undefined;
  if (mode === "qty_by_gap") {
    var len = line.DisplayCurve.Length;
    var qty = Math.floor(len / (gap+obj.SizeWidth));
    if (even && qty % 2 != 0) qty += 1;
    gap = len/qty - 0.01;
    mode = "dist";
    mode2 = "qty_by_gap";
  }
  dbg(mode + " : " + mode2 + " : " + gap + " : " + qty + " : " + even);
  var os = get_EOS();
  os.Add(line);
  os.Add(obj);
  var rasp = do_raspred(mode, mode2, os, gap, false);
  return createShape(rasp.Combine(), "raspred");
};


function FillXY(X,Y){
  var s1 = smartFill(X, Y);
  return createShape(s1, "smartFill");
}

function line_teeth(x1, y1, x2, y2, nums, th, direction, shift) {
  if (nums < 1) return null;

  var dx = x2 - x1;
  var dy = y2 - y1;
  var length = Math.sqrt(dx * dx + dy * dy);
  if (length === 0) return null;

  var ux = dx / length;
  var uy = dy / length;

  var nx = uy;
  var ny = -ux;

  if (direction === "left" || direction === "up") {
    nx = -nx;
    ny = -ny;
  }

  var totalParts = nums * 2 + 1;
  var segLength = length / totalParts;
  
  // Calculate shift amount
  var shiftAmount = 0;
  if (shift !== undefined) {
    if (shift === "half") {
      shiftAmount = segLength/2;
    } else if (shift === "-half") {
      shiftAmount = -segLength/2;
    } else {
      shiftAmount = parseFloat(shift) || 0;
      // Limit shift amount to segLength
      if (Math.abs(shiftAmount) > segLength) {
        shiftAmount = segLength * (shiftAmount > 0 ? 1 : -1);
      }
    }
  }

  var px = x1;
  var py = y1;

  var startLine = [x1, y1, x1 + ux * segLength + ux * shiftAmount, y1 + uy * segLength + uy * shiftAmount];
  px = startLine[2];
  py = startLine[3];
  
  var addLines = [];
  
  var offset = th/40;

  for (var i = 1; i < totalParts - 1; i++) {
    var nextPx = x1 + ux * (segLength * (i + 1) + shiftAmount);
    var nextPy = y1 + uy * (segLength * (i + 1) + shiftAmount);

    if (i % 2 === 1) {
      // Create rectangular tooth points - only the top points with slight inward offset
      var toothTopLeftX = px + nx * th + ux * offset;
      var toothTopLeftY = py + ny * th + uy * offset;
      
      var toothTopRightX = nextPx + nx * th - ux * offset;
      var toothTopRightY = nextPy + ny * th - uy * offset;
      
      // Add only the top points of the rectangular tooth
      addLines.push([toothTopLeftX, toothTopLeftY]);
      addLines.push([toothTopRightX, toothTopRightY]);
    }

    // Add the next base point
    addLines.push([nextPx, nextPy]);

    px = nextPx;
    py = nextPy;
  }

  // Add the final point
  addLines.push([x2, y2]);

  return line(startLine, addLines);
}

function line_slots(x1, y1, x2, y2, nums, th, direction, shift) {
  if (nums < 1) return null;

  var dx = x2 - x1;
  var dy = y2 - y1;
  var length = Math.sqrt(dx * dx + dy * dy);
  if (length === 0) return null;

  var ux = dx / length;
  var uy = dy / length;

  var nx = uy;
  var ny = -ux;

  if (direction === "left" || direction === "up") {
    nx = -nx;
    ny = -ny;
  }

  var totalParts = nums * 2 + 1;
  var segLength = length / totalParts;
  
  // Calculate shift amount
  var shiftAmount = 0;
  if (shift !== undefined) {
    if (shift === "half") {
      shiftAmount = segLength/2;
    } else if (shift === "-half") {
      shiftAmount = -segLength/2;
    } else {
      shiftAmount = parseFloat(shift) || 0;
      // Limit shift amount to segLength
      if (Math.abs(shiftAmount) > segLength) {
        shiftAmount = segLength * (shiftAmount > 0 ? 1 : -1);
      }
    }
  }

  // Start from the first segment point
  var px = x1 + ux * segLength + ux * shiftAmount;
  var py = y1 + uy * segLength + uy * shiftAmount;
  var angle = Math.atan2(dy, dx) * 180 / Math.PI;
  var lastRect = null;
  var isReversed = x2 < x1;

  for (var i = 1; i < totalParts - 1; i++) {
    var nextPx = x1 + ux * (segLength * (i + 1) + shiftAmount);
    var nextPy = y1 + uy * (segLength * (i + 1) + shiftAmount);

    if (i % 2 === 1) {
      // Calculate rectangle dimensions
      var rectWidth = segLength;
      var rectHeight = th;
      
      // Calculate base points
      var baseX = px;
      var baseY = py;
      
      // Calculate the starting point for the rectangle
      var startX = baseX;
      var startY = baseY;
      
      // Since rectangle always draws up-right, adjust starting point based on direction
      if (direction === "up") {
          startY -= rectHeight;  // Move start point down for UP direction
      }
      
      // Create rectangle
      var rect = host.ActiveLayer.CreateRectangle2(
        startX,        // x1 - left
        startY,        // y1 - bottom
        rectWidth,     // width
        rectHeight,    // height
        0, 0, 0, 0     // no corners
      );
      
      // Set rotation center and rotate
      rect.RotationCenterX = baseX;
      rect.RotationCenterY = baseY;
      rect.Rotate(angle);
      
      // Move the rectangle to its final position
      rect.Move(nx * rectHeight, ny * rectHeight);
      
      lastRect = (lastRect) ? lastRect.weld(createShape(rect, "rectangle")) : createShape(rect, "rectangle");
    }

    px = nextPx;
    py = nextPy;
  }

  return lastRect;
}

function line(a, b, c, d, e, f, g, h) {
  var startLine = null;
  var addLines = null;
  var last_line;

  if (arguments.length === 1 && a instanceof Array) {
    startLine = a;
  } else if (arguments.length === 2 && a instanceof Array && b instanceof Array) {
    startLine = a;
    addLines = b;
  } else if (arguments.length === 4) {
    startLine = [a, b, c, d];
  } else if (arguments.length === 8) {
    startLine = [a, b, c, d, e, f, g, h];
  } else {
    return null;
  }

  if (startLine.length === 4) {
    last_line = host.ActiveLayer.CreateLineSegment(
      startLine[0],
      startLine[1],
      startLine[2] === "last" ? startLine[0] : startLine[2],
      startLine[3] === "last" ? startLine[1] : startLine[3]
    );
  } else if (startLine.length === 8) {
    last_line = host.ActiveLayer.CreateCurveSegment(
      startLine[0],
      startLine[1],
      startLine[2] === "last" ? startLine[0] : startLine[2],
      startLine[3] === "last" ? startLine[1] : startLine[3],
      startLine[4],
      startLine[5],
      startLine[6],
      startLine[7]
    );
  } else {
    return null;
  }

  if (addLines) {
    var subPath = last_line.Curve.SubPaths.Last;
    for (var i = 0; i < addLines.length; i++) {
      var seg = addLines[i];
      if (seg){
        if (seg[0] === "last") seg[0] = i === 0 ? startLine[2] : addLines[i-1][0];
        if (seg[1] === "last") seg[1] = i === 0 ? startLine[3] : addLines[i-1][1];
        if (seg.length === 2 || seg.length === 3) {
          subPath.AppendLineSegment(seg[0], seg[1]);
        } else if (seg.length === 6 || seg.length === 7) {
          subPath.AppendCurveSegment(seg[0], seg[1], seg[2], seg[3], seg[4], seg[5]);
        }

        if ((seg.length === 3 || seg.length === 7) && seg[seg.length - 1] !== 0) {
          subPath.Nodes.Last.Previous().Fillet(seg[seg.length - 1]);
        }
      }
    }
  }

  return createShape(last_line, "line");
}

function rectangle(x1, y1, wi, hi, r1, r2, r3, r4) {
  
  var rectShape;
  if (arguments.length === 4) {
    rectShape = host.ActiveLayer.CreateRectangle2(x1, y1, wi, hi, 0, 0, 0, 0);
  } else if (arguments.length === 5) {
    rectShape = host.ActiveLayer.CreateRectangle2(x1, y1, wi, hi, r1, r1, r1, r1);
  } else if (arguments.length === 8) {
    rectShape = host.ActiveLayer.CreateRectangle2(x1, y1, wi, hi, r1, r2, r3, r4);
  } else {
    return null;
  }

  return createShape(rectShape, "rectangle");
}

function circle(x, y, r1, r2, startAngle, endAngle, pie) {
  if (startAngle === undefined) startAngle = 90;
  if (endAngle === undefined) endAngle = 90;
  if (pie === undefined) pie = false;
  if (r2 === undefined) r2 = r1;

  if (typeof x === "object") {
    var obj = x;
    x = obj.x;
    y = obj.y;
    r1 = obj.r;
    r2 = obj.r2 || obj.r; // если r2 не указан, считаем круг
  }
  return createShape(host.ActiveLayer.CreateEllipse2(x, y, r1, r2, 360-startAngle, 360-endAngle, pie), "circle");
}

function pointOnCircle(cx, cy, r, angleDegrees, r2) {
  var radians = angleDegrees * Math.PI / 180;
  var points = [];

  // Первая точка
  var x1 = cx + r * Math.cos(radians);
  var y1 = cy + r * Math.sin(radians);
  points.push({ x: x1, y: y1 });

  // Вторая точка, если передан второй радиус
  if (typeof r2 != "undefined") {
    var x2 = cx + r2 * Math.cos(radians);
    var y2 = cy + r2 * Math.sin(radians);
    points.push({ x: x2, y: y2 });
  }

  return points;
}

function makeGlueFlap(points, height, slopeAngle, join) {
  if (!points || points.length != 2) return [];

  // Преобразуем входные точки к объектам {x, y}
  function toPoint(p) {
    return (p instanceof Array) ? { x: p[0], y: p[1] } : p;
  }

  var p1 = toPoint(points[0]);
  var p2 = toPoint(points[1]);

  // Вектор между точками
  var dx = p2.x - p1.x;
  var dy = p2.y - p1.y;
  var length = Math.sqrt(dx * dx + dy * dy);

  // Нормаль к основанию
  var nx = -dy / length;
  var ny = dx / length;

  // Угол скоса в радианах
  var slopeRad = slopeAngle * Math.PI / 180;

  // Смещение по бокам
  var sideOffset = height * Math.tan(slopeRad);

  // Верхние точки
  var p3 = {
    x: p1.x + nx * height + (dx / length) * sideOffset,
    y: p1.y + ny * height + (dy / length) * sideOffset
  };
  var p4 = {
    x: p2.x + nx * height - (dx / length) * sideOffset,
    y: p2.y + ny * height - (dy / length) * sideOffset
  };

//  return [p1, p2, p4, p3]; // по часовой стрелке
  return poly([p1, p3, p4, p2], join);
}


function poly(points, closed) {
  if (!points) return null;

  // Если это массив объектов {x, y}, преобразуем в массив чисел
  if (typeof points[0] === 'object' && points[0] !== null && 'x' in points[0] && 'y' in points[0]) {
    var arr = [];
    for (var i = 0; i < points.length; i++) {
      arr.push(points[i].x, points[i].y);
    }
    points = arr;
  }

  if (points.length < 4) return null;

  // Если замыкание включено — добавляем первую точку в конец
  if (closed) {
    points = points.slice(); // копируем, чтобы не менять оригинал
    points.push(points[0], points[1]);
  }

  var last_line = host.ActiveLayer.CreateLineSegment(points[0], points[1], points[2], points[3]);
  var subPath = last_line.Curve.SubPaths.Last;

  for (var i = 4; i + 1 < points.length; i += 2) {
    subPath.AppendLineSegment(points[i], points[i + 1]);
  }
  
  if (closed) {
    last_line.Curve.JoinTouchingSubpaths(1, 0.1);
    //last_line.Curve.AutoReduceNodes(1);
  }

  return createShape(last_line, "poly");
}

function polyCurve(points, closed) {
  if (!points || points.length < 2) return null;

  var shape, curve, subPath;

  // ==== Двумерный массив ====
  if (points instanceof Array && points[0] instanceof Array) {
    var first = points[0];

    if (first.length === 8) {
      // кубическая Безье
      shape = host.ActiveLayer.CreateCurveSegment(
        first[0], first[1], first[2], first[3], first[4], first[5], first[6], first[7]
      );
    } else if (first.length === 4) {
      // простая линия
      shape = host.ActiveLayer.CreateLineSegment(
        first[0], first[1], first[2], first[3]
      );
    } else {
      return null; // неверный формат
    }

    curve = shape.Curve;
    subPath = curve.SubPaths.Last;

    for (var i = 1; i < points.length; i++) {
      var seg = points[i];
      if (!Array.isArray(seg)) continue;

      if (seg.length === 2) {
        // линия к точке
        subPath.AppendLineSegment(seg[0], seg[1]);
      } else if (seg.length === 6) {
        // кубическая Безье
        subPath.AppendCurveSegment(seg[0], seg[1], seg[2], seg[3], seg[4], seg[5]);
      } else if (seg.length === 4) {
        // линия (две точки)
        subPath.AppendLineSegment(seg[0], seg[1]);
        subPath.AppendLineSegment(seg[2], seg[3]);
      } else {
        continue;
      }
    }

    if (closed) {
      if (first.length === 8) {
        // закрываем кривой
        subPath.AppendCurveSegment(first[0], first[1], first[4], first[5], first[6], first[7]);
      } else {
        // закрываем линией
        subPath.AppendLineSegment(first[0], first[1]);
      }
      curve.JoinTouchingSubpaths(1, 0.1);
    }

    return createShape(shape, "polyCureve");
  }

  // ==== Ломаная ====
  if (points.length % 2 !== 0) return null;

  shape = host.ActiveLayer.CreateLineSegment(
    points[0], points[1], points[2], points[3]
  );

  curve = shape.Curve;
  subPath = curve.SubPaths.Last;

  for (var i = 4; i + 1 < points.length; i += 2) {
    subPath.AppendLineSegment(points[i], points[i + 1]);
  }

  if (closed) {
    subPath.AppendLineSegment(points[0], points[1]);
    curve.JoinTouchingSubpaths(1, 0.1);
  }

  return createShape(shape, "poly");
}



function shipy(sx, sy, stx, sty, qty_or_len, ph, clo, sgap, lgap, rgap, bylen, colr) {
  if (typeof sx === "object" && typeof sy === "string") {
    var s = sx;
    var side = sy.toUpperCase();
    var inv = false;

    if (side.charAt(0) === "-") {
      inv = true;
      side = side.substr(1);
    }

    // Инверсия по умолчанию для B и L
    if (side === "B" || side === "L") inv = !inv;

    var baseCoords = {
      L: s.L(),
      R: s.R(),
      T: s.T(),
      B: s.B()
    };

      var calc_sx, calc_sy, calc_stx, calc_sty;

    if (side === "T" || side === "B") {
      calc_sy = calc_sty = (side === "T") ? baseCoords.T : baseCoords.B;
      calc_sx = baseCoords.L;
      calc_stx = baseCoords.R;
    } else if (side === "L" || side === "R") {
      calc_sx = calc_stx = (side === "L") ? baseCoords.L : baseCoords.R;
      calc_sy = baseCoords.T;
      calc_sty = baseCoords.B;
    } else {
      return null;
    }

    if (inv) {
      var tmpX = calc_sx, tmpY = calc_sy;
      calc_sx = calc_stx; calc_sy = calc_sty;
      calc_stx = tmpX; calc_sty = tmpY;
    }

    return createShape(pazy(calc_sx, calc_sy, calc_stx, calc_sty, stx, sty, qty_or_len, ph, clo, sgap, lgap, rgap), "shipy");
  }

  if (arguments.length >= 5) {
    return createShape(pazy(sx, sy, stx, sty, qty_or_len, ph, clo, sgap, lgap, rgap, bylen, colr), "shipy");
  }

  return null;
}

function shipiki_between(ships, color) {
    var shipp;
    if (ships.shape.shapes.Count == 0) return null;
    for (var i = 1; i <= ships.shape.shapes.Count; i++) {
        var curshape = ships.shape.shapes(i);
        
        // Находим минимальную и максимальную длины сегментов
        var minLength = Number.MAX_VALUE;
        var maxLength = 0;
        for (var s = 1; s <= curshape.displayCurve.segments.count; s++) {
            var length = curshape.displayCurve.segments(s).length;
            if (length < minLength) minLength = length;
            if (length > maxLength) maxLength = length;
        }
        
        // Теперь minLength будет высотой (TH), а maxLength/2 будет шириной (ssize)
        var TH = minLength;
        var ssize = maxLength/2;

        if (i === 1) {
            var nextshape = ships.shape.shapes(i+1);
            // Используем центральные точки объектов
            var dx = nextshape.CenterX - curshape.CenterX;
            var dy = nextshape.CenterY - curshape.CenterY;
            var angle = Math.atan2(dy, dx);
            var dist = Math.sqrt(dx*dx + dy*dy);
        }

        // Вычисляем координаты с учетом угла
        var offsetX = dist/2 * Math.cos(angle);
        var offsetY = dist/2 * Math.sin(angle);
        
        // Создаем прямоугольник относительно центра объекта
        var ship = rectangle(
            curshape.CenterX - offsetX - ssize/2,
            curshape.CenterY - offsetY - TH/2, // Центрируем по вертикали
            ssize,
            TH,
            0, 0, 0, 0
        );
        
        ship.shape.Rotate(angle * 180 / Math.PI);

        if(i > 1) {
            shipp.weld(ship);
        } else {
            shipp = ship;
        }

        if(i == ships.shape.shapes.Count) {
            var lastRect = rectangle(
                curshape.CenterX + offsetX - ssize/2,
                curshape.CenterY + offsetY - TH/2, // Центрируем по вертикали
                ssize,
                TH,
                0, 0, 0, 0
            );
            lastRect.shape.Rotate(angle * 180 / Math.PI);
            shipp.weld(lastRect);
        }
    }
    shipp.setFill(color);
    //dbg(shipp.shape.type);
    return createShape(shipp.shape, "shipiki");
}


function getAngleByTwoCatets(a, b) {
  // a - противолежащий катет, b - прилежащий катет
  var angleInRadians = Math.atan(a / b);
  var angleInDegrees = angleInRadians * (180 / Math.PI);
  return angleInDegrees;
}

function getAngleByTwoCatetsAtan2(a, b) {
  var angleInRadians = Math.atan2(a, b);
  var angleInDegrees = angleInRadians * (180 / Math.PI);
  return angleInDegrees;
}

// Расчет соединения деталей под углом
// t1 - толщина шипа (вставляемой детали)
// t2 - толщина детали куда вставляется
// angle - угол наклона (90° = вертикально, 0° = горизонтально)
// mode - режим расчета (0 - close, 1 - open, 2 - full)
//
// Результат (возвращаемый объект)
// Функция возвращает объект с основными параметрами соединения:
// tennon — длина шипа (рассчитанная длина выступающей части).
// slot — ширина паза (рассчитанная ширина отверстия для шипа).
// cut1 — дополнительная длина/глубина с одной стороны соединения (зависит от режима и угла).
// cut2 — дополнительная длина/глубина с другой стороны соединения.
// add1 — вспомогательный параметр: tennon - cut1.
// add2 — вспомогательный параметр: slot - cut2.
// debug — объект с отладочной информацией (промежуточные значения для проверки формул).

function calcAngleJoint(t1, t2, origangle, mode) {
    var absAngle = origangle;
    // Приводим угол к положительному значению
    while(absAngle <0) absAngle += 360;
    var angle = absAngle; //Нормализированный угол
    // Приводим угол к значению от 0 до 180
    while(absAngle > 180) absAngle = 360-absAngle;
    // Конвертируем угол в радианы
    if(absAngle>89.9 && absAngle<90.1) {
      //Если угол 90, то возвращаем прямоугольник
      return {
        tennon: t1,
        slot: t2,
        cut1: 0,
        cut2: 0,
        add1: t1,
        add2: t2
      }
    }
    var angleRad = Math.abs(90-absAngle) * Math.PI / 180;
    
    // Защита от деления на ноль при cos(angle) близком к 0
    var cosAngle = Math.cos(angleRad);
    if (Math.abs(cosAngle) < 0.01) {
        cosAngle = 0.01;
    }
    
    // Определяем режим (по умолчанию "close")
    if (!mode) mode = "close";
    if (mode === 0) mode = "close";
    if (mode === 1) mode = "open";
    if (mode === 2) mode = "full";
    
    var slotWidth, tennonLength, cut1, cut2;
    var debugInfo = {
        angle: angle,
        angleRad: angleRad,
        mode: mode
    };
    
    var cutl = t1 * Math.tan(angleRad);   // противолежащий катет l по прилежащему катету t1
    var cutm = t1 / Math.abs(cosAngle);   // гипотенуза m по прилежащему катету t1
    cut1 = 0;
    cut2 = cutl;

    if (mode === "close") {
        var b = t2 * Math.tan(angleRad);  // противолежащий катет b по прилежащему катету t2
        var c = t2 / Math.abs(cosAngle);  // гипотенуза c по прилежащему катету t2

        var d = t1 * Math.abs(cosAngle);   // прилежащий катет d по гипотенузе t1
        var e = t1 * Math.sin(angleRad);   // противолежащий катет e по гипотенузе t1
        
        slotWidth = b + d;
        tennonLength = c;
        
        cut1 = slotWidth-cutm;
        

        debugInfo.b = b;
        debugInfo.c = c;
        debugInfo.d = d;
        debugInfo.e = e;
    } else if (mode === "open") {
         

        if (absAngle < 90) {
          var S = t2 / Math.abs(cosAngle);   // гипотенуза S по прилежащему катету t2
          var V = t1 / Math.abs(cosAngle);   // гипотенуза V по прилежащему катету t1
        } else {
          var V = t1 * Math.abs(cosAngle);   // прилежащий катет V при гипотенузе t1
          var W = t2 - t1 * Math.sin(angleRad);   // t2- противолежащий катет по гипотенузе t1
          cut1  = W * Math.tan(angleRad);  // противолежащий катет по прилежащему катету W
          var S = t2 * Math.sin(angleRad);   // противолежащий катет S при гипотенузе t2
          cut2 = S - W / Math.abs(cosAngle); //S - гипотенуза по прилежащему катету W
       }

        slotWidth = V;
        tennonLength = S;

        if(angle>180) {
          cut1 = tennonLength;
          cut2 = slotWidth;
        }
        
        debugInfo.S = S;
        debugInfo.V = V;
        
    } else if (mode === "full") {
        var L = t1 * Math.sin(angleRad);  // противолежащий катет L по гипотенузе t1
        var K = t1 * Math.abs(cosAngle);  // прилежащий катет K по гипотенузе t1
        
        var N = L + t2;                   // прилежащий катет N сумма противолежащего катета L и толщины детали t2
        var P = N / Math.abs(cosAngle);   // гипотенуза P по прилежащему катету N
        var O = N * Math.tan(angleRad);   // противолежащий катет O по прилежащему катету N
        
        slotWidth = K + O;
        tennonLength = P;
        cut1 = slotWidth-cutm;
        
        debugInfo.K = K;
        debugInfo.L = L;
        debugInfo.N = N;
        debugInfo.O = O;
        debugInfo.P = P;
    }
    if (angle <90 && angle > 0) {
      cut1 = 0; 
      cut2 = 0;
    }
    return {
        // Основные результаты
        tennon: tennonLength,
        slot: slotWidth,
        cut1: cut1,
        cut2: cut2,
        add1: tennonLength-cut1,
        add2: slotWidth-cut2,
        // Отладочная информация
        debug: debugInfo
    };
}

/// System gbx functions

// Обертка создания SHAPE
function createShape(corelShape, type) {
  return new SHAPE(corelShape, type);
}

// Обертка создания RANGE
function createRange() {
  return new SHAPE(get_EOS(), "range");
}


function generateId(prefix) {
  if (!(prefix in _idCounters)) {
    _idCounters[prefix] = 1;
  } else {
    _idCounters[prefix] = _idCounters[prefix] + 1;
  }
  return prefix + "_" + _idCounters[prefix];
}


function replaceLimitStrict(input) {
  // IF(a>b,x,y) → (a>b ? x : y)
  input = input.replace(/IF\s*\(\s*([^,]+?)\s*([<>!=]=?)\s*([^,]+?)\s*,\s*([^,]+?)\s*,\s*([^)]+?)\)/g,
    '($1 $2 $3 ? $4 : $5)');

  // (A limit=B) → ((A > B) ? B : A)
  input = input.replace(/\(\s*([^\(\)]+?)\s+limit\s*=\s*([^\(\)]+?)\s*\)/g,
    '(($1 > $2) ? $2 : $1)');
  return input;
}

function parseParamsLine(lines) {
  var result = [];
  var line = lines[0];
  if (line.indexOf('//params:') !== 0) return result;

  var paramString = line.substring(9);
  
  // Extract limits before removing them from paramString
  var limits = {};
  var limitMatches = paramString.match(/\b\w+\s*=\s*[^,;]+?\s+limit\s*=\s*[^,;]+/g) || [];
  for (var m = 0; m < limitMatches.length; m++) {
    var match = limitMatches[m];
    var parts = match.match(/(\w+)\s*=\s*[^,;]+?\s+limit\s*=\s*([^,;]+)/);
    if (parts) {
      limits[parts[1]] = parts[2];
    }
  }

  paramString = paramString.replace(/limit\s*=\s*[^,;]+/g, '');
  paramString = paramString.replace(/[;]/g, '');

  var parts = paramString.split(/\s*,\s*/);

  for (var i = 0; i < parts.length; i++) {
    var part = parts[i].replace(/^\s+|\s+$/g, '');
    if (!part) continue;

    var eqIndex = part.indexOf('=');
    if (eqIndex === -1) continue;

    var key = part.substring(0, eqIndex).replace(/^\s+|\s+$/g, '');
    var value = part.substring(eqIndex + 1).replace(/^\s+|\s+$/g, '');

/*
    // Извлечение (odd)/(even)
    var parityMatch = rawValue.match(/\((odd|even)\)/i);
    var parity = parityMatch ? parityMatch[1].toLowerCase() : null;

    // Значение без скобок
    var value = rawValue.replace(/\([^)]*\)/g, '');
*/

    // Замена переменной в остальных строках
    for (var l = 1; l < lines.length; l++) {
        //обработка val_поле для изменения данных
        var regexVal = new RegExp('(^|[^\\.\\w_])(val_' + key + ')(?![\\w_]|\\s*\\()', 'g');
        lines[l] = lines[l].replace(regexVal, function(_, prefix, word) {
          return prefix + 'val_gbx_' + key + '.value';
        });

      var regex = new RegExp('(^|[^\\.\\w_])(' + key + ')(?![\\w_]|\\s*\\()', 'g');
      lines[l] = lines[l].replace(regex, function(_, prefix, word) {
        return prefix + 'gbx_' + word;
      });
    }

    // Логика генерации кода
      var arrAction = get_actions(value)
      value = arrAction[0];
      //dbg(key + ":" + value);
      if (value=="btn"){
        continue;
      }else if (value === "true" || value === "false") {
        result.push('var gbx_' + key + ' = getVal(val_gbx_' + key + ');');
      } else if (value.indexOf(':') !== -1) {
        result.push('var gbx_' + key + ' = getVal(val_gbx_' + key + ');');
      } else if (document.getElementById("val_gbx_" + key)){
        if (!isNaN(value) && value.charAt(0) !== '0') {
          var baseAssignment = 'vall(parseFloat(getVal(val_gbx_' + key + ')))';
          
          // Add limit check if exists
          if (limits[key]) {
            result.push('var gbx_' + key + ' = ' + baseAssignment + ';');
            result.push('if (gbx_' + key + ' > ' + limits[key] + ') { gbx_' + key + ' = ' + limits[key] + '; val_gbx_' + key + '.value = gbx_' + key + '; do_save(val_gbx_' + key + '); }');
          } else {
            result.push('var gbx_' + key + ' = ' + baseAssignment + ';');
          }
          //если не mm, то проверка четности и обновление поля
          if(arrAction['mm']) result.push('if(!getVal(val_gbx_mm)){');
            // Проверка четности и обновление поля
            if (arrAction['odd']) {
              result.push('if (gbx_' + key + ' % 2 === 0) { gbx_' + key + ' += 1; val_gbx_' + key + '.value = gbx_' + key + '; do_save(val_gbx_' + key + '); }');
            } else if (arrAction['even']) {
              result.push('if (gbx_' + key + ' % 2 !== 0) { gbx_' + key + ' += 1; val_gbx_' + key + '.value = gbx_' + key + '; do_save(val_gbx_' + key + '); }');
            }
          if(arrAction['mm']) result.push('}');
        } else {
          result.push('var gbx_' + key + ' = ' + 'getVal(val_gbx_' + key + ');  do_save(val_gbx_' + key + ');');
          if (limits[key]) {
            result.push('if (gbx_' + key + ' > ' + limits[key] + ') { gbx_' + key + ' = ' + limits[key] + '; val_gbx_' + key + '.value = gbx_' + key + '; do_save(val_gbx_' + key + '); }');
        }
      }
    }
  }

  return result;
}

function showListValue(el, prefix, postfix){
  if (prefix === undefined) prefix = false;
  if (postfix === undefined) postfix = false;
  if (el){
      var showspan = document.getElementById(el.id+"_show");
      if (showspan) showspan.innerHTML = prefix+el.value+postfix;
  }
}

function genNum(txt, text) {
  if (text === undefined) text = false;
  if (txt instanceof SHAPE) txt = txt.shape.name();
  else if (txt instanceof Object) txt = txt.name();
    if (txt)  var match = txt.match(/^(.*_)?(\d+)?$/);

  if (!match) return null;

  if (!match[2]) {
    // вернуть всё кроме цифр, но с подчёркиванием, либо всю строку если цифр нет
    return match[1] || txt;
  } else {
    return match[2] || null;
  }
}

function get_actions(val) {
  if (val.split(":").length>1) return [val];
  var arrAction = val.split("|");
  var actions = [arrAction[0]];
  if (arrAction.length>1){
    for (var ia = 1; ia < arrAction.length; ia++){
          var preAct = arrAction[ia].toLowerCase().split("#");
          var actKey = preAct[0];
          if (preAct.length>1){
            preAct.shift();
            if (actKey==="active" || actKey=="deactive"){
                  var actRet = "";
                  for (var i=0; i<preAct.length; i++) actRet += "val_gbx_" + preAct[i]+",";
              }else{
                  var actRet = preAct;
              }
          }else{
              var actRet = true;
          }
          actions[actKey] = actRet;
      }
  }
  return actions;
}

function getRadbyWH(W,H){
    return Math.sqrt(W * W + H * H) / 2;
}

 function vRECT(shape, draw){
  if(draw===undefined) draw = false;
  if (shape===undefined) shape = [0,0,250,120];

  this.closed = true;
  this.nodes = [];
  this.sides = [];
  this.shapes = [];
  this.W = 0;
  this.H = 0;
  this.L = 0;
  this.B = 0;
  this.R = 0;
  this.T = 0;

  if(shape instanceof SHAPE){
      this.nodes = [{x:shape.L(), y:shape.B()},
                    {x:shape.L(), y:shape.T()},
                    {x:shape.R(), y:shape.T()},
                    {x:shape.R(), y:shape.B()}
                  ];
  } else if(shape instanceof Array){
      if(shape[0] instanceof Object){
          this.nodes = shape;
      }else if(shape.length===4 && !(shape[0] instanceof Array)){
          this.nodes = [{x:shape[0], y:shape[1]},
                        {x:shape[0], y:shape[3]},
                        {x:shape[2], y:shape[3]},
                        {x:shape[2], y:shape[1]}
                      ];
      } else if(shape[0] instanceof Array && shape[0].length===2){
          for(var i=0; i<shape.length; i++){
              this.nodes.push({x:shape[i][0], y:shape[i][1]});
          }   
      } else if(shape.length>4 && !(shape[0] instanceof Array)){
          for(var i=0; i<shape.length-1; i+=2){
              this.nodes.push({x:shape[i], y:shape[i+1]});
          }   
      }
  }

  this.nodeNext = function(node, cnt){
      if(node===undefined) node = 0;
      if(cnt===undefined) cnt = 1;
      var finalIndex = node+cnt;
      if((finalIndex<0 || finalIndex>this.nodes.length-1) && !this.closed){
          return null;
      }else{
          var ost = finalIndex%this.nodes.length;
          finalIndex = (finalIndex<0) ? this.nodes.length+ost : ost;
      }
      return this.nodes[finalIndex];
  }

  this.nodePrev = function(node, cnt){
      if(node===undefined) node = 0;
      if(cnt===undefined) cnt = 1;
      return this.nodeNext(node, -cnt);
  }

  this.sideRotate = function(side, angle, byEnd, long){
      if(side===undefined) side = 0;
      if(long===undefined) long = false;
      if(side==="L") side = 0;
      if(side==="T") side = 1;
      if(side==="R") side = 2;
      if(side==="B") side = 3;
      if(byEnd===undefined) byEnd = false;

      function findNodeIndex(node, nodes) {
          for (var i = 0; i < nodes.length; i++) {
              if (nodes[i] === node) { return i; }
          }
          return -1;
      }

      if (!long) {
          var rotatePoint = byEnd ? this.nodeNext(side) : this.nodes[side];
          var toRotate = byEnd ? this.nodes[side] : this.nodeNext(side);
          
          if (!rotatePoint || !toRotate) return this;

          var newAngle = angle * Math.PI / 180;
          var newX = rotatePoint.x + Math.cos(newAngle)*(toRotate.x-rotatePoint.x) - Math.sin(newAngle)*(toRotate.y-rotatePoint.y);
          var newY = rotatePoint.y + Math.sin(newAngle)*(toRotate.x-rotatePoint.x) + Math.cos(newAngle)*(toRotate.y-rotatePoint.y);
          
          var toRotateIndex = findNodeIndex(toRotate, this.nodes);
          if (toRotateIndex !== -1) {
              this.nodes[toRotateIndex] = {x:newX, y:newY};
          }
      } else {
          var P0, P1, P2;

          if (!byEnd) {
              P0 = this.nodes[side];
              P1 = this.nodeNext(side);
              P2 = this.nodeNext(side, 2);
          } else {
              P0 = this.nodeNext(side);
              P1 = this.nodes[side];
              P2 = this.nodePrev(side);
          }

          if (!P0 || !P1 || !P2) { return this; }

          var orig_dx = P1.x - P0.x;
          var orig_dy = P1.y - P0.y;
          var orig_angle_rad = Math.atan2(orig_dy, orig_dx);
          var rotation_rad = angle * Math.PI / 180;
          var new_angle_rad = orig_angle_rad + rotation_rad;

          var L1_dx = P2.x - P1.x;
          var L1_dy = P2.y - P1.y;

          var Lnew_cos = Math.cos(new_angle_rad);
          var Lnew_sin = Math.sin(new_angle_rad);

          var D = Lnew_cos * L1_dy - Lnew_sin * L1_dx;

          if (Math.abs(D) < 1e-9) { return this; }

          var t = (Lnew_cos * (P0.y - P1.y) - Lnew_sin * (P0.x - P1.x)) / D;

          var newX = P1.x + t * L1_dx;
          var newY = P1.y + t * L1_dy;

          var p1_index = findNodeIndex(P1, this.nodes);
          if (p1_index !== -1) {
              this.nodes[p1_index] = {x: newX, y: newY};
          }
      }

      this.init();
      return this;
  }

  // Добавляет относительное смещение всех узлов
  this.move = function(dx, dy){
      if(dx===undefined) dx = 0;
      if(dy===undefined) dy = 0;
      for(var i = 0; i < this.nodes.length; i++){
          this.nodes[i].x += dx;
          this.nodes[i].y += dy;
      }
      // пересчитать стороны после перемещения
      this.init();
      return this;
  }

  // Перемещает фигуру так, чтобы её первый узел оказался в точке (x, y)
  this.moveTo = function(x, y){
      if(this.nodes.length === 0) return this;
      var dx = 0, dy = 0;
      if(x !== undefined && x !== null){
          dx = x - this.nodes[0].x;
      }
      if(y !== undefined && y !== null){
          dy = y - this.nodes[0].y;
      }
      return this.move(dx, dy);
  }

  // Возвращает крайние координаты фигуры
  this.getLeft = function(){
      if(this.nodes.length === 0) return undefined;
      var minX = this.nodes[0].x;
      for(var i = 1; i < this.nodes.length; i++){
          if(this.nodes[i].x < minX) minX = this.nodes[i].x;
      }
      return minX;
  }

  this.getRight = function(){
      if(this.nodes.length === 0) return undefined;
      var maxX = this.nodes[0].x;
      for(var i = 1; i < this.nodes.length; i++){
          if(this.nodes[i].x > maxX) maxX = this.nodes[i].x;
      }
      return maxX;
  }

  this.getBottom = function(){
      if(this.nodes.length === 0) return undefined;
      var minY = this.nodes[0].y;
      for(var i = 1; i < this.nodes.length; i++){
          if(this.nodes[i].y < minY) minY = this.nodes[i].y;
      }
      return minY;
  }

  this.getTop = function(){
      if(this.nodes.length === 0) return undefined;
      var maxY = this.nodes[0].y;
      for(var i = 1; i < this.nodes.length; i++){
          if(this.nodes[i].y > maxY) maxY = this.nodes[i].y;
      }
      return maxY;
  }

  // Смещает фигуру так, чтобы её левый край находился в координате x
  this.setLeft = function(x){
      if(x === undefined || this.nodes.length === 0) return this;
      var dx = x - this.getLeft();
      return this.move(dx, 0);
  }

  // Смещает фигуру так, чтобы её правый край находился в координате x
  this.setRight = function(x){
      if(x === undefined || this.nodes.length === 0) return this;
      var dx = x - this.getRight();
      return this.move(dx, 0);
  }

  // Смещает фигуру так, чтобы её верхний край находился в координате y
  this.setTop = function(y){
      if(y === undefined || this.nodes.length === 0) return this;
      var dy = y - this.getTop();
      return this.move(0, dy);
  }

  // Смещает фигуру так, чтобы её нижний край находился в координате y
  this.setBottom = function(y){
      if(y === undefined || this.nodes.length === 0) return this;
      var dy = y - this.getBottom();
      return this.move(0, dy);
  }

  // Вращает фигуру против часовой стрелки на угол (в градусах)
  // angle  – угол в градусах.
  // x, y   – координаты точки вращения.  Если оба не заданы, используется геометрический центр фигуры.
  // Если задан только x (y undefined), то x трактуется как индекс узла (0-based), вокруг которого нужно вращать.
  this.rotate = function(angle, x, y){
      if(angle === undefined) angle = 0;
      if(this.nodes.length === 0) return this;

      var pivot = {x:0, y:0};

      // Определяем точку вращения
      if(x === undefined && y === undefined){
          // Центр ограничивающего прямоугольника
          pivot.x = (this.getLeft() + this.getRight()) / 2;
          pivot.y = (this.getBottom() + this.getTop()) / 2;
      } else if(x !== undefined && y === undefined){
          // x считается индексом узла
          var idx = parseInt(x);
          if(isNaN(idx)) return this;
          var len = this.nodes.length;
          if(this.closed){
              // Нормализуем индекс по кругу
              idx = ((idx % len) + len) % len; // поддерживаем отрицательные значения тоже
          }
          if(idx < 0 || idx >= len) return this; // для незамкнутых фигур вне диапазона – выходим
          pivot.x = this.nodes[idx].x;
          pivot.y = this.nodes[idx].y;
      } else {
          // заданы координаты точки
          pivot.x = x;
          pivot.y = y;
      }

      var rad = angle * Math.PI / 180;
      var cosA = Math.cos(rad);
      var sinA = Math.sin(rad);

      for(var i=0; i<this.nodes.length; i++){
          var dx = this.nodes[i].x - pivot.x;
          var dy = this.nodes[i].y - pivot.y;
          var newX = pivot.x + dx * cosA - dy * sinA;
          var newY = pivot.y + dx * sinA + dy * cosA;
          this.nodes[i].x = newX;
          this.nodes[i].y = newY;
      }

      // пересчёт свойств
      this.init();
      return this;
  }

  this.init = function(){
      this.sides = [];
      for(var i=0; i<this.nodes.length-1; i++){
          this.sides.push({sx:this.nodes[i].x, sy:this.nodes[i].y, ex:this.nodes[i+1].x, ey:this.nodes[i+1].y});
      }
      if(this.closed) this.sides.push({sx:this.nodes[this.nodes.length-1].x, sy:this.nodes[this.nodes.length-1].y, ex:this.nodes[0].x, ey:this.nodes[0].y});
      this.sides["L"] = this.sides[0];
      this.sides["T"] = this.sides[1];
      this.sides["R"] = this.sides[2];
      this.sides["B"] = this.sides[3];
      this.W = this.getRight()-this.getLeft();
      this.H = this.getTop()-this.getBottom();
      this.L = this.getLeft();
      this.B = this.getBottom();
      this.R = this.getRight();
      this.T = this.getTop();
      if(draw) this.draw();
  }

  this.draw = function(){
      this.shapes.push(poly(this.nodes, this.closed));
      return this;
  }

  // Копирование объекта
  this.copy = function(){
      var newNodes = [];
      for(var i = 0; i < this.nodes.length; i++){
          newNodes.push({x: this.nodes[i].x, y: this.nodes[i].y});
      }
     return new vRECT(newNodes, false); // не рисуем копию сразу
  }
  
  // Смещение конкретного сегмента перпендикулярно его направлению
  this.segmentOffset = function(side, offset){
      if(!this.sides || !this.sides[side] || offset === 0) return this;
      
      var segment = this.sides[side];
      
      // Вычисляем вектор сегмента
      var vectorX = segment.ex - segment.sx;
      var vectorY = segment.ey - segment.sy;
      var length = Math.sqrt(vectorX * vectorX + vectorY * vectorY);
      
      if(length === 0) return this;
      
      // Нормализуем вектор
      vectorX /= length;
      vectorY /= length;
      
      // Вычисляем перпендикулярный вектор (поворот на 90° против часовой стрелки)
      var perpX = -vectorY;
      var perpY = vectorX;
      
      // Смещаем узлы сегмента
      var sideIndex;
      switch(side){
          case "L": sideIndex = 0; break; // сегмент 0: узлы 0->1
          case "T": sideIndex = 1; break; // сегмент 1: узлы 1->2
          case "R": sideIndex = 2; break; // сегмент 2: узлы 2->3
          case "B": sideIndex = 3; break; // сегмент 3: узлы 3->0
          default: return this;
      }
      
      // Определяем индексы узлов для данного сегмента
      var nodeIndex1, nodeIndex2;
      if(sideIndex === 3){ // сегмент B: 3->0
          nodeIndex1 = 3;
          nodeIndex2 = 0;
      } else {
          nodeIndex1 = sideIndex;
          nodeIndex2 = sideIndex + 1;
      }
      
      // Смещаем оба узла сегмента
      this.nodes[nodeIndex1].x += perpX * offset;
      this.nodes[nodeIndex1].y += perpY * offset;
      this.nodes[nodeIndex2].x += perpX * offset;
      this.nodes[nodeIndex2].y += perpY * offset;
      
      // Пересчитываем свойства
      this.init();
      return this;
  }

  this.del = function(){
      for(var i=0; i<this.shapes.length; i++){
          this.shapes[i].del();
      }
      return this;
  }
  this.init();

}

function createVirtual(shape, draw){
  return new vRECT(shape, draw);
}



function make_gbx(type, undogroup){
  if(type === undefined) type = "gbx";
  if(undogroup === undefined) undogroup = true;
  var shft = Shift();
  var timer = new Date().getTime();
  var OS = get_OS(true,false,true, isShift(shft), false);
      do_save(val_gbx_th);
      do_save(val_gbx_hi);
      var btnpath = 'gbx/'+gbx_list.value+'/'+type+'.js';
      var fpath = (type === "gbx" || !vbfileExist(host.Application.AddonPath + btnpath)) ? 'gbx/'+gbx_list.value+'.js' : btnpath;
      var makefpath = 'gbx/' + getVal(gbx_list) + '/make.js';
      if(type==="gbx" && shft>0 && vbfileExist(host.Application.AddonPath + makefpath)) fpath = makefpath;
      do_begin("gbx_" + type, undogroup, glOptim);
      var sr = include_gbx(OS, fpath);
      if (sr.Shapes.Count>0) sr.CreateSelection();
      do_end(undogroup);
  var timer2 = new Date().getTime();
  dbg("timer gbx:" + (timer2 - timer) + "ms");
  } 


function include_gbx(OS, file, shft, fname, doit){
  if (doit===undefined) doit = true;
  if (fname===undefined) fname = "do";
  if (shft===undefined) shft = Shift();
  var ffile = vbReadFileUTF(file, chr(10));
  if (ffile.length<3 && ffile[0].length<3) return false;
  var noduplicateS = (ffile[0].indexOf("noduplicateS")>-1) ? true : false;
  var noMove = (ffile[0].indexOf("noMove")>-1) ? true : false;
  var noOS = (ffile[0].indexOf("noOS")>-1) ? true : false;
  var funcName = "include_" + fname;
  var scriptId = "include_script_" + fname;
  dbg();

  var inner = "function " + funcName + "(OS, shft) { var sr = get_EOS();\n";

      inner += "if (shft===undefined) shft = Shift();\n";
      inner += "  var HI = vall(val_gbx_hi.value);\n";
      inner += "  var TH = vall(val_gbx_th.value);\n";
      inner += "  var join = \"join\";\n";
      inner += "  var copy = \"copy\";\n";
      inner += "  var last = \"last\";\n";
      inner += "  var color_paz = getColor('paz');\n";
      inner += "  var color_ship = getColor('ship');\n";
      inner += "  var color_vstr = getColor('vstr');\n";
      inner += "  var color_grav = getColor('grav');\n";
      inner += "  var color_3mm = getColor('3mm');\n";
      inner += "  var color_cut = getColor('cut');\n";
      inner += "  var OScnt = OS.Shapes.Count;\n";
      inner += "  var OSstart = OScnt;\n";
      inner += "  var btn = window.event.srcElement.id;\n";
      inner += "  var toDel = getVal(ch_gbx_del);\n";
      inner += "  var delMe = 'deletemeplease';\n";
        if (!noOS){
          inner += "if (OScnt>0){\n";
          inner += "  var compensation = (getVal(ch_kbx_compens)) ? vall(val_kbx_compens.value) : 0;\n";
          inner += "  var lastnum = undefined;\n";
          inner += "  var sfirst = true, slast = false, sstop = false;\n";
          inner += "  var allA = one_shape_area(OS);\n";
          inner += "  var allLE = one_shape_len(OS);\n";
          inner += "for (var sindex=1; sindex<=OScnt;sindex++){\n";
            inner += "  if(sindex>1) sfirst = false;\n";
            inner += "  if(sindex==OScnt) slast = true;\n";
            inner += "  var s = OS.Shapes(sindex);\n";
            inner += "  if(vbgetExist(s)){\n";
              inner += "  var sstring = getSstring(s);\n";
              if (noduplicateS) inner += "  var S = createShape(s, 'source object');\n";
              else inner += "  var S = createShape(s.Duplicate(), 'source object');\n";
              inner += "  var addShape = true;\n";
              //inner += "  if (!toDel) s = S.copy().shape;\n";
              inner += "  var A = one_shape_area(s);\n";
              inner += "  var LE = one_shape_len(s);\n";
              inner += "  var W = s.SizeWidth;\n";
              inner += "  var H = s.SizeHeight;\n";
              inner += "  var L = s.LeftX;\n";
              inner += "  var R = s.RightX;\n";
              inner += "  var T = s.Topy;\n";
              inner += "  var B = s.Bottomy;\n";
              inner += "  var HI = vall(val_gbx_hi.value, true, -1, s);\n";
              inner += "  var TH = vall(val_gbx_th.value, true, -1, s);\n";
              inner += "  var X =  ((getVal(ch_sett_center)) ? s.CenterX : s.RotationCenterX );\n";
              inner += "  var Y =  ((getVal(ch_sett_center)) ? s.CenterY : s.RotationCenterY );\n";
              //Случайный номер от 1000 до 10000 для именования деталей
              inner += "  var rnd_num = Math.floor(Math.random() * 90000) + 10000;\n";
              //Если этот номер уже там есть
              inner += "  var tmpNum = genNum(s.name);";
              inner += "  var sNum = (tmpNum>0) ? tmpNum : 0;\n";

              inner += "\n";
        } 
            var params = parseParamsLine(ffile);
            for (var lind=0;lind<params.length;lind++){
                inner += params[lind]+"\n";
            }
        
            if (Shift()!=7) inner = replaceAll(inner, "\n", "");
            for (var lind=0;lind<ffile.length;lind++){
              var txt = ffile[lind];
              if (txt.indexOf('//')<0 || txt.indexOf('//')>3) inner += replaceLimitStrict(txt) + "\n";
            }
        if (!noOS){
            if (!noduplicateS) inner += "  if (vbgetExist(S.shape)) if (getSstring(S.shape)==sstring) S.del();\n";
            inner += "  if(vbgetExist(s)){\n";
            if (!noMove) inner += "  s.OrderToFront();\n";
            inner += "  if (toDel)s.Delete();\n else if(addShape)sr.Add(s);}}\n";//end of if(vbgetExist(s)) обоих
            inner += "  if (sstop){ "+(noduplicateS ? "sr.AddRange(OS);" : "")+" break;}\n";
        inner += "}\n";//end of for (var sindex=1; sindex<=OScnt;sindex++)
      inner += "}\n";//end of OS.Shapes.Count>0
      }
  inner += "return sr;}";

  var oldScript = document.getElementById(scriptId);
  if (oldScript)  oldScript.parentNode.removeChild(oldScript);
  if (Shift()==7) {dbg(); dbg(escapeHtml(inner, true));}

 //dbg(escapeHtml(inner, true)); // для отладки

  // Создание и вставка <script>, чтобы код реально исполнился
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.id = scriptId;
  script.text = inner;
  document.body.appendChild(script);

  // Вызов сгенерированной функции
  if (doit && typeof window[funcName] === 'function')  return window[funcName](OS, shft);
  return get_EOS();
}


 tmrs.push({name:"end_gbx",time:new Date().getTime()});