/******* Woodman Docker for CorelDraw Copyright (c) by DukereD 2025 mailto: laserman@tut.by *******/
var version = '3.04.05';
var host = window.external.Application;
var glOptim = false;
var glUnit = 3;
var glSelect = undefined;
var glMemory = undefined;
var glDbg = false;
var glFullDbg = false;
var glDBGMsg = '';
var glruUnit = gl_units[glUnit];
var glenUnit = gl_enunits[glUnit];
var glShift = 99;
var glStyle = "";
var glAddonPath = host.Application.AddonPath + 'wpanel/';
var master = null;
var mastercont = null;
var template_add_btn = null;
var domove = false;
var in_main = document.title.substring(0,14)=="Woodman Docker";
var CR = chr(10)+chr(13);
var tg60 = 1.73205080757;
var readact = [];
var applang = host.Application.UILanguageCode.substring(0,2).toLowerCase();
if(!vbRead('lang')){
	vbWrite('lang',applang);
	vbWrite('cat_settings','true');
}
if(!vbRead('cats')){
	vbWrite('cats','title_cat_calc/title_cat_colors/title_cat_contur/title_cat_autogroup/title_cat_master/title_cat_sizes/title_cat_raspred/title_cat_punktir/title_cat_nest/title_cat_print/title_cat_webcam/title_cat_actions/title_cat_save/title_cat_text/title_cat_kbx/title_cat_template/title_cat_info');
	vbWrite('ch_show_title_cat_webcam','false');
	vbWrite('ch_show_title_cat_info','false');
}

var cLang = vbRead('lang');
if (!cLang) cLang = applang;

//cLang="ru";

var glSkeys = ["","Shift","Ctrl","Ctrl+Shift","Alt","Alt+Shift","Ctrl+Alt","Ctrl+Alt+Shift",]

var head  = document.getElementsByTagName('head')[0];

/*
var link  = document.createElement('script');
link.type = 'text/javascript';
link.src = 'langs/ru.js';
head.appendChild(link);
*/

if (cLang!='ru'){
	var link  = document.createElement('script');
	link.type = 'text/javascript';
	link.src = 'langs/' + cLang + '.js';
	head.appendChild(link);
    
}

var link  = document.createElement('script');
link.type = 'text/javascript';
langcosrc = (vbfileExist(glAddonPath + 'langs/colors/color_'+cLang+'.js')) ? cLang : 'en';
link.src = 'langs/colors/color_' + langcosrc + '.js';
head.appendChild(link);

defdoc();


function sel_folder(elem, files){
	if(files === undefined) files = "All Files(*.*)|*.*";
	var fldr = vbTemplPath(elem.value,lang[elem.id], files);
	if (fldr.length>3) {
		elem.value = fldr;
		do_save(elem);
	}
}

function  set_vals(elname, elvalue, flag){
    if (flag=="true" || flag===true){
        switch (elname){
            case "webcam_no":
                var web_no = elvalue;
                webcam_fhd.checked = (vbRead("webcam_fhd_" + web_no)) ? true : false;
                webcam_gapx.value = vbRead("webcam_gapx_" + web_no);
                webcam_gapy.value = vbRead("webcam_gapy_" + web_no);
                webcam_bwi.value = vbRead("webcam_bwi_" + web_no);
                webcam_bhi.value = vbRead("webcam_bhi_" + web_no);
                break;
        }
    }
}

function make_selection (type){
    do_begin("make_selection " + type);
    var sr = do_selection(type);
    setGlobalSelection(sr);
    do_end();
}

function do_selection(type, shft, sample, OS, ingroup, setall){
    if (!defdoc()) return null;
	do_events("button_make_selection "+ type );
    if(shft === undefined) shft = Shift();
    if(sample === undefined) sample = false;
    if(ingroup === undefined) ingroup = isShift(shft);
    if(setall === undefined) setall = false;
	//host.ActiveDocument.ClearSelection();
	var sr = host.ActiveSelectionRange;
    sr.RemoveAll();
    var tquery = "";
    var bytype = false;
    var doquery = true;

	var simpleobj = " and @com.type<7 and @com.powerclip=null and @com.type!=5 and @com.effect==null and @com.effects.count=0 and @com.parentgroup.type!=13";
    var newType = (type instanceof Array) ? type : [type];
    var sl = newType.length;
    if(glFullDbg) dbg("sl:" + sl + " - " + newType + " - " + typeof(type) + " - " + typeof(newType));
    if(sl>1 && sample){
        for (var i=0;i<sl;i+=3){
            var str = newType[i].toLowerCase();
            var sgn = newType[i+1];
            if (sgn instanceof Array){
                if(glFullDbg) dbg("in split:" + str);
                switch (str){
                    case "fntsize": if (sample.Type==6) tquery += "@com.type=6 and (@com.text.story.size-"+replaceAll(sample.Text.Story.Size,",",".")+")."+abs[0]+abs[1]+abs[2];break;
                    case "w": tquery += "(@width.value-"+replaceAll(sample.SizeWidth,",",".")+")."+sgn[0]+sgn[1]+sgn[2]; break;
                    case "h": tquery += "(@height.value-"+replaceAll(sample.SizeHeight,",",".")+")."+sgn[0]+sgn[1]+sgn[2]; break;
                    case "l": tquery += (isDCurve(sample)) ? "(@com.displaycurve.length-"+replaceAll(sample.DisplayCurve.length,",",".")+")."+sgn[0]+sgn[1]+sgn[2] : ""; break;
                    case "a": tquery += (isDCurve(sample)) ? "(@com.displaycurve.area-"+replaceAll(sample.DisplayCurve.Area,",",".")+")."+sgn[0]+sgn[1]+sgn[2] : ""; break;
                    case "owi": tquery += "(@outline.Width().convert('mm').value-"+replaceAll(sample.Outline.Width,",",".")+")."+sgn[0]+sgn[1]+sgn[2]; break;
                }
            }else{
                if(glFullDbg) dbg("no split:" + str + " - " + sgn);
                switch (str){
                    case "fntsize": if (sample.Type==6)  tquery += "@com.type=6 and @com.text.story.size"+sgn+replaceAll(sample.Text.Story.Size,",","."); break;
                    case "fnt": if (sample.Type==6) tquery += "@com.type=6 and @com.text.story.font='" + sample.Text.Story.Font + "'"; break;
                    case "w": tquery += "@width.value"+sgn+replaceAll(sample.SizeWidth,",","."); break;
                    case "h": tquery += "@height.value"+sgn+replaceAll(sample.SizeHeight,",","."); break;
                    case "l": tquery += (isDCurve(sample)) ? "@com.displaycurve.length"+sgn+replaceAll(sample.DisplayCurve.length,",",".") : ""; break;
                    case "a": tquery += (isDCurve(sample)) ? "@com.displaycurve.area"+sgn+replaceAll(sample.DisplayCurve.Area,",",".") : ""; break;
                    case "f": tquery += (sample.Fill.Type==1) ? "@fill.Color()="+get_color_info(sample.Fill.UniformColor)['hint'] : "@fill.Type()='none'"; break;
                    case "o": tquery += (sample.Outline.Type==1) ? "@outline.Color()="+get_color_info(sample.Outline.Color)['hint'] : "@outline.Type()='none'"; break;
                    case "owi": tquery += "@outline.Width().convert('mm').value"+sgn+""+sample.Outline.Width; break;
                }
            }
            if (newType[i+2]) if (tquery.length>10) tquery += " " + newType[i+2] + " ";
        }
    }else{
        switch (newType[0]){
            //tquery = get_Shift("", "", "", "");
            //case "sel_closae_open": sr = (shft==2 || shft==3) ? do_each("sel_open") : do_each("sel_close"); doquery = false; break;
            case "text":
                if (shft==10){
                    doquery = false;
                }else{
                    tquery = get_Shift("@type = 'text:artistic' or @type = 'text:paragraph'", "@type!='text:artistic' and @type!='text:paragraph'", "@type='text:artistic'", "@type='text:paragraph'", shft); break;
                }
            case "sel_close_open": tquery = get_Shift("@com.displaycurve.closed" + simpleobj, "!@com.displaycurve.closed and @com.displaycurve!=null", "@com.type=3", "@com.type!=3" + simpleobj, shft); break;
            case "curve": tquery = get_Shift("@type = 'curve'", "@com.type!=3" + simpleobj, shft); break;
            case "powerclip": tquery = get_Shift("@com.powerclip!=null", "@com.powerclip=null", "@com.powerclip.shapes.count=0", "@com.powerclip.shapes.count>0", shft); break;
            case "sel_fill_no":  tquery = get_Shift("@fill.type = 'uniform'", "@fill.type = 'none'", "@fill.type = 'fountain'", "@com.transparency.type = 1", shft); break;
            case "sel_outl_no": tquery = get_Shift("@outline.type = 'solid'", "@outline.type = 'none'", "@outline.type = 'dot-dash'", "@outline.type = 'enhanced'", shft); break;
            case "sel_images": tquery = get_Shift("@type = 'bitmap'", "@type != 'bitmap'", "@com.transparency.type = 1 and @type = 'bitmap'", "@com.transparency.type = 0 and @type = 'bitmap'", shft); break;
            case "sel_effect_no":
                if(shft==4 || shft==5){
                    sr = do_each("break_effect");
                    doquery = false;
                }else{
                    tquery = get_Shift("@com.effect!=null or @com.effects.count>0", "@com.effect==null and @com.effects.count=0 and @com.parentgroup.type!=13", "", "", shft);
                }
            break;
            case "sel_lock": var OS = get_OS(true, true, false, undefined, ["locked"]); sr = (shft==2 || shft==3) ? do_each("sel_unlock",'', OS) : do_each("sel_lock",'', OS); doquery = false; break;
            default: bytype = true;	break;
        }
    }
    if (doquery){
        if (OS === undefined) var OS = (newType[0]=="group") ? host.ActiveSelectionRange : get_OS(true, setall, false, ingroup);
         var query =  (bytype) ? "@type='" + newType[0] + "'" : tquery;
         if((shft==2 || shft==3) && bytype){
            query = replaceAll(query,"=","!=");
            query = replaceAll(query,"or","and");
        }
        //query += " and @name!='mazafakereptyname'";
        if(glFullDbg) dbg(tquery);
        sr = vbdoQuery (OS.Shapes, query, ingroup);
    }
	return sr;
}


function make_each(name, prams, OS, shft, ingroup, undogroup){
    //функция для вызова их интерфейсов или выбора объектов
    if(name === undefined) name = false;
	if(prams === undefined) prams = [];



	if(OS === undefined) OS = get_OS();
	if(shft === undefined) shft = Shift();
	if(ingroup === undefined) ingroup = isShift(shft);
	if(undogroup === undefined) undogroup = true;

    var sr = do_each(name, prams, OS, shft, ingroup, undogroup);

    if(!inArray(name,["set_sizes","set_sizes", "corners_off"])){
        if (sr.Shapes.Count>0) setGlobalSelection(sr);
    }
    do_cure();
    return sr;
}

function do_each(name, param, OS, shft, ingroup, undogroup){
    //функция для внутреннего вызова
	if(name != undefined && host.ActiveDocument!=null){

    // var stmr1 = new Date().getTime()/1000;
    // var stmr2 = new Date().getTime()/1000;
    // alert(stmr2-stmr1);
    // var stmr1 = new Date().getTime()/1000;

		do_events(name);
        if(name === undefined) name = false;
        if(param === undefined) param = [];
        if(shft === undefined) shft = Shift();
        if(ingroup === undefined) ingroup = isShift(shft);
        if(undogroup === undefined) undogroup = true;
        if(OS === undefined) OS = get_OS(true, undefined,undefined,ingroup);

		var sr = get_EOS();
		if(OS.Shapes.Count>0){
		    var doeachsec1 = new Date().getTime()/1000;
			var doeach=true;
			if (name!="repeat_last") do_begin(name,undogroup, glOptim);
			var ch_lst = false;
			var glst = OS.FirstShape;
			var gfst = OS.LastShape;
			for (var i=1;i<=OS.Shapes.Count;i++){
				if (OS.Shapes(i).Shapes.Count==0) {
					var fst = OS.Shapes(i);
					if(!ch_lst) lst = OS.Shapes(i);
					ch_lst = true;
				}
			}
			var mlst = isMaster();
			if(shft==7 && name!="make_sizes" || shft==5 && name=="mashtab_set_size" || !isMaster() && inArray(name,["master_replace", "master_setprop","container_change", "master_crc"])){
				mlst = OS.FirstShape;
				if (name!="master_select") OS = ShapeRemove(OS,mlst);
			}

            //селектор предварительных действий до цикла
			switch(name){
				case "make_contur":
					if(param[3] === undefined) param[3] = getVal(ch_cont_sep);
					if(param[4] === undefined) param[4] = (shft==3) ? !getVal(ch_cont_del) : getVal(ch_cont_del);
					if(param[5] === undefined) param[5] = getVal(ch_cont_round);
					if(param[6] === undefined) param[6] = getVal(ch_cont_reduce);
					if(param[7] === undefined) param[7] = getVal(ch_cont_cut);
					if(param[8] === undefined) param[8] = getVal(ch_cont_smart);
					if(param[9] === undefined) param[9] = getVal(ch_cont_nofil);
					if(param[10] === undefined) param[10] = getVal(ch_cont_layers);
					if(param[11] === undefined) param[11] = getVal(ch_cont_focus);
					break;
				case "perimetr_get_size":val_perimetr.value = fst.DisplayCurve.Length*wScale; do_save(val_perimetr); doeach = false; break;
				case "perimetr_set_size":do_save(val_perimetr); break;
				case "punkt_get_dash": if(isDCurve(fst)) val_punkt_dash.value = fst.DisplayCurve.Segments.Count; do_save(val_punkt_dash); doeach = false; break;
				case "master_select": masterArea = (mlst) ? maxSPArea(mlst) : 0; break;
                case "collect_text": firt = false; break;
                case "round": if (shft==4){ OS.CustomCommand("ConvertTo", "JoinCurves", vall(param)); doeach = false;} break;
                case "master_crc": var mlst_crc = getShapeCRC(mlst, getVal(ch_master_rotate)); break;
                case "set_outl" : OS.SetOutlineProperties(762, undefined, param); break;
                case "set_fill" : OS.ApplyUniformFill(param);  break;
                case "change_thikness":
                    do_save(val_kbx_change_old);
                    do_save(val_kbx_change_new);
                    do_save(val_kbx_pup_dif);
                    break;
                case "replace_text":
                case "search_text":
                    var replace_arr = [];
                    if (shft>1 && (!isAlt(shft) || shft==5)){
                        OS = OS.ReverseRange;
                        if (OS.Shapes(1).type==6){
                            var p1 = OS.Shapes(1).Text.Story.Text.split("\r");
                            var cnt_src = p1.length;
                            var xlsmode = false;
                            var isShortList = false;
                            if (cnt_src>1 && param[1]!=undefined){
                                var astx = p1[0].split("\t");
                                if (astx.length==p1[1].split("\t").length && astx.length>1){
                                    var xlsmode = true;
                                    var tcnt = astx.length;
                                    if (shft==5){
                                        for (var ti=0;ti<tcnt;ti++){
                                                var stx = replaceAll(astx[ti],"trims");
                                                host.ActiveLayer.CreateArtisticText(OS.CenterX, OS.BottomY-15*(ti+1), stx, undefined, undefined, undefined, 24);
                                        }
                                        doeach = false;
                                    }else{
                                        for (var pi=0;pi<cnt_src;pi++){
                                            var artx = p1[pi].split("\t");
                                            if (artx.length>=tcnt){
                                                for (var ti=0;ti<tcnt;ti++){
                                                    var idx = (pi-1)*tcnt+ti;
                                                    var rtx = replaceAll(artx[ti],"trims");
                                                    var stx = replaceAll(astx[ti],"trims");
                                                    //alert(rtx);
                                                    if (stx.length>0) replace_arr[idx] = [stx, rtx];
                                                }
                                            }
                                        }
                                        if (replace_arr.length<2) xlsmode = false;
                                    }
                                }
                            }
                            if (!xlsmode) {
                                for (var pi=0;pi<cnt_src;pi++){
                                    var stx = replaceAll(p1[pi],"trims");
                                    if (stx.length>0) replace_arr[pi] = [stx];
                                }
                                if (param[1]!=undefined && OS.Shapes(2).type==6){
                                    var p2 = OS.Shapes(2).Text.Story.Text.split("\r");
                                    if (cnt_src!=p2.length) isShortList = true;
                                    for (var pi=0;pi<p2.length;pi++){
                                        var idx = pi;
                                        //var rtx = replaceAll(p2(pi).Text,"trims");
                                        stx = (replace_arr[pi]) ? replace_arr[pi][0] : replace_arr[pi % cnt_src][0];
                                        if (stx.length>0) replace_arr[pi] = [stx, p2[pi]];
                                    }
                                    if (param[1]!=undefined) OS.Remove(1);
                                }
                            }
                            OS.Remove(1);
                        }
                        OS = OS.ReverseRange;
                    }else{
                        replace_arr[0] = (param[1]!=undefined) ? [param[0], param[1]] : [param[0]];
                    }
                    //alert(replace_arr);
                    break;
				case "set_sizes":
					do_save(val_sizes_wi); do_save(val_sizes_hi);
					if (shft==2){
                        if (getVal(ch_sizes_rotate) && glst.Shapes.Count==0){
                            var rx = glst.RotationCenterX;
                            var ry = glst.RotationCenterY;
                            ang = max_ang(glst, true);
                            glst.Rotate(-ang);
                        }
						val_sizes_wi.value = glst.SizeWidth*wScale;
						val_sizes_hi.value = glst.SizeHeight*wScale;
                        if (getVal(ch_sizes_rotate) && glst.Shapes.Count==0){
                            glst.SetRotationCenter(rx,ry);
                            glst.Rotate(ang);
                        }
						doeach = false;
					}
					break;
				case "numerate":
					if(!getVal(ch_num_reverse)) OS = OS.ReverseRange;
                    if (getVal(ch_num_bycolor)) var numcolor = [];
					var num_templ=val_num_templ.value;
					var num_cnt=vall(val_num_start.value,false, 0);
					var num_step=vall(val_num_step.value,false, 0);
					var num_digs=vall(val_num_digs.value,false, 0);
				break;
				case "make_sizes":
					if (shft!=6){
						if (getVal(ch_sizes_hor)){
        					OS.CreateSelection();
							dr = (isCtrl(shft) && shft!=7) ? "up" : "dn";
							if (getVal(ch_sizes_betw)) dr +="b";
							vbMakeSize(dr, shft);//, getVal(ch_sizes_center));
						}
						if (getVal(ch_sizes_ver)){
                            OS.CreateSelection();
							dr = (isCtrl(shft) && shft!=7) ? "ri" : "lf";
							if (getVal(ch_sizes_betw)) dr +="b";
							vbMakeSize(dr, shft);//, getVal(ch_sizes_center));
						}
					}else{
                        OS.Shapes.FindShapes(undefined, 14, isShift(shft)).Delete();
					}
                    doeach = false;
				break;
				case "freza":
					var freza_R = vall(val_freza.value)/2;
					var freza_Rk = freza_R * 4 / 3;
					inp=false;
					if((shft==4 || shft==5) && !getVal(ch_freza_corners)){
						inp = prompt(lang["freza_title"],freza_R * 4 * wScale);
					}else if (shft==6){//Проверка прохода фрезы
                        var oscnt = OS.Shapes.Count;
                        var s = (oscnt==1) ? OS.Shapes(1) : OS.Group();

                        if (param=="in"){
                            var fir_cont = "in";
                            var sec_cont = "out";
                            var fgap = -0.01;
                        }else{
                            var fir_cont = "out";
                            var sec_cont = "in";
                            var fgap = 0.01;
                        }
                        //alert((freza_R+fgap) + "_" + fir_cont);
                        var sf = dos_contur(s,vall(freza_R+fgap), fir_cont, undefined, true, false,true,false,false,false);
                        if (sf.SizeWidth!=s.SizeWidth){
                            sf = dos_contur(sf,freza_R, sec_cont, undefined, true, true, true,false,false,false);
                            sf.Fill.ApplyUniformFill(host.CreateRGBColor(255, 0, 0));
                        }else{
                            alert(lang['freza_to_low_gap']);
                        }
                        if (oscnt>1) s.Ungroup();
                        doeach = false;
                    }
				break;
				case "rotate":
					var mang = vall(param,false);
					if(param=="ang"){
                        if (isAlt(shft)){
                            mang = glst.RotationAngle;
                            OS.Remove(1);
                        }else{
                            var se = vbgetClick();
                            if (se[0]==1) {doeach = false; break;}
                            mang = FindSegXY(se[1],se[2], host.ActivePage.SelectShapesAtPoint(se[1],se[2], false)).StartingControlPointAngle;
                            if (mang > 180) mang -= 180;
                            if(se[3]==2) mang *= -1;
                        }
					}else if(param>0){
						if(isAlt(shft))	mang *= -1;
					}
				break;
                case "make_punktir":
					do_save(val_punkt_dash);
					do_save(val_punkt_gap);
					if(shft==4){
						doeach = false;
						var se = vbgetClick();
						if (se[0]==1) break;
						var seg = FindSegXY(se[1],se[2], host.ActivePage, true);
						if(seg){
                            var punkt_dash = vall(val_punkt_dash.value,false,0);
							for(var k=1;k<punkt_dash;k++){
								kf = 1-1/(punkt_dash-k+1);
								seg.AddNodeAt(kf,1);
							}
						}
					}
				break;
				case "mashtab_set_size":
                    if (isCtrl(shft) && fst.DisplayCurve.Closed){
                        var len = maxSPArea(fst);
                        var inp = (mlst) ? maxSPArea(mlst) : prompt(lang["mashtab_title"],len * wScale);
                        var are = true;
                    }else{
                        var len = (!isSimpleShape(fst) || fst.DisplayCurve.Closed) ? max_size(fst) : fst.DisplayCurve.Length;
                        var inp = (mlst) ? lastSize(mlst) : prompt(lang["mashtab_title"],len * wScale);
                        var are = false;
                    }
					if (inp>0){
						var coef = vall(inp,undefined,undefined, OS) / len;
                        if (are) coef = Math.sqrt(coef);
						if (shft!=12) OS.SizeWidth = OS.SizeWidth * coef;
						if (shft!=11) OS.SizeHeight = OS.SizeHeight * coef;
					}
					doeach = false;
				    break;
                case "find_wide":
                    if (param[0]===undefined) param[0] = vall(getVal("ch_wide_accu"),false);
                    if (param[1]===undefined && getVal(ch_wide_numtempl)) param[1] = val_num_templ.value;
                    if (param[2]===undefined && getVal(ch_wide_numtempl)) param[2] = (shft==2);
                    break;
			}
			if(doeach){
                var excolor = [];
                var colcnt = 0;
				for(var sind=1;sind<=OS.Shapes.Count;sind++){
					var s = OS.Shapes(sind);
                    var globalsRotationX = s.RotationCenterX;
                    var globalsRotationY = s.RotationCenterY;
                    var return_center = false;
					if(vbgetExist(s)){
						if(s.Locked){
							switch(name){
								case "sel_lock": sr.add(s); break;
								case "sel_unlock": if(s.Locked) {s.Locked=false; sr.add(s); }break;
							}
						}else{
							switch(name){
								case "sel_rectangle":if(s.Type==1) sr.add(s); break;
								case "sel_norectangle":if(s.Type!=1) sr.add(s); break;
								case "sel_ellipse":if(s.Type==2) sr.add(s); break;
								case "sel_noellipse":if(s.Type!=2) sr.add(s); break;
								case "sel_curve":if(s.Type==3) sr.add(s); break;
								case "sel_nocurve":if(s.Type!=3) sr.add(s); break;
								case "sel_polygon":if(s.Type==4) sr.add(s); break;
								case "sel_nopolygon":if(s.Type!=4) sr.add(s); break;
								case "sel_images": if(s.Type==5) sr.add(s); break;
								case "sel_noimages": if(s.Type!=5) sr.add(s); break;
								case "sel_text":if(s.Type==6) if(mlst){if (mlst.Text.Story.Font==s.Text.Story.Font) sr.add(s);} else sr.add(s); break;
								case "sel_notext":if(s.Type!=6) sr.add(s); break;
								case "sel_close":if(s.DisplayCurve!=null) if (s.DisplayCurve.Closed) sr.add(s); break;
								case "sel_open":if(s.DisplayCurve!=null) if (!s.DisplayCurve.Closed) sr.add(s); break;
								case "sel_fill":if(s.Type!=7 && s.Fill.Type==1) if(mlst){ if(mlst.Fill.Type==s.Fill.Type) if (mlst.Fill.UniformColor.RGBValue==s.Fill.UniformColor.RGBValue) sr.add(s);} else sr.add(s); break;
								case "sel_otherfill":if(s.Type!=7 && s.Fill.Type>1) sr.add(s); break;
								case "sel_nofill":if(s.Fill.Type==0) sr.add(s); break;
								case "sel_outl":if(isSimpleShape(s,[6]))if(s.Outline.Type>0) if(mlst){if (mlst.Outline.Color.RGBValue==s.Outline.Color.RGBValue && mlst.Outline.Width==s.Outline.Width) sr.add(s);} else sr.add(s); break;
								case "sel_nooutl":if(isSimpleShape(s,[6]))if(s.Outline.Type==0) sr.add(s); break;
								case "sel_image_trans": if(isSimpleShape(s,[6]))if(s.Outline.Type>0) sr.add(s); break;
								case "sel_effect": if(s.Effects.Count > 0) sr.add(s); break;
								case "sel_noeffect": if(s.Effects.Count == 0) sr.add(s); break;
								case "sel_power": if(s.PowerClip) sr.add(s); break;
								case "sel_nopower": if(!s.PowerClip) sr.add(s); break;
								case "sel_delete": s.Delete(); break;
								case "s_flip_h":  s.Flip(1); break;
								case "s_flip_v":  s.Flip(2); break;
                                case "find_wide": sr.Add(each_find_wide(s, param[0], param[1], param[2])); break;
                                case "sel_toup": if (s.ParentGroup != null) s.OrderFrontOf(s.ParentGroup.Shapes.First); else s.OrderToFront(); break;
                                case "sel_todown": if (s.ParentGroup != null) s.OrderBackOf(s.ParentGroup.Shapes.Last); else s.OrderToBack(); break;

								case "make_punktir":
                                    sr.Add(dos_punktir(s,vall(val_punkt_dash.value, getVal(radio_punktir_size)),vall(val_punkt_gap.value, getVal(radio_punktir_size)),getVal(radio_punktir_size),getVal(ch_punkt_trim),getVal(ch_punkt_del),getVal(ch_punkt_join),getVal(ch_punkt_line)));
                                    return_center = true;
                                    break;
								case "rotate":
                                    sr.Add(dos_rotate(s,mang,param,getVal(ch_rotate_rel)));
                                    return_center = true;
                                    break;
								case "repeat_last": s.CreateSelection(); host.ActiveDocument.Repeat(); sr.add(s); break;
								case "make_contur":
                                        return_center = true;
                                        if(s.Effects.Count==0){
                                            if (shft==4 || shft==5){
                                                s.ConvertToCurves();
                                                if (isDCurve(s)){
                                                    s.Curve.Segments.All().SetType(1);
                                                    s.Curve.AutoReduceNodes(vall(param[0],  false, 0));
                                                }
                                            }else if(shft==12){
                                                s.Outline.Width = vall(param[0],false,undefined,s,"o");
                                            }else if(shft==13){
                                                var cgap = vall(param[0],undefined,undefined,s);
                                                if (param[1]<1) cgap*=-1;
                                                s = host.ActiveLayer.CreateRectangle(s.LeftX-cgap, s.BottomY-cgap, s.RightX+cgap, s.Topy+cgap);
                                            }else{
                                                s = dos_contur(s, vall(param[0],undefined,undefined,s),param[1],param[2],param[3],param[4],param[5],param[6],param[7],param[8],param[9],param[10],param[11]);
                                                sr.Add(s);
                                            }
                                        }
                                        break;
                                case "qrcodes":
                                    if (s.Type==6){
                                        if (s.Text.Story.Paragraphs.Count==1 && s.Text.Story.length>0){
                                            txt = vbget_qrcode(s.Text.Story.Text, param[0], param[1], param[2], param[3]);
                                            if (txt){
                                                var txtok = true;
                                                if (param[2]=="orcascan"){
                                                    txtok = false;
                                                    var tcnt = txt.Shapes.Count;
                                                    if (tcnt>0 && tcnt!=3){
                                                        txt.Shapes(tcnt).Delete();
                                                        if(inArray(param[0],["QRCode","DataMatrix","Aztec","PDF417"])){
                                                            txt.Shapes(1).Locked = false;
                                                        }else{
                                                            txt.Outline.ConvertToObject();
                                                            vbdoQuery(txt.Shapes,"!@com.displaycurve.closed").Delete();
                                                        }
                                                        txtok = true;
                                                    }
                                                }else if (param[6]){
                                                    var delback = (param[2]=="bwipjs" || param[2]=="tec-it" && !inArray(param[0],["PDF417","EAN8","EAN13"])) ? false : true;
                                                    var txt2 = txt.Bitmap.Trace(5,40,98,2,0,2,true,delback,delback).Finish().UngroupAllEx();
                                                    if (txt2){
                                                        if (delback) txt2.ApplyUniformFill(host.CreateCMYKColor(0,0,0,100));
                                                        txt = txt2.Group();
                                                    }
                                                }
                                                if (txtok){
                                                    var ang = 0;
                                                    if (s.RotationAngle!=0){
                                                        var ang = s.RotationAngle;
                                                        var sd = s.Duplicate()
                                                        sd.RotationAngle = 0;
                                                        var sw = sd.SizeWidth;
                                                        var sh = sd.SizeHeight;
                                                    }else{
                                                        var sw = s.SizeWidth;
                                                        var sh = s.SizeHeight;
                                                    }
                                                    txt.SetSize(sw, (param[4]) ? undefined : sh);
                                                    if (ang!=0){
                                                        sd.Delete();
                                                        txt.Rotate(ang);
                                                    }
                                                    moveC(txt, s);
                                                    if (param[5]){
                                                        s.Delete();
                                                    }else{
                                                        s.Topy = txt.BottomY - s.SizeHeight*0.1;
                                                    }
                                                }else{
                                                    moveC(txt, s);
                                                    //txt.Delete();
                                                }
                                            }
                                        }
                                    }
                                    break;
								case "replace_text":
								case "search_text":
                                    var add = false;
                                    for (var li=0;li<replace_arr.length;li++){
                                        var stxt = replace_arr[li][0];
                                        if (s.Type == 6 && stxt!='no_way_muther_fucker' || isAlt(shft)){
                                            if (s.Type == 6 && isAlt(shft) && s.Name=="") s.Name = replaceAll(s.Text.Story.Paragraphs(1).Text,"trim");
                                            var txt = (isAlt(shft)) ? s.Name : s.text.Story.text;
                                            if (txt.indexOf("---===### ")<0){
                                                var rm = [];
                                                var isReplace = false;
                                                if (replace_arr[li][1]!=undefined){
                                                    isReplace = true;
                                                    rtxt = replace_arr[li][1];
                                                    rtxt = rtxt.replace("\\r","\r");
                                                    rtxt = rtxt.replace("\\n","\n");
                                                    rtxt = rtxt.replace("\\t","\t");
                                                    var regr = new RegExp("\\(\\$(\\d)([\\+\\-\\*\\/])([\\d\\.,]*\\d)\\)", "g");
                                                    var rmatch = rtxt.match(regr);
                                                    if (rmatch){
                                                        for (var ri=0;ri<rmatch.length;ri++){
                                                            if (rmatch[ri].match(regr)) rm[RegExp.$1] = [RegExp.$2,RegExp.$3];
                                                        }
                                                    }
                                                }

                                                var rflags  = (getVal(ch_text_case)) ? "g" : "gi";
                                                var reg = new RegExp(stxt, rflags);
                                                var fndmatch = txt.match(reg);
                                                if(fndmatch!=null){
                                                    var match = (isReplace) ? (stxt.length>0) ? txt.replace(reg, rtxt) : rtxt : fndmatch;
                                                    if (match.length==0 && xlsmode) match = "---===### "+stxt+" ("+parseInt(li/tcnt + 1)+") ###===---";
                                                    if (rm.length>0 && isReplace){
                                                        for (var ri=0;ri<fndmatch.length;ri++){
                                                            if (fndmatch[ri].match(reg)){
                                                                var res=[];
                                                                var m = [,RegExp.$1,RegExp.$2,RegExp.$3,RegExp.$4,RegExp.$5,RegExp.$6,RegExp.$7,RegExp.$8,RegExp.$9];
                                                                for (var mi=1;mi<10;mi++){
                                                                    if (m[mi] && rm[mi]){
                                                                        var a = m[mi].replace(",",".")*1;
                                                                        var b = rm[mi][1].replace(",",".")*1;
                                                                        switch (rm[mi][0]){
                                                                            case "+": res[mi] = a+b; break;
                                                                            case "-": res[mi] = a-b; break;
                                                                            case "*": res[mi] = a*b; break;
                                                                            case "/": res[mi] = a/b; break;
                                                                        }
                                                                        res[mi] = add_leads(res[mi],m[mi].length,"0");
                                                                        match = match.replace("("+m[mi]+rm[mi][0]+rm[mi][1]+")",res[mi]);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    if (getVal(ch_text_strong)){
                                                        if(txt.toLowerCase()==fndmatch[0].toLowerCase()) add = true;
                                                    }else{
                                                        add = true;
                                                    }
                                                    if (add) {
                                                        if (isReplace){
                                                            if (isAlt(shft)){
                                                                s.Name = match;
                                                            }else{
                                                                //s.text.Story.text = match;
                                                                for (var i=0; i<fndmatch.length; i++){
                                                                    s.Text.Replace(fndmatch[i], rtxt, getVal(ch_text_case));
                                                                }
                                                                //if(s.text.Story.text!=match) s.text.Story.text = match;
                                                            }
                                                            if (isShortList || xlsmode) replace_arr[li][0] = "no_way_muther_fucker";
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (add) sr.Add(s);
                                    break;
								case "import_by_path":
                                    if(s.Type==6){
                                        var fpath = s.text.story.text;
                                        if (vbfileExist(fpath)){
                                            var imp = vbImportFile(fpath);
                                            if (imp){
                                                moveC(imp,s);
                                                if (fpath.indexOf(".cdr")<3){
                                                    if (s.SizeWidth>s.SizeHeight){
                                                        imp.SetSize(s.SizeWidth);
                                                    }else{
                                                        imp.SetSize(undefined, s.SizeHeight);
                                                    }
                                                }
                                                s.Delete();
                                                s = imp;
                                            }
                                        }
                                    }
                                    break;
								case "collect_text":
                                    if(lst.Type==6 && s.Type==6){
                                        if(!firt){
                                            firt = (shft==0) ? host.ActiveLayer.CreateArtisticText(OS.LeftX, OS.BottomY-s.text.Story.Size/2, s.text.Story.text, undefined, undefined, s.text.Story.Font, s.text.Story.Size) : lst;
                                        }else{
                                            firt.text.Story.text += CR + s.text.Story.text;
                                        }
                                    }
                                    break;
								case "vert_text":
                                    if (s.Type == 6){
                                        var tx = "";
                                        for (var i=1;i<=s.text.Story.Characters.Count;i++){
                                            tx += s.text.Story.Characters(i) + CR;
                                        }
                                        //s.text.Story.text = tx;
                                        s.Text.Replace(s.text.Story.text, tx, false, 1,0);
                                    }
                                    break;
								case "txt_sample": if (s.type==6) s.Text.Story.Text = param; break;
								case "font_ch_size":
                                    if (s.type==6){
                                        var fnt_size = s.SizeWidth;
                                        s.SetSize(parseInt(fnt_size + fnt_size * 0.1 * ((shft==4) ? -1 : 1)));
                                        sr.Add(s);
								    }
                                    break;
								case "rotate_center":
									sadd = false;
									if (s!=glst && shft!=2) {
										if(getVal(ch_sett_center)){
											sx = glst.CenterX;
											sy = glst.CenterY;
										}else{
											sx = glst.RotationCenterX;
											sy = glst.RotationCenterY;
										}
										sadd = true;
									}else if(shft==2){
										sx = s.centerX;
										sy = s.centerY;
										sadd = true;
									}
									if (sadd){
										s.SetRotationCenter(sx,sy);
										sr.Add(s);
									}

								break;
								case "break_effect":
									if(s.Effects.Count>0){
										if (s.Effects(1).Type==9){/*check Lens*/
											s = s.ConvertToBitmapEx();
										}else{
											spr = s.Effects(1).Separate()(1);
											sr.Add(s);
											sr.Add(spr);
										}
									}
								break;
								case "perimetr_set_size":
									if (s.Shapes.Count==0){
										if (mlst){
											var siz  = lastSize(mlst,true);
										}else{
											var siz  = vall(val_perimetr.value,undefined, undefined, s,"L");
										}
                                        if (shft!=0 && shft!=7){
                                            s.ConvertToCurves();
                                            //siz = siz - s.Curve.Length;

                                            for (var i=1;i<=s.Curve.SubPaths.Count;i++){
                                                var sp = s.Curve.SubPaths(i);
                                                if (shft==2){
                                                    addLenSeg(sp, siz,true,false);
                                                }else if (shft==4){
                                                    addLenSeg(sp, siz,false,true);
                                                }else if (shft==6){
                                                    if (sp.Closed)
                                                        addLenSeg(sp, siz/2,true,true);
                                                    else
                                                        addLenSeg(sp, siz,true,true);
                                                }
                                            }

                                        }else{
                                            coef = siz/s.DisplayCurve.Length;
                                            s.SetSize (s.SizeWidth*coef, s.SizeHeight*coef);
                                        }

										do_save(val_perimetr);
										sr.add(s);
									}
								break;
								case "all_split":
                                    if (s.Type==6){
                                        if (shft!=4) sr.AddRange(break_all_txt(s, undefined, false));
                                    }else{
                                        s.ConvertToCurves();
                                        if(s.Effects.Count>0){
                                            if (s.Effects(1).Type==9){
                                                s.Effects(1).Clear();
                                                sr.Add(s);
                                            }else if(inArray(s.Effects(1).Type,[0,3,4])){
                                                sr.AddRange(s.BreakApartEx());
                                            }else{
                                                sr.AddRange (s.Effects(1).Separate);
                                            }
                                        }else if(s.PowerClip){
                                            var extr = s.PowerClip.ExtractShapes();
                                            if (shft==6 || shft==7) extr.Delete(); else sr.AddRange(extr);
                                            if (shft!=2 && shft!=3){
                                                sr.Add(host.ActiveLayer.CreateCurve(s.DisplayCurve));
                                            }
                                            s.Delete();
                                        }else{
                                            var rnd = getRandom(999999,100000,0);
                                            var nm = rnd + s.name;
                                            s.name = nm;
                                            s.BreakApart();
                                            sr.AddRange(host.ActivePage.Shapes.FindShapes(nm));
                                        }
                                    }
								break;
                                case "change_start_node":
                                    s.ConvertToCurves();
                                    for (si=1;si<=s.Curve.SubPaths.Count;si++){
                                        var sp = s.Curve.SubPaths(si);
                                        var lin = host.ActiveLayer.CreateLineSegment(sp.PositionX, sp.PositionY, s.RightX + 10, sp.PositionY);
                                        lin.SetRotationCenter(sp.PositionX, sp.PositionY);
                                        lin.RotationAngle = param[0];
                                        var cps = sp.GetIntersections(lin.Curve.SubPaths.First);
                                        lin.Delete();
                                        var moff = 0;
                                        var ind = 1;
                                        for (i=1;i<=cps.Count;i++){
                                            if (cps(i).Offset2 > moff){
                                                moff = cps(i).Offset2;
                                                ind = i;
                                            }
                                        }
                                        var cp = cps(ind);
                                        vbBreakSubPathAtXY(sp, cp.PositionX, cp.PositionY, param[1]);
                                    }
                                    s.Curve.JoinTouchingSubpaths();
                                break;
								case "select_no_colors":
								case "select_colors":
                                    var adda = [false,false,false,false,false,false];
                                    for (var key in param[3]){
                                        if(s.Type==7 && param[3][key] == 40) adda[3] = true;
                                        if(s.Type==5 && get_bitmap_mode(s.Bitmap)['mode']==param[3][key]) adda[3] = true;
                                        if(s.PowerClip && param[3][key]=='pwr') adda[3] = true;
                                    }
                                    for (var key in param[4]){
                                        if(s.Effect==null && param[4][key] == 90) adda[4] = true;
                                        if(s.Effect!=null && 20+s.Effect.Type==param[4][key]) adda[4] = true;
                                        if(s.Effects.Count>0) for (var ei=1;ei<=s.Effects.Count;ei++){
                                            if (20 + s.Effects(ei).Type == param[4][key]) adda[4] = true;
                                            if (40 + s.Transparency.MergeMode == param[4][key]) adda[4] = true;
                                        }
                                    }

                                    if(isSimpleShape(s, [6])){
                                        for(var key in param[0]) if ((s.Outline.Type > 0 && s.Outline.Color.HexValue == param[0][key]) || (s.Outline.Type == 0 && param[0][key] == 0)) adda[0] = true;
                                        for(var key in param[1]) if ((s.Fill.Type == 1 && s.Fill.UniformColor.HexValue == param[1][key]) || (s.Fill.Type == 0 && param[1][key] == 0)) adda[1] = true;
                                        for(var key in param[5]) if(s.Type==6) if (s.Text.Story.Font == param[5][key]) adda[5] = true;
                                        for(var key in param[2]) {
                                            skey = param[2][key].split(":");
                                            if (s.Fill.Type==2 && s.Fill.Fountain.Colors(0).Color.HexValue==skey[0] && s.Fill.Fountain.Colors(1).Color.HexValue==skey[1]) adda[2] = true;
                                        }
                                    }
                                    if (getVal(ch_selcol_strict)){
                                        add = true;
                                        for (var i=0;i<adda.length;i++) if (param[i].length>0 && adda[i]==false) add = false;
                                    }else{
                                        add = false;
                                        for (var i=0;i<adda.length;i++) if (adda[i]==true) add = true;
                                    }
                                    add = (name!="select_no_colors") ? add : !add;
                                    if(add) sr.add(s);
                                    //alert(shft);
                                    if (shft==15 || shft==16){
                                        if (s.Outline.Type > 0) s.Outline.Color.CopyAssign(s.Outline.Color.ValidDuotoneColor);
                                        if (s.Fill.Type > 0) sq.Fill.ApplyUniformFill(s.Fill.UniformColor.ValidDuotoneColor)
                                    }
                                    if (shft==10 && adda[0] || shft==11 && (adda[1] || adda[2])){

                                        var rcolor = "no";
                                        if (shft==10 && s.Outline.Type > 0){ rcolor = s.Outline.Color; var sz = OS.SizeHeight /  (param[0].length+1);}
                                        if (shft==11){ rcolor = s.Fill.UniformColor; var sz = OS.SizeHeight /  (param[1].length+param[2].length+1);}
                                        if(excolor[rcolor.HexValue]===undefined && rcolor!="no"){
                                            excolor[rcolor.HexValue] = "true";
                                            colcnt++;
                                            alert(rcolor.Name);
                                            var sq = host.ActiveLayer.CreateRectangle2(OS.RightX+sz, OS.TopY-colcnt*sz*1.1, sz, sz);
                                            if (shft==10) sq.Fill.ApplyUniformFill(rcolor);
                                            if (shft==11) sq.Fill.CopyAssign(rcolor);
                                            var stxt = host.ActiveLayer.CreateArtisticText(sq.RightX, sq.BottomY, rcolor.ValidDuotoneColor.SpotColorName, undefined, undefined, undefined, 24);
                                            stxt.SetSize(undefined, sz/3);
                                            moveC(stxt, sq.RightX+sz*0.2, sq.CenterY,false,"CL");

                                            //alert(rcolor.HexValue + "::" + excolor + ":" + Object.keys(excolor).length);
                                        }
                                    }

								break;
/*								case "select_no_colors":
									if(isSimpleShape(s)  && s.Type!=7){
										add = true;
										for(var key in param[0]){if ((s.Outline.Type>0 && (s.Outline.Color.HexValue!=key || key==0)) || (s.Outline.Type==0 && key!=0)){add = true;}}
										for(var key in param[1]){if ((s.Fill.Type>0 && (s.Fill.UniformColor.HexValue!=key || key==0)) || (s.Fill.Type==0 && key!=0)){add = true;}}
										if(add) sr.add(s);
									}
								break;
*/
                                case "container_change":
                                    if (mlst && isDCurve(s)){
                                        if (mlst.PowerClip){
                                            s = movePowerCont(mlst,s);
                                           //for (var ci=1; ci<=s.Clones.Count;ci++){
                                           //     movePowerCont(mlst,s.Clones(ci));
                                           //}
                                            sr.Add(s);
                                        }
                                    }
                                break;
                                case "container_update":
                                    if (isDCurve(s) && s.Clones.Count>0){
                                        sr.Add(movePowerCont(s,s));
                                    }
                                break;
								case "numerate":
									if (s.type==6){
                                        var pgi = s.Page.Index;
                                        var num_insert = num_cnt;
										var str= false;
										var tmpstr = s.text.story.text;
                                        if (getVal(ch_num_bycolor)){
                                            if(isCtrl(shft) && tmpstr.indexOf(num_templ) >= 0 || !isCtrl(shft) && tmpstr == num_templ){
                                                if (numcolor[pgi]===undefined) numcolor[pgi] = [];
                                                var okey = (s.outline.type===0) ? '0' : s.outline.color.hexvalue;
                                                var fkey = (s.fill.type===0) ? '0' : (s.fill.type===1) ? s.fill.UniformColor.hexvalue : s.fill.Fountain.Colors(1).Color.HexValue;
                                                var colorKey = okey+"_"+fkey;
                                                if (numcolor[pgi][colorKey]===undefined){
                                                    numcolor[pgi][colorKey] = num_cnt;
                                                    num_cnt += num_step;
                                                }
                                                num_insert = numcolor[pgi][colorKey];
                                            }
                                        }

										var nums = (getVal(ch_num_digs)) ? add_leads(num_insert, num_digs, 0) : num_insert;
                                        if(getVal(ch_num_prefix)) nums = getVal(val_num_prefix) + nums;
                                        if(getVal(ch_num_postffix)) nums = nums + getVal(val_num_postffix);
										
                                        if(isCtrl(shft)){
											while (s.text.story.text.indexOf(num_templ) >= 0) {
                                                s.Text.Replace(num_templ, nums, false, 1,0);                                                
                                                str = true;
                                            }
										}else{
                                            if (tmpstr == num_templ) {
                                                str = true;
                                                s.Text.Replace(tmpstr, nums, false, 1,0);
                                            }
										}
                                        if(str){
											//s.text.story.text = str;
											//s.Text.Replace(num_templ, nums, false, 1,0);
											if (!getVal(ch_num_bycolor)) num_cnt += num_step;
											sr.add(s);
										}
									}
								break;
								case "round":
                                    return_center = true;
									var arr_sel = [];
									var arr_smart = [];
                                    param = vall(param,undefined,undefined,s);
                                    if (shft!=4 && shft!=5){
                                        var bynode = false;
                                        if (s.Type==3){
                                            var maxx = s.LeftX;
                                            var minx = s.RightX;
                                            var maxy = s.BottomY;
                                            var miny = s.TopY;
                                            var selcnt=0;
                                            for(var i=1;i<=s.Curve.Nodes.Count;i++){
                                                nn = s.Curve.Nodes(i);
                                                if(nn.PrevSegment && nn.NextSegment && getVal(ch_cont_smart)){
                                                    if (Math.abs(nn.PositionX - maxx) < 1 || Math.abs(nn.PositionX - minx) < 1 || Math.abs(nn.PositionY - maxy) < 1 || Math.abs(nn.PositionY - miny) < 1){
                                                        arr_smart.push(i);
                                                        bynode = true;
                                                        if (nn.Selected) {
                                                            arr_sel.push(i);
                                                        }
                                                    }
                                                }else if (nn.Selected){
                                                    arr_sel.push(i);
                                                    bynode = true;
                                                }
                                            }
                                        }
                                        if (bynode){
                                            nr = s.Curve.Nodes.Range(1);
                                            nr.RemoveAll();
                                            if(getVal(ch_cont_smart) && arr_sel.length==0) arr_sel = arr_smart;
                                            for (var key in arr_sel){
                                                nr.AddRange(s.Curve.Nodes.Range(arr_sel[key]));
                                            }
                                            nr.Fillet(param);
                                        }else{
                                            s.Fillet(param);
                                        }
                                    }
									sr.add(s);
								break;
								case "master_select":
									if(mlst){
										gap = 0.01;
										if (getVal(ch_master_sel_h) && !getVal(ch_master_sel_w)){
											scomp = s.SizeHeight;
											mcomp = mlst.SizeHeight;
										}else if (!getVal(ch_master_sel_h) && getVal(ch_master_sel_w)){
											scomp = s.SizeWidth;
											mcomp = mlst.SizeWidth;
										}else{
											scomp = s.SizeHeight * s.SizeWidth;
											mcomp = mlst.SizeHeight * mlst.SizeWidth;
											if (mlst.DisplayCurve && s.DisplayCurve){
												if(mlst.DisplayCurve.closed && s.DisplayCurve.closed){
													scomp = maxSPArea(s);
													mcomp = masterArea;
													gap = 0.1;
												}else if(!mlst.DisplayCurve.closed && !s.DisplayCurve.closed){
													scomp = s.DisplayCurve.length;
													mcomp = mlst.DisplayCurve.length;
												}
											}
										}
										if (shft==2 || shft==3){
											less = (getVal(radio_master_sel_l)) ? scomp<=mcomp : true;
											more = (getVal(radio_master_sel_m)) ? scomp>=mcomp : true;
										}else{
											less = (getVal(radio_master_sel_l)) ? scomp<mcomp : true;
											more = (getVal(radio_master_sel_m)) ? scomp>mcomp : true;
										}
										if(shft==4)
											equal = (getVal(radio_master_sel_e)) ? scomp==mcomp : true;
										else
											equal = (getVal(radio_master_sel_e)) ? Math.abs(scomp-mcomp)<gap : true;
										if(less && more && equal) sr.Add(s);
									}
								break;
                                case "change_thikness":
                                    if (s.Type==3){
                                        sr.Add(s);
                                        var oldt = vall(val_kbx_change_old.value);
                                        var newt = vall(val_kbx_change_new.value);
                                        var dift = vall(val_kbx_pup_dif.value);
                                        do_points(s, "change_thikness", "all", [oldt, newt, dift], false);
                                    }
                                    break;
								case "set_sizes":
                                    if (isAlt(shft)){
                                        var wi = vall(val_sizes_wi.value);
                                        wi = (wi>0) ? (wi - s.SizeWidth)/2 : 0;
                                        var hi = vall(val_sizes_hi.value);
                                        hi = (hi>0) ? (hi - s.SizeHeight)/2 : 0;
                                        if (getVal(ch_sett_center)){
                                            var cx = s.CenterX;
                                            var cy = s.CenterY;
                                        }else{
                                            var cx = s.RotationCenterX;
                                            var cy = s.RotationCenterY;
                                        }
                                        if (isSimpleShape(s,[6])) s.ConvertToCurves();

                                        var oss = getInGroup(s.Shapes.All())
                                        if (oss.Shapes.Count==0) oss.Add(s);
                                        for (var ki=1;ki<=oss.Shapes.Count;ki++){
                                            var ss = oss.Shapes(ki);
                                            for (var i=1;i<=ss.Curve.Nodes.Count;i++){
                                                var nd = ss.Curve.Nodes(i);
                                                if (wi!=0) nd.positionX += (nd.positionX<cx) ? - wi : wi;
                                                if (hi!=0) nd.positionY += (nd.positionY<cy) ? - hi : hi;
                                            }
                                        }
                                    }else{
                                        var swi = s.SizeWidth;
                                        var shi = s.SizeHeight;
                                        //var wi = (mlst) ? mlst.SizeWidth : vall(val_sizes_wi.value,s, undefined, undefined, "W");
                                        //var hi = (mlst) ? mlst.SizeHeight : vall(val_sizes_hi.value,s, undefined, undefined, "H");
                                        var wi = vall(val_sizes_wi.value, undefined, undefined, s,"W");
                                        var hi = vall(val_sizes_hi.value, undefined, undefined, s,"H");
                                        var ndsel = 0;
                                        if (getVal(ch_sizes_rotate)){
                                            if(OS.Shapes.Count==1){
                                                if (s.Type==3){
                                                    ndsel = do_points(s,"size","noadd",[wi,hi], false);
                                                }
                                            }
                                        }
                                        if (ndsel==0){
                                            if (getVal(ch_sizes_rotate) && s.Shapes.Count==0){
                                                var rx = s.RotationCenterX;
                                                var ry = s.RotationCenterY;
                                                ang = max_ang(s, true);
                                                s.Rotate(-ang);
                                            }

                                            if (mlst && getVal(ch_master_sel_h) && !getVal(ch_master_sel_w)){
                                                wi=0;
                                            }else if (mlst && !getVal(ch_master_sel_h) && getVal(ch_master_sel_w)){
                                                hi=0;
                                            }

                                            var wi2 = wi;
                                            var hi2 = hi;

                                            //fstwi = val_sizes_wi.value.substring(0,1);
                                            //fsthi = val_sizes_hi.value.substring(0,1);

                                            //if (fstwi == "+" || fstwi == "-") wi2 = swi + wi;
                                            //if (fsthi == "+" || fsthi == "-") hi2 = shi + hi;

                                            if (wi == 0) wi2 = swi;
                                            if (hi == 0) hi2 = shi;
                                            if (hi == 0 && getVal(ch_sizes_aspect)) hi2 = shi * wi2 / swi;
                                            if (wi == 0 && getVal(ch_sizes_aspect)) wi2 = swi * hi2 / shi;
                                            s.SetSize (wi2, hi2);

                                            if (getVal(ch_sizes_rotate) && s.Shapes.Count==0){
                                                s.SetRotationCenter(rx,ry);
                                                s.Rotate(ang);
                                            }
                                        }
                                    }
									sr.Add(s);
								break;

                                case "corners_off":
                                    sr.add(s);
                                    do_points(s, "corners_off","all");
                                    break;
								case "freza":
                                    if (shft==6){//Проверка прохода фрезы

                                    }else{
                                        var cnt_sp = s.DisplayCurve.SubPaths.Count;
                                        for(var i=1;i<=cnt_sp;i++){
                                            var arr_sel = [];
                                            sp = s.DisplayCurve.SubPaths(i);
                                            for(var n=1;n<=sp.Nodes.Count;n++){
                                                nd = sp.Nodes(n);
                                                nX = nd.PositionX;
                                                nY = nd.PositionY;
                                                tang = nd.Segment.EndingControlPointAngle;
                                                nang = nd.Segment.Next().StartingControlPointAngle;
                                                if(sp.IsClockwise && sp.SizeHeight == s.SizeHeight && sp.SizeWidth == s.SizeWidth || !sp.IsClockwise && cnt_sp > 1 && (sp.SizeHeight < s.SizeHeight || sp.SizeWidth < s.SizeWidth)){
                                                    ta = tang;
                                                    na = nang;
                                                }else{
                                                    ta = nang;
                                                    na = tang;
                                                }

                                                if (param=="in"){
                                                    ta = ta + na;
                                                    na = ta - na;
                                                    ta = ta - na;
                                                }

                                                ang = ta - na;
                                                if (ang < 0) ang = ang + 360;
                                                if (ang < 180 && nd.Segment.length > freza_Rk && nd.Segment.Next().length > freza_Rk){
                                                    if(shft == 2 || shft==3){
                                                        ci = host.ActiveLayer.CreateEllipse2(nX, nY, freza_R);
                                                        sr.Add(ci);
                                                    }else if(getVal(ch_freza_corners)){
                                                        arr_sel.push(nd.AbsoluteIndex);
                                                    }else{
                                                        lin = host.ActiveLayer.CreateLineSegment(nX, nY, nX + freza_R, nY);
                                                        lin.SetRotationCenter(nX, nY);
                                                        if(ta < na) ta = ta + 360;
                                                        if(inp){
                                                            if (Math.abs(nd.Segment.Length-vall(inp))<0.5)
                                                                ang = tang;
                                                            else if (Math.abs(nd.Segment.Next().Length-vall(inp))<0.5)
                                                                ang = nang;
                                                        }else{
                                                            ang = (ta + na) / 2;
                                                        }
                                                        lin.RotationAngle = ang;
                                                        ci = host.ActiveLayer.CreateEllipse2(lin.Curve.Nodes.Last.PositionX, lin.Curve.Nodes.Last.PositionY, freza_R);
                                                        sr.Add(ci);
                                                        lin.Delete();
                                                    }

                                                }
                                            }
                                            nr = sp.Nodes.Range(1);
                                            nr.RemoveAll();
                                            for (var key in arr_sel){
                                                nr.AddRange(s.Curve.Nodes.Range(arr_sel[key]));
                                            }
                                            nr.Fillet(freza_R);

                                        }
                                    }
								break;

								case "cureinvert":
									sr.Add(do_cure_shape(s));
								break;
							}
						}
						if (s!=mlst && mlst){
							switch (name){
                                case "master_crc":
                                    var sradd = false;
                                    if (mlst_crc == getShapeCRC(s, getVal(ch_master_rotate))) sradd = true;
                                    if (getVal("group_less_more")!="equal" || isCtrl(shft)) sradd = !sradd;
                                    if (sradd) sr.Add(s);
                                break;
								case "master_setprop":
                                    if (getVal(ch_master_rotate)){
                                        s.RotationAngle = (shft==4 || shft==5) ? max_ang(mlst, true) - max_ang(s,true) : mlst.RotationAngle;
                                    }
                                    if (getVal(ch_master_sel_w) || getVal(ch_master_sel_h)) {
                                        var swi = (getVal(ch_master_sel_w)) ? mlst.SizeWidth : (getVal(ch_master_size) ? s.SizeWidth : undefined);
                                        var shi = (getVal(ch_master_sel_h)) ? mlst.SizeHeight : (getVal(ch_master_size) ? s.SizeHeight : undefined);
                                        if (swi===undefined && shi===undefined){
                                            swi = mlst.SizeWidth;
                                            shi = mlst.SizeHeight;
                                        }
                                        s.SetSize(swi, shi);
                                    }
                                    if (s.Type==6){
                                        if (getVal(ch_master_sel_fnt)) {
                                            s.Text.Story.Font = mlst.Text.Story.Font;
                                        }
                                        if (getVal(ch_master_size) && !getVal(ch_master_sel_w) && !getVal(ch_master_sel_h)){
                                            s.Text.Story.Size = mlst.Text.Story.Size;
                                        }
                                    }
                                    if (getVal(ch_master_sel_f)) s.Fill.CopyAssign(mlst.Fill);
                                    if (getVal(ch_master_sel_o)) s.Outline.CopyAssign(mlst.Outline);

                                    if (getVal(ch_master_sel_crc)){
                                        s.ConvertToCurves();
                                        var sx=s.CenterX;
                                        var sy=s.CenterY;
                                        s.Curve.CopyAssign(mlst.DisplayCurve);
                                        moveC(s,sx,sy)
                                    }
                                    sr.Add(s);
                                    break;
                            case "master_replace":
                                    // Старая логика: дублируем master объект
                                    var dup = (getVal(ch_master_clone)) ? mlst.Clone() : mlst.Duplicate();
                                        if (getVal(ch_master_rotate)){
                                            dup.RotationAngle = (shft==4 || shft==5) ? max_ang(s, true) - max_ang(dup,true) : s.RotationAngle;
                                        }
                                        if (getVal(ch_master_sel_w) || getVal(ch_master_sel_h) || getVal(ch_master_size)) {
                                            var swi = (getVal(ch_master_sel_w)) ? s.SizeWidth : (getVal(ch_master_size) ? mlst.SizeWidth : undefined);
                                            var shi = (getVal(ch_master_sel_h)) ? s.SizeHeight : (getVal(ch_master_size) ? mlst.SizeHeight : undefined);
                                            if (swi===undefined && shi===undefined){
                                                swi = s.SizeWidth;
                                                shi = s.SizeHeight;
                                            }
                                            dup.SetSize(swi, shi);
                                        }
                                        moveC(dup, s);
                                        if (getVal(ch_master_sel_fnt)) {
                                            dup.Text.Story.Font = s.Text.Story.Font;
                                            if (getVal(ch_master_size) && !getVal(ch_master_sel_w) && !getVal(ch_master_sel_h)){
                                                dup.Text.Story.Size = s.Text.Story.Size;
                                            }
                                        }
                                        if (getVal(ch_master_sel_f)) dup.Fill.CopyAssign(s.Fill);
                                        if (getVal(ch_master_sel_o)) dup.Outline.CopyAssign(s.Outline);

                                        if (getVal(ch_master_sel_crc)){
                                            dup.ConvertToCurves();
                                            dup.Curve.CopyAssign(s.DisplayCurve);
                                        }
                                        var cnt_cl = s.Clones.Shapes.Count;
                                        if (cnt_cl>0){
                                            for (var i=1;i<=cnt_cl;i++){
                                                var cl = s.Clones(i);
                                                //var sscl = moveC(SS,cl, undefined, "clone");
                                                var sscl = dup.Clone();
                                                transformS(sscl, cl,true);
                                            }
                                        }
                                    /*}*/
                                    dup.OrderFrontOf(s);
                                    sr.Add(dup);
                                    if (getVal(ch_master_del)) s.Delete();
                                break;
							}
						}
					}
                    if (!getVal(ch_sett_center) && return_center) if(vbgetExist(s)) s.SetRotationCenter(globalsRotationX,globalsRotationY);
				}

				switch(name){
                    case "master_replace": if (getVal(ch_master_size) && shft==2) mlst.Delete(); mlst = null; break;
					case "numerate": val_num_start.value = num_cnt; do_save(val_num_start); break;
				}

				//host.ActiveDocument.ClearSelection();
			}else{
				//sr.AddRange(OS);
			}
			if (name!="repeat_last") do_end(undogroup);
		}
        if (mlst && getVal(master_select_after)) sr.Add (mlst);
		var doeachsec2 = new Date().getTime()/1000;
		//warn(name + ": " + getRound(doeachsec2 - doeachsec1,3) + "s", false);
		return sr;
	}else{
		return 	get_EOS();
	}
}


function get_effect_info(effect, transp){
    if(transp === undefined) transp = false;
	var ret = [];
    var lens = "";
	ret['type'] = effect.type;
    var eff = ret['type'];
    if (effect.type==9){
        lens = "lens_";
        ret['type'] = 20 + transp.MergeMode;
        eff = transp.MergeMode;
    }
	ret['name'] = lang['text_effect_'+lens+'full_' + eff];
	ret['ltr'] = lang['text_effect_'+lens+'short_' + eff];
	return ret;
}

function get_bitmap_mode(bmp){
	var ret = [];
	var name = "";
	switch (bmp.mode){
		case 0: name = "BW"; break;
		case 1: name = "16"; break;
		case 2: name = "Gray"; break;
		case 3: name = "Paletted"; break;
		case 4: name = "RGB"; break;
		case 5: name = "CMYK"; break;
		case 6: name = "DuoTone"; break;
		case 7: name = "LAB"; break;
		case 8: name = "CMYK Multy"; break;
		case 9: name = "RGB Multy"; break;
		case 10: name = "Spot Multy"; break;
	}
	ret['name'] = name;
	ret['mode'] = bmp.mode;
	return ret;
}

function get_color_info(colors, fountain){
	if(fountain === undefined) fountain = false;
	var digs = [];
	var ret = [];
	var cols = [];
	if(fountain){
		for(var i=0;i<colors.count;i++) cols[i] = get_color_info(colors(i).color);
		var color = colors(0).color;
	}else{
		var color = colors;
	}
	switch (color.type){
		case 1:
			var sname = "PANTONE";
			break;
		case 2:
			digs[0] = color.CMYKCyan;
			digs[1] = color.CMYKMagenta;
			digs[2] = color.CMYKYellow;
			digs[3] = color.CMYKBlack;
			var sname = "CMYK";
			break;
		case 4:
			digs[0] = color.CMYCyan;
			digs[1] = color.CMYMagenta;
			digs[2] = color.CMYYellow;
			var sname = "CMY";
			break;
		case 5:
			digs[0] = color.RGBRed;
			digs[1] = color.RGBGreen;
			digs[2] = color.RGBBlue;
			var sname = "RGB";
			break;
		case 6:
			digs[0] = color.HSBHue;
			digs[1] = color.HSBSaturation;
			digs[2] = color.HSBBrightness;
			var sname = "HSB";
			break;
		case 7:
			digs[0] = color.HLSHue;
			digs[1] = color.HLSLightness;
			digs[2] = color.HLSSaturation;
			var sname = "HLS";
			break;
		case 8:
			digs[0] = color.BW;
			var sname = "BW";
			break;
		case 9:
			digs[0] = color.Gray;
			var sname = "Gray";
			break;
		case 11:
			digs[0] = color.YIQLuminanceY;
			digs[1] = color.YIQChromaI;
			digs[2] = color.YIQChromaQ;
			var sname = "YIQ";
			break;
		case 12:
			digs[0] = color.LabLuminance;
			digs[1] = color.LabComponentA;
			digs[2] = color.LabComponentB;
			var sname = "LAB";
			break;
		case 14:
			var sname = "PANTONE Hex";
			break;
		case 20:
			var sname = "Registration";
			break;
		case 22:
			var sname = "multi-channel";
			break;
		case 25:
			var sname = "user ink";
			break;
		case 26:
			var sname = "mixed";
			break;
		case 99:
			digs[0] = color.SpotColorID;
			digs[1] = color.SpotColorName;
			var sname = "spot";
			break;
	}
	ret['name'] = color.Name;
	ret['sname'] = sname;
	if (fountain){
		ret['hex'] = cols[0]['hex']+":"+cols[1]['hex'];
		hnt = "";
		for(var i=0;i<colors.count;i++) hnt += cols[i]['sname'] + "(" + cols[i]['digs'].join(", ") + ")\n";
		ret['hint'] = hnt;
		ret['digs'] = cols;
	}else{
		ret['digs'] = digs;
		ret['hex'] = color.HexValue;
		ret['hint'] = sname + "(" + digs.join(", ") + ") ";
	}
	var gray = color.GetCopy();
	gray.ConvertToGray();
    if (gray.type==9)
	    ret['gray'] = (gray.Gray<111) ? "#FFF" : "#000";
    else
	    ret['gray'] = "#FFF";

	return ret;
}

function FindShapes(lay, name, strong){
	if(strong === undefined) strong = true;
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();

	for (var i=1;i<=lay.Shapes.Count;i++){
		var s = lay.Shapes(i);
		if(strong){
			nm = s.name;
			if (nm==name || nm.toLowerCase() == name.toLowerCase() || nm.toUpperCase() == name.toUpperCase()) sr.Add(s);
		}else{
			ind = s.name.indexOf(name);
			if (ind>-1) sr.Add(s);
		}
	}
	return sr;
}


function getArrOS(OS, params){
	if(OS === undefined) OS = get_OS();
	if(params === undefined) params = ['position','size'];
	var ret = [];
	var cnt_os = OS.Shapes.Count;
	if(cnt_os>0){
		for(var i=1;i<=cnt_os;i++){
			var s = OS.Shapes(i);
			ret[i] = [];
			ret[i]['id'] = i;
			ret[i]['cnt'] = s.Shapes.Count;
			for(var key in params){
				switch (params[key]){
					case "pos":
					case "position": ret[i]['px'] = s.PositionX; ret[i]['py'] = s.PositionY; ret[i]['cx'] = s.CenterX; ret[i]['cy'] = s.CenterY; break;
					case "size": ret[i]['l'] = s.LeftX; ret[i]['r'] = s.RightX; ret[i]['t'] = s.TopY; ret[i]['b'] = s.BottomY; ret[i]['w'] = s.SizeWidth;ret[i]['h'] = s.SizeHeight; break;
					case "rot":
					case "rotation": ret[i]['rx'] = s.RotationCenterX; ret[i]['ry'] = s.RotationCenterY; break;
					case "len":
					case "length": ret[i]['len'] = (isDCurve(s)) ? s.DisplayCurve.Length : 0; break;
					case "txt":
					case "text": ret[i]['txt'] = (s.Type == 6) ? s.Text.Story.Text : ""; break;
					case "subp":
					case "subpath":
						if (isDCurve(s)){
							ret[i]['sp'] = [];
							ret[i]['sp']['cnt'] = s.DisplayCurve.Subpaths.Count;
							for (var spi=1;spi<=ret[i]['sp']['cnt'];spi++){
								var sp = s.DisplayCurve.Subpaths(spi);
								//alert(i+":"+spi+"::" + s.DisplayCurve.Subpaths.Count);
								ret[i]['sp'][spi] = [];
								ret[i]['sp'][spi]['id'] = spi;
								ret[i]['sp'][spi]['px'] = sp.PositionX;
								ret[i]['sp'][spi]['py'] = sp.PositionY;
								ret[i]['sp'][spi]['len'] = sp.Length;
							}
						}
						break;
				}
			}
		}
	}
	return ret;
}

function arrInBound(ss,s,gap, mode, checkid){// mode = v or h or or
    if(ss===undefined || s===undefined) return false;
	if(gap === undefined) gap = 0.005;
	if(mode === undefined) mode = "both";
	if(checkid === undefined) checkid = true;
    mode = mode.toLowerCase();
    var hor = (mode=="v") ? true : (ss['l'] < s['r'] + gap && ss['r'] > s['l'] - gap);
    var ver = (mode=="h") ? true : (ss['b'] < s['t'] + gap && ss['t'] > s['b'] - gap);
    var res = (mode=="or") ? (hor || ver) : (hor && ver);
	return (checkid && ss['id']==s['id']) ? false : res;
}

function arrFndDouble(ss,s,gap,checkid){
	if(checkid === undefined) checkid = true;
	var ret = false;
	if (ss['id']!=s['id'] || !checkid){
        if (gap<0){
			var sgap = Math.abs(gap);
			ret = (Math.abs(ss['w']-s['w'])<=sgap && Math.abs(ss['h']-s['h'])<=sgap && Math.abs(ss['len']-s['len'])<=sgap*4 && ss['len']>0 && s['len']>0)
		}else{
			ret = (Math.abs(ss['px']-s['px'])<=gap && Math.abs(ss['py']-s['py'])<=gap && Math.abs(ss['len']-s['len'])<=gap*4 && ss['len']>0 && s['len']>0);
		}
	}
	return ret;
}

function getbySID(sid, type, name, ingroup){
    var s = null;
    for (var i=1;i<=host.ActiveDocument.Pages.Count;i++){
        var pg = host.ActiveDocument.Pages(i);
        s = pg.FindShape(name,type,sid,ingroup);
        if (s) break;
    }

    return s
}

function get_Shift(all, ctrl, alt, ctrlalt, shft){
    if(all === undefined) all = "";
    if(ctrl === undefined) ctrl = "";
    if(alt === undefined) alt = "";
    if(ctrlalt === undefined) ctrlalt = "";
    if(shft === undefined) shft = Shift();

    var ret = all;
    if (alt.length>0 && (shft==4 || shft==5)) ret = alt;
    if (ctrl.length>0 && (shft==2 || shft==3)) ret = ctrl;
    if (ctrlalt.length>0 && (shft==6 || shft==7)) ret = ctrlalt;
    return ret;
}


function getShapeCenter(shape) {
    return (getVal(ch_sett_center)) ? {x: shape.CenterX, y: shape.CenterY} :{x: shape.RotationCenterX, y: shape.RotationCenterY};
}


function getCenter(s, center){
	if(s === undefined) s = false;
	if(center === undefined) center = false;
    if (!s){
        X = host.ActiveDocument.ActiveWindow.ActiveView.OriginX;
        Y = host.ActiveDocument.ActiveWindow.ActiveView.OriginY;
    }else{
        if(center){
            X = s.CenterX;
            Y = s.CenterY;
        }else{
            X = s.RotationCenterX;
            Y = s.RotationCenterY;
        }
    }
    return {"x":X,"y":Y};
}

function MoveToLayer(lname,s){
    if (s === undefined) s = get_OS();
    if (lname.length>0){
        var fndl = host.ActivePage.Layers.Find(lname);
        fndl = (fndl===null) ? host.ActivePage.CreateLayer(lname) : host.ActivePage.Layers(lname);
        s.MoveToLayer(fndl);
        return true;
    }else{
        return false;
    }
}



function SetRC(s, ss){ //SetRotationCenter for S by S or SS
    var sss = (ss === undefined) ? s : ss;
    if (getVal(ch_sett_center)){
        var cx = sss.centerX;
        var cy = sss.centerY;
    }else{
        var cx = sss.RotationCenterX;
        var cy = sss.RotationCenterY;
    }
    s.SetRotationCenter(cx,cy);
    return s;
}

function moveC(s, shape, Y, dupl, center, transform){
    //написать swap
    var X = false;
    if(transform === undefined) transform = false;
	if(Y === undefined && shape === undefined){
        X = host.ActiveDocument.ActiveWindow.ActiveView.OriginX;
        Y = host.ActiveDocument.ActiveWindow.ActiveView.OriginY;
    }else if (Y === undefined && shape.CenterX){
        if (getVal(ch_sett_center)){
            var X = shape.CenterX;
            var Y = shape.CenterY;
        }else{
            var X = shape.RotationCenterX;
            var Y = shape.RotationCenterY;
        }
        if (transform) transformS(s, shape);
    }else{
        X = shape;
    }
    if (X && Y){
        if(dupl === undefined) dupl = false;
        if(center === undefined) center = (getVal(ch_sett_center)) ? "C" : "R";
        if(center === true) center = "C";
        switch (center){
            case "TL": dx = X - s.LeftX; dy = Y - s.TopY; break;
            case "TC": dx = X - s.CenterX; dy = Y - s.TopY; break;
            case "TR": dx = X - s.RightX; dy = Y - s.TopY; break;
            case "CL" : dx = X - s.LeftX; dy = Y - s.CenterY; break;
            case "C" : dx = X - s.CenterX; dy = Y - s.CenterY; break;
            case "CR" : dx = X - s.RightX; dy = Y - s.CenterY; break;
            case "BL": dx = X - s.LeftX; dy = Y - s.BottomY; break;
            case "BC": dx = X - s.CenterX; dy = Y - s.BottomY; break;
            case "BR": dx = X - s.RightX; dy = Y - s.BottomY; break;
            default  : dx = X - s.RotationCenterX; dy = Y - s.RotationCenterY; break;
        }
        if (dupl){
            return (dupl===true) ? s.Duplicate(dx, dy) : s.Clone(dx, dy);
        }else{
            s.Move(dx, dy);
        }
    }
    return s;
}

function transformS(s, shape, replace){
    if(replace === undefined) replace = false;
    if (replace){
        s = moveC(s, shape,undefined, (replace=="move"), undefined, true);
    }else{
        //s.ApplyTransformMatrix(shape.TransformationMatrix);
        if (s.TransformationMatrix.IsMirrored!=shape.TransformationMatrix.IsMirrored) s.Flip(1);
        s.RotationAngle = shape.RotationAngle;
        s.SetSize(shape.SizeWidth, shape.SizeHeight);
        moveC(s,shape);
    }
    return s;
}

function one_shape_len(s){
	var all_len = 0;
	
	if (s.Shapes.Count > 0){
		// Рекурсивный обход всех дочерних объектов в группе
		for (var i = 1; i <= s.Shapes.Count; i++){
			var childShape = s.Shapes(i);
			all_len += one_shape_len(childShape);
		}
	} else {
		// Для отдельного объекта
		if(s.DisplayCurve !== undefined && s.DisplayCurve !== null){
			all_len = s.DisplayCurve.Length;
		}
	}
	
	return all_len;
}

function all_shapes_len(OS){
    if (OS === undefined) OS = get_OS(true,false,false,true);
	//var oss = vbdoQuery(OS.Shapes,"@name!='sdfsdflkjdsfkldskj'", true); //getInGroup(OS);
	var allen = 0;
	for(var i=1;i<=OS.Shapes.Count;i++){
		var s = OS.Shapes(i);
		allen += one_shape_len(s);
	}
	return allen;
}

function one_shape_area(s,external){
	if(external === undefined) external = false;
	
	// Если external = true, просто возвращаем площадь габаритного прямоугольника
	if (external) {
		return s.SizeHeight * s.SizeWidth;
	}
	
	all_area = 0;
    if (s.Shapes.Count > 0){
        // Рекурсивный обход всех дочерних объектов в группе
        all_area = 0;
        for (var i = 1; i <= s.Shapes.Count; i++){
            var childShape = s.Shapes(i);
            all_area += one_shape_area(childShape, false);
        }
    }else{
        if (s.Shapes.Count==0){if (s.DisplayCurve){if(s.DisplayCurve.closed){
            s_info = get_subpath_info(s);
            all_area = 0;
			for (var cns=1;cns<=s.DisplayCurve.SubPaths.Count;cns++){
				sp  = s.DisplayCurve.SubPaths(cns);
                all_area = (s_info[cns][3] % 2 == 0 ) ? all_area + sp.Area : all_area - sp.Area;
			}
		}}}
	}
    return all_area;
}




// ❌ УДАЛЕНЫ дублирующие функции PriceColor и PriceUpdate
// ✅ Теперь используются только версии из модуля cat_calc.js

function vallId(id){
    return vall(document.getElementById(id).value, false);
}

function get_subpath_info(one_shape){
    var sup = [];

	if (one_shape.Shapes.Count==0){if(one_shape.DisplayCurve){
		sp_cnt = one_shape.DisplayCurve.SubPaths.Count;
		for (var cns=1;cns<=sp_cnt;cns++){
			sp  = one_shape.DisplayCurve.SubPaths(cns);
			sup[cns] = [cns, sp.Nodes.First.PositionX, sp.Nodes.First.PositionY,0,sp.BoundingBox.Left, sp.BoundingBox.Right, sp.BoundingBox.Top,sp.BoundingBox.Bottom];
		}
		maxc = 0;
		for (var i=1;i<=sp_cnt;i++){
			for (var cns=1;cns<=sp_cnt;cns++){
				if(i!=cns){
					sp  = one_shape.DisplayCurve.SubPaths(cns);
					if (sp.BoundingBox.Left < sup[i][5]){
						if (sp.BoundingBox.Right > sup[i][4]){
							if (sp.BoundingBox.Top > sup[i][7]){
								if (sp.BoundingBox.Bottom < sup[i][6]){
									res = sp.IsOnSubPath(sup[i][1],sup[i][2]);
									if (res == 2) sup[i][3]++
								}
							}
						}
					}
				}
			}
		}
	}}
    return sup;
}

function GetShapesInfo(){
	if(host.Activeshape){
        var OS = get_OS();
		numSelected.value = OS.Shapes.Count;
        numlength.value = all_shapes_len(OS) * wScale;
		objectName = host.Activeshape.Evaluate("@type"); // use CQL to get the object type name
		selectedObject.value = objectName;
		wi = host.ActiveShape.SizeWidth;
		hi = host.ActiveShape.SizeHeight;
		info_wi.value = wi*wScale;
		info_hi.value = hi*wScale;
		dd = info_del.value;
		info_wid.value = vall(wi+dd,false,4)*wScale;
		info_hid.value = vall(hi+dd,false,4)*wScale;
	}
}

function ShapeRemove(OSS, shp){
    var os = get_EOS();
    os.Add(shp);
    OSS.RemoveRange(os);
    return OSS;
}

function getShapeCRC(shp, mirr){
	if(mirr === undefined) mirr = false;
    var os = get_EOS();
    os.Add(shp);
    os = getInGroup(os);
    var cnt_os = os.shapes.count;
    var maxlen = 0;
    var sumdelta=0;
    for (c=1;c<=cnt_os;c++){
        var s = os.Shapes(c);
        if (s.type<5){
            var inmirr = false;
            if (mirr && s.RotationAngle!=0){
                s = s.Duplicate();
                s.RotationAngle = 0;
                if (s.TransformationMatrix.IsMirrored) s.Flip(1);
                inmirr = true;
            }
            for (i=1; i<=s.DisplayCurve.SubPaths.Count;i++){
                var curv = s.DisplayCurve.SubPaths(i);
                var curvlen = curv.length;
                if (curvlen>maxlen){
                    maxlen = curvlen;
                    max_X = curv.PositionX;
                    max_Y = curv.PositionY;
                }
            }
            if (inmirr) s.Delete();
        }
    }
    for (c=1;c<=cnt_os;c++){
        var s = os.Shapes(c);
        if (s.type<5){
            var inmirr = false;
            if (mirr && s.RotationAngle!=0){
                s = s.Duplicate();
                s.RotationAngle = 0;
                if (s.TransformationMatrix.IsMirrored) s.Flip(1);
                inmirr = true;
            }
            if (s.DisplayCurve.SubPaths.Count==1){
                sumdelta += curv.length*s.SizeWidth*s.SizeHeight;
            }else{
                for (i=1; i<=s.DisplayCurve.SubPaths.Count;i++){
                    var curv = s.DisplayCurve.SubPaths(i);
                    if (mirr){
                        var a = Math.abs(max_X - curv.PositionX);
                        var b = Math.abs(max_Y - curv.PositionY);
                        sumdelta += Math.sqrt(a*a + b*b) * curv.length;
                    }else{
                        sumdelta += (max_X - curv.PositionX + max_Y - curv.PositionY) * curv.length;
                    }
                }
            }
            if (inmirr) s.Delete();
        }else{
            sumdelta += s.Type*s.SizeHeight*s.SizeWidth*13;
        }
    }
    sumdelta = getRound(sumdelta,1);
    return sumdelta;
}

function getStrfromCurve(crv){
	/*Добавить подпути в парсер*/
	var vals = "";
	for (var si=1;si<=crv.SubPaths.Count;si++){
		sp = crv.SubPaths(si);
		vals += sp.Nodes(1).PositionX + ":" + sp.Nodes(1).PositionY + chr(10);
		nds_cnt = sp.Nodes.Count;
		nds = (sp.Closed) ? nds_cnt+1 : nds_cnt;
		for (var i=2;i<=nds;i++){
			nd = (i>nds_cnt) ? sp.Nodes(1) : sp.Nodes(i);
			vals += nd.PositionX + ":" + nd.PositionY + ":";
			if(nd.PrevSegment.Type > 0 /*cdrLineSegment*/) vals += nd.PrevSegment.StartingControlPointX + ":" + nd.PrevSegment.StartingControlPointY + ":" + nd.PrevSegment.EndingControlPointX + ":" + nd.PrevSegment.EndingControlPointY;
			if (i>nds_cnt) vals += ":13.13";
			vals += chr(10);
		}
	}
	vbWriteFile(host.UserDataPath + "ar_envel.txt", vals);
	return vals;
}

function getCurvefromStr(str){
	/*Добавить подпути в парсер*/
	var crv = false;
	var pts = str.split(chr(10));
	if(pts.length>2){
		var crv = host.ActiveDocument.CreateCurve();
		var sp = false;
		for (var p=0;p<pts.length;p++){
			pt = pts[p].split(":");
			for(var i=0;i<pt.length;i++) pt[i]*=1;
			if(pt.length>1){
				if(pt.length==2){
					sp = crv.CreateSubPath(pt[0], pt[1]);
				}else if(pt.length>4){
					sp.AppendCurveSegment2(pt[0],pt[1],pt[2],pt[3],pt[4],pt[5]);
					if (pt[6]==13.13) crv.JoinTouchingSubpaths();
				}else{
					sp.AppendLineSegment(pt[0], pt[1]);
					if (pt[3]==13.13) crv.JoinTouchingSubpaths();
				}
			}
		}
		//crv.JoinTouchingSubpaths();
	}
	return crv;
}

function set_master(){
	var shft = Shift();
	if (isMaster() && shft==1){
		master.CreateSelection();
	}else if (shft==2){
        isMaster(null);
	}else{
		isMaster(host.ActiveShape);
	}
    do_cure();
}


function collect_arr(arr, ci, ki) {
    for (var k = 0; k < arr.length; k++) {
        if (arr[ki][k] > 0) {
            arr[ci][k] = k;
            if (ki !== ci) {
                arr[ki][k] = null;
            }
            if (ci !== k && ki !== k) {
                arr = collect_arr(arr, ci, k);
            }
        }
    }
    //if (ki !== ci) { arr[ki][ki] = null; }
    return arr;
}



function FindIn(shape, gap, touch, type){
	if(gap === undefined) gap = 0;
	if(touch === undefined) touch = false;
	return host.ActivePage.SelectShapesFromRectangle(shape.leftx-gap, shape.bottomy-gap, shape.rightx+gap, shape.topy+gap, touch).Shapes.All();
}



function FindSegXY(glx, gly, sel, tocurve){
	if(tocurve === undefined) var tocurve = false;
    var fnd = false;
	for(var i=1;i<=sel.Shapes.Count;i++){
		var sa = sel.Shapes(i);
        if (isDCurve(sa)){
            if (tocurve){
                sa.ConvertToCurves();
                var sd = sa.Curve;
            }else{
                var sd = sa.DisplayCurve;
            }
            var sfnd = sd.FindSegmentAtPoint(glx, gly, 0, 1);
            if(sfnd) {
				return sfnd;
			}
        }else{
            fnd = FindSegXY(glx, gly, sa);
        }
    }
    if (tocurve){
        sel.FirstShape.ConvertToCurves();
        var sd = sel.FirstShape.Curve;
    }else{
        var sd = sel.FirstShape.DisplayCurve;
    }
    return sd.DisplayCurve.Segments(1);
}


function max_ang(s, check_long){
	if(check_long === undefined) check_long = false;
	var ang = 0;
	if (s){
		if (!check_long || !isSimpleShape(s) || (s.RotationAngle>0 && s.RotationAngle<360)) {
			ang  = s.RotationAngle;
		}else if (s.Shapes.Count==0 && isSimpleShape(s)){
			max = 0;
			imax = 0;
			for(var k=1;k<=s.DisplayCurve.Segments.Count;k++){
				len = s.DisplayCurve.Segments(k).Length;
				if (len>max){
					max = len;
					imax = k;
				}
			}
			ang = s.DisplayCurve.Segments(imax).EndingControlPointAngle;
		}
	}
	return ang;
}

function max_area(OS){
	if(OS === undefined) OS = get_OS();
	max = 0;
	smax = OS.FirstShape;

	cnt_os = OS.Shapes.Count;
	for(var i=1;i<=cnt_os;i++){
		s = OS.Shapes(i);
		area = s.SizeWidth * s.SizeHeight;
		if (area>max){
			max = area;
			smax = s;
		}
	}
	return smax;
}

function max_size(s){
	max = s.SizeWidth;
	if (s.SizeHeight>max) max = s.SizeHeight;
	return max;
}

function lastSize(lst, perimetr){
	if(perimetr === undefined) perimetr = false
	siz = 0;
	if(isSimpleShape(lst)){
		clsd = true;
		if(lst.DisplayCurve) if(!lst.DisplayCurve.closed) clsd = false;
		if(clsd){
			if (getVal(ch_master_sel_h) && !getVal(ch_master_sel_w)){
				siz = lst.SizeHeight;
			}else if (!getVal(ch_master_sel_h) && getVal(ch_master_sel_w)){
				siz = lst.SizeWidth;
			}else{
				siz = (perimetr && lst.Shapes.Count==0) ? lst.DisplayCurve.Length :  max_size(lst);
			}
		}else{
			siz = lst.DisplayCurve.length;
		}
	}
	return siz;
}


function maxSPArea(s){
	area = 0;
	if (isDCurve(s)){
		max = 0;
		for(var k=1;k<=s.DisplayCurve.SubPaths.Count;k++){
			sp = s.DisplayCurve.SubPaths(k);
			if(sp.closed){
				are = sp.Area;
				if (are>max) max = are;
			}
		}
		area = max;
	}
	return area;
}


function sub_trim(spp, gap){
	shft = Shift();
	if(spp.closed && shft==2) spp.Nodes.First.BreakApart();
	if(!spp.closed){
		spp.AddNodeAt(gap, 0);
		spp.AddNodeAt(spp.length - gap, 0);
		spp.Nodes.First.Delete();
		spp.Nodes.Last.Delete();
	}
	return spp;
}


function about(val, valc, gap){
    if(valc === undefined) valc = 0;
    if(gap === undefined) gap = 1;
    return (val<valc+gap && val>valc-gap);
}

function getRef(setDoc){
	if(setDoc === undefined) setDoc = true;
	s = host.ActiveLayer.CreateEllipse2(0,0,100);
	sx = s.CenterX;
	sy = s.CenterY;
	host.FrameWork.Automation.InvokeItem("e6644135-9dab-4935-8ab9-fc85527810ca");
    host.FrameWork.Automation.InvokeItem("6ae897fd-2eab-4dad-b172-f4fb768c273e");
	ex = s.CenterX;
	ey = s.CenterY;
	//s.Delete();
	if(ey > sy){
		refpt = 2;
		if(ex<sx) refpt = 3;
		if(ex>sx) refpt = 1;
	}else if(ey < sy){
		refpt = 6;
		if(ex<sx) refpt = 5;
		if(ex>sx) refpt = 7;
	}else{
		refpt = 9;
		if(ex<sx) refpt = 4;
		if(ex>sx) refpt = 8;
	}

	if(setDoc) host.ActiveDocument.ReferencePoint = refpt;
	return refpt;
}

function hextorgb(hex) {
	if(hex === undefined) hex = '000';
	var arr = [0,0,0];
	if (hex.length==3)
		str = "" + hex.substring(0,1) + hex.substring(0,1) + hex.substring(1,2) + hex.substring(1,2) + hex.substring(2,3) + hex.substring(2,3);
	else if (hex.length==6)
		str = "" + hex;
	else
		str = false;
	if (str){
		arr = [parseInt(str.substring(0,2),16),parseInt(str.substring(2,4),16),parseInt(str.substring(4,6),16)];
	}
	return arr;
}

function movePowerCont(mlst,s){
    var shft = Shift();

    SetRC(s);
    var sang = s.RotationAngle;
    if (s.RotationAngle != mlst.RotationAngle) s.RotationAngle = mlst.RotationAngle;

    var SS = mlst.Duplicate();

    if (s.RotationAngle != sang) s.RotationAngle = sang;
    moveC(SS,s)

    if (shft!=2){
        var swi = (!getVal(ch_master_sel_w)) ? undefined : s.SizeWidth;
        var shi = (!getVal(ch_master_sel_h)) ? undefined : s.SizeHeight;
        if (swi===undefined && shi===undefined){
            swi = s.SizeWidth;
            shi = s.SizeHeight;
        }
        SS.SetSize(swi, shi);
    }

    if (!getVal(ch_master_sel_o)) SS.Outline.CopyAssign(s.Outline);
    if (!getVal(ch_master_sel_f)) SS.Fill.CopyAssign(s.Fill);
    SS.ConvertToCurves();
    SS.Curve.CopyAssign(s.DisplayCurve);
    var cnt_cl = s.Clones.Shapes.Count;
    if (cnt_cl>0){
        for (var i=1;i<=cnt_cl;i++){
            var cl = s.Clones(i);
            //var sscl = moveC(SS,cl, undefined, "clone");
            var sscl = SS.Clone();
            transformS(sscl, cl,true);
            sscl.OrderBackOf(cl);
        }
    }
    SS.OrderBackOf(s);
    s.Delete();
    s = SS;
    return s;
}

function parse_ws(file){
    var filr = file.toLowerCase();
    filr = replaceAll(filr," ","");
    filr = replaceAll(filr,"\t","");
    filr = replaceAll(filr,"\n","");
    filr = replaceAll(filr,"\r","");
    filr = replaceAll(filr,"{","{;");
    filr = replaceAll(filr,"}",";};");
    filr = replaceAll(filr,";;",";");
    filr = replaceAll(filr,"limit=","|");
    filr = filr.replace(/(\d)([a-zA-Z])/g, "$1*$2");
    return filr;
}

// Функция trim для JS 1.5
function trim(str) {
    return str.replace(/^\s+|\s+$/g, "");
}

// Извлекает имя файла из полного пути
function getFileName(filePath, noExtension) {
    if (!filePath || typeof filePath !== 'string') return '';
    
    // Убираем путь - берем всё после последнего \ или /
    var fileName = filePath.replace(/^.*[\\\/]/, '');
    
    // Если нужно убрать расширение
    if (noExtension) {
        var dotIndex = fileName.lastIndexOf('.');
        if (dotIndex > 0) {
            fileName = fileName.substring(0, dotIndex);
        }
    }
    
    return fileName;
}


function replaceAll(str, find, replace, word, casesense) {
    if(replace === undefined) replace = '';
    if(word === undefined) word = false;
    casesense = (casesense === true) ? "" : "i";

    str += "";
	if(find=="trim" || find=="trims"){
        if (find!="trims") str = str.replace(/^\s+|\s+$/gm,'');
        str = str.replace("\r","");
        str = str.replace("\n","");
		return str;
	}else{
        if (word===true)
		    return str.replace(new RegExp("\\b"+find+"\\b", 'g'+casesense), replace);
        else
    		return str.replace(new RegExp(find, 'g'+casesense), replace);
	}
}

function arrwarn(arr){
	txt = "";
	for(var i=0;i<=arr.length;i++){
		if(arr[i][0]!=null){
			for(var j=0;j<=arr[i].length;j++){
				if(arr[i][j]!=null){
					txt += "arr["+i+",]["+j+"]=" + arr[i][j] + "<br>";
				}
			}
		}
	}
	return txt;
}


function add_leads(str, digs, lead){
	str = "" + str;
	while (str.length < digs) str = "" + lead + str;
	return str;
}

function inArray(value, array) {
  for (var i = 0; i < array.length; i++) if (value === array[i]) return true;
  return false;
}


// Функция естественной сортировки для правильного порядка файлов (img_10 после img_9)
function naturalSort(a, b) {
    var aChunks = chunkify(a);
    var bChunks = chunkify(b);
    var length = Math.max(aChunks.length, bChunks.length);
    
    for (var i = 0; i < length; i++) {
        var aChunk = aChunks[i] || '';
        var bChunk = bChunks[i] || '';
        
        // Если оба фрагмента - числа
        if (isNumber(aChunk) && isNumber(bChunk)) {
            var diff = parseInt(aChunk, 10) - parseInt(bChunk, 10);
            if (diff !== 0) return diff;
        }
        // Иначе обычное строковое сравнение
        else if (aChunk !== bChunk) {
            return aChunk > bChunk ? 1 : -1;
        }
    }
    return 0;
}

// Разбивает строку на фрагменты (текст и числа)
function chunkify(str) {
    return str.replace(/(\d+)/g, '\0$1\0').replace(/\0+/g, '\0').split('\0');
}

// Проверяет, является ли строка числом
function isNumber(str) {
    return /^\d+$/.test(str);
}


// Универсальная функция поиска подстроки (аналог indexOf для JS 1.5)
function inStr(str, substr) {
    dbg(typeof str + " " + typeof substr);
    var l1 = str.length;
    var l2 = substr.length;
    for (var i = 0; i <= l1 - l2; i++) {
        if (str.substring(i, i + l2) == substr) return i;
    }
    return -1;
}


function sort2D(a,b){ if (a[0] > b[0]) return 1; if (a[0] < b[0]) return -1; return 0;}
function rsort2D(a,b){ if (a[0] < b[0]) return 1; if (a[0] > b[0]) return -1; return 0;}
function distXY(x1,y1,x2,y2){return Math.sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));}

// Простая функция определения состояния клавиш (аналог оригинальной)
function Shift(mode) {
    if (mode === undefined) mode = false;
    if (mode) glShift = 99;
    
    var ret = 0;
    if (glShift != 99) {
        ret = glShift;
    } else if (window.event) {
        if (window.event.shiftKey) ret += 1;
        if (window.event.ctrlKey) ret += 2;
        if (window.event.altKey) ret += 4;
    }
    return ret;
}

// Простые функции проверки клавиш (как в sys.js)
function isShift(shft) {
    if (shft === undefined) shft = Shift();
    return (shft == 1 || shft == 3 || shft == 5 || shft == 7);
}

function isCtrl(shft) {
    if (shft === undefined) shft = Shift();
    return (shft == 2 || shft == 3 || shft == 6 || shft == 7);
}

function isAlt(shft) {
    if (shft === undefined) shft = Shift();
    return (shft > 3);
}

function isShift (shft){return (shft==1 || shft==3 || shft==5 || shft==7) ? true : false;}
function isCtrl (shft){return (shft==2 || shft==3 || shft==6 || shft==7) ? true : false;}
function isAlt (shft){return (shft>3)  ? true : false;}
function chr( ascii ) {return String.fromCharCode(ascii);}

function isSame(s1, s2){
    return (s1.StaticID == s2.StaticID) ? true : false;
}

function isMaster(shape){
    if(shape === undefined) shape = false;
    var ret = false;
    if (shape!==false){
        if (shape !== null && vbgetExist(shape)){
            master = shape;
            ret = master;
        }else{
            master = false;
        }
    }else if (vbgetExist(master)){
        ret = master;
    }else{
        master = false;
    }
    var masterbtn = document.getElementById('master_set');
    if (masterbtn) masterbtn.style.backgroundColor = (ret) ? "#F99" : "";
    return ret;
}

function isSimpleShape(s, arryes){
	if(arryes === undefined) arryes = [];
	arrno = [5,6,7,10,11,12,13,15,16,17,18,19,20,22,23,24,25,26,27,28,29,30];
	//inArray(s.Type,[1,2,3,4,6,9,14,21])
//	return false;
	return (!inArray(s.type, arrno) || inArray(s.type, arryes)) ? true : false;
}

function isDCurve(s){
	return (s.DisplayCurve!=null && s.Type!=6) ;
}



function dbg(text){
    var debug = document.getElementById("debug");
    if (!debug){ glDBGMsg += text; return;}
    if (glDBGMsg.length>0) glDBGMsg += text;
    var path = host.Application.GMSManager.UserGMSPath;
    if (path.indexOf("DukereD")>0 || glDbg){
        if(text === undefined) text = false;
        newline = "<br />";

        function formatObjectProperties(obj, level) {
            if (level > 4) {
                return '[Object]';
            }

            if (level === 4 && typeof obj === 'object' && obj !== null) {
                var props = [];
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) {
                        var value = obj[key];
                        var valueStr;
                        if (typeof value === 'function') {
                            valueStr = '[Function]';
                        } else if (typeof value === 'object' && value !== null) {
                            valueStr = '[Object]';
                        } else {
                            valueStr = value;
                        }
                        props.push(key + ': ' + valueStr);
                    }
                }
                return props.join(', ');
            }

            var result = '';
            var indent = '';
            for (var i = 0; i < level; i++) {
                indent += '&nbsp;&nbsp;';
            }

            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var value = obj[key];
                    result += indent + '<u>' + key + '</u>: ';

                    if (typeof value === 'function') {
                        result += '[Function]<br />';
                    } else if (typeof value === 'object' && value !== null) {
                        var formattedValue = formatObjectProperties(value, level + 1);
                        if (level + 1 === 4) {
                            result += formattedValue + '<br />';
                        } else {
                            result += '<br />' + formattedValue;
                        }
                    } else {
                        result += value + '<br />';
                    }
                }
            }
            return result;
        }

        if (typeof text === 'object' && text !== null) {
            text = formatObjectProperties(text, 0);
        } else if (typeof text === "string" && text.length > 0) {
            text = replaceAll(text, "\n", "<br />");
        }
        text = (text===false) ? "" : debug.innerHTML + newline + text;
        debug.innerHTML = text;
    }
}

function warn(text, alarm, append){
	if(text === undefined) text = "no";
	if(alarm === undefined) alarm = false; // Убрана настройка ch_warn_alert - по умолчанию false
	if(append === undefined) append = false;
    if (text instanceof Array) {
        var hnt = (text[1]!==undefined) ? text[1] : false;
        text = text[0];
    }else{
        var hnt = false;
    }
    text += (append) ? warning.innerHTML : "";
    warning.title = hint['text_warning'];
    if (text.length<2 || text=="no"){
        warning.innerHTML = "";
        warning.style.display = "none";
    }else{
        if (alarm){
            warning.innerHTML = "";
            warning.style.display = "none";
            alert(text);
        }else{
            text = replaceAll(text,CR,"<br />");
            warning.style.display = "block";
            if (hnt) warning.title = hnt;
            warning.innerHTML = text;
        }
    }
    //alert(document.body.scrollTop);
    //warning.style.bottom = 0-document.body.scrollTop+10;
    //host.ActiveWindow.Activate();
	//host.Application.Refresh();
}

function do_begin(undoname,undogroup,optimize,units,sett){
	if(host.ActiveDocument!=null){
		if(undoname === undefined) undoname = "do somth";
		if(undogroup === undefined) undogroup = true;
		if(optimize === undefined) optimize = glOptim;
		if(units === undefined) units = glUnit;
		if(sett === undefined) sett = "before";
        if(glFullDbg) dbg("begin " + undoname + " - " + undogroup);
		host.ActiveDocument.SaveSettings(sett);
		host.ActiveDocument.Unit = units;
		if(undogroup) host.ActiveDocument.BeginCommandGroup(undoname);
		host.Application.Optimization = optimize;
		host.EventsEnabled = !optimize;
	}
}

function do_end(undogroup, sett, refresh){
	if(host.ActiveDocument!=null){
		if(undogroup === undefined) undogroup = true;
		if(refresh === undefined) refresh = true;
		if(sett === undefined) sett = "before";
		do_cure(undogroup, refresh);
		host.ActiveDocument.RestoreSettings(sett);
        if(glFullDbg) dbg("end " + undogroup);
	}
}

function do_cure(undogroup, refresh){
    if(refresh === undefined) refresh = true;
	if(host.ActiveDocument!=null){
		if(undogroup === undefined) undogroup = true;
		host.EventsEnabled = true;
		host.Application.Optimization = false;
        //alert(undogroup);
		if(undogroup) host.ActiveDocument.EndCommandGroup();
		if (refresh){
            host.ActiveWindow.Activate();
            host.Application.Refresh();
            host.DoEvents;
        }
	}
}

function getSizeS(el, mode){
    if (mode === undefined) mode = "A";
    var ret = vbGetShapeSize(host.ActiveselectionRange, Shift(), mode);
    if (ret>0) el.value = ret;
}

function get_cnt(){
    return host.ActiveSelectionRange.Count;
}

function getSstring(s){
    var ret = s.type + "_" + s.SizeWidth + "_" + s.SizeHeight + "_" + s.CenterX + "_" + s.CenterY + "_";
    if(s.type<5) ret += s.DisplayCurve.Length;
    return ret;
}

function get_OS(bycolor, selall, reverse, ingroup, grmode){
//    warn("");
	if(defdoc()){
		if(bycolor === undefined) bycolor = true;
		if(selall === undefined) selall = true;
		if(reverse === undefined) reverse = false;
		if(ingroup === undefined) ingroup = (isShift(Shift())) ? true : false;
		if(grmode === undefined) grmode = [];
        if(glFullDbg) dbg("get_OS: clr=" + bycolor + ", sel=" + selall + ", rev=" + reverse + ", ing=" + ingroup + ", grm=" + grmode);
		//host.ActiveWindow.Activate();

        if(glSelect!=undefined){
            var sll = glSelect;
            setGlobalSelection(undefined);
            return sll;
        }
		if(bycolor){
			return do_select_colors(selall, reverse, ingroup, grmode);
		}else{

            var os = host.ActiveSelectionRange;

            //dbg ("doc:"+getVal(radio_sett_doc));
			if(getVal(radio_sett_doc)){
                os.RemoveAll();
                for (var i=host.ActiveDocument.Pages.Count;i>=1;i--){
                    os.AddRange((inArray("locked",grmode)) ? host.ActiveDocument.Pages(i).Shapes.All() : host.ActiveDocument.Pages(i).SelectableShapes.All());
                }
			}else if((os.Shapes.Count==0 /*|| os.Shapes.Count==1 && isMaster()*/) && selall) {
                var os = (inArray("locked",grmode)) ? host.ActivePage.Shapes.All() : host.ActivePage.SelectableShapes.All();
				var msg = lang['text_more50'].replace("{shtuk}",os.Shapes.Count);
				if (os.Shapes.Count>30) if (!confirm(msg)) os.RemoveAll();
			}
            setGlobalSelection(undefined);
		}
		//if (ingroup) os = os.Shapes.FindShapes("", 0, ingroup, "@Name!='dsf'");
		var nolast = inArray("nolast",grmode);
        if (nolast){
            var s = os.Shapes(1);
            os.Remove(1);
        }
		if (ingroup){
            os = getInGroup(os, true); //vbdoQuery(os.Shapes,"@name!='sdfsdflkjdsfkldskj'", true);
            os.AddRange(getInPwrclip(os));
		} //getInGroup(os);

        if (reverse || nolast) os = os.ReverseRange;
        if (nolast){
            os.Add(s);
            if (!reverse) os = os.ReverseRange;
        }
        if(glFullDbg) dbg("end get_OS: " + os.Shapes.Count);
		return os;
	}else{
		return null
	}
}

function get_EOS(OS){
    if(OS === undefined) OS = null;
	if(defdoc()){
		var esr = host.ActiveSelectionRange;
		esr.RemoveAll();
        if (OS!=null) esr.AddRange(OS);
		return esr;
	}else{
		return null;
	}
}

function getInPwrclip(os){
    var sr = get_EOS();
    var OSS = vbdoQuery(os.Shapes,"@com.powerclip.shapes.count>0", true);
    var cnt_os = OSS.shapes.count;
    //alert(cnt_os);
    for (var i=1;i<=cnt_os;i++){
        sr.AddRange(getInGroup(OSS.Shapes(i).PowerClip, false, false));
    }
    return sr;
}

function getInGroup(OSS, query, ungroup){
    if(OSS === undefined) OSS = get_OS();
    if(query === undefined) query = false;
    if(ungroup === undefined) ungroup = true;

    var sr = get_EOS();
    if (query===true){
        sr = vbdoQuery(OSS.Shapes,"@name!='sdfsdflkjdsfkldskj'", true);
    }else{
        var cnt_os = OSS.Shapes.Count;
        for (var i=1;i<=cnt_os;i++){
            if (vbgetExist(OSS.Shapes(i))){
                var s = OSS.Shapes(i);
                if (s.ParentGroup) if (s.ParentGroup.Shapes.Count==1) s = s.ParentGroup;
                if (s.Shapes.Count==1 && s.Effects.Count==0){
                    sd = s.Shapes(1);
                    if (ungroup) s.Ungroup();
                    s = sd;
                }
                if (s.Shapes.Count==0){
                    sr.Add(s);
                }else{
                    sr.AddRange(getInGroup(s.Shapes.All()));
                }
            }
        }
    }
	return sr;
}


function setGlobalSelection(sr, create){
    if (sr === undefined || sr.Shapes.Count==0){
        warn();
        glSelect = undefined;
    }else if (getVal(radio_sett_doc) || create){
        if (!create) warn([lang['text_warning_global_selection'], hint['text_warning_global_selection']]);
        glSelect = sr;
        if(!getVal(radio_sett_doc)) glSelect.CreateSelection();
    }else{
        sr.CreateSelection();
    }
}   

function glMem(){
    var shft = Shift();
    if(glMemory===undefined || (glMemory.Shapes.Count>0 && shft==4)){
        dbg("inundef");
        var OS = get_OS();
        setglMemory(OS, btn_glMemory);
        btn_glMemory.title = OS.Shapes.Count;
    }else{
        dbg("inelse");
        if(shft==0) {
            setGlobalSelection(glMemory, true);
        }else if(shft==1){
            dbg("in1");
            glMemory.AddRange(get_OS());
            btn_glMemory.title = glMemory.Shapes.Count;
        }else if(shft==2){
            setglMemory(undefined, btn_glMemory);
            btn_glMemory.title = "";
        }
    }
    if (glMemory) dbg("glMem: " + glMemory.Shapes.Count + " - " + shft);
}

function setglMemory(sr, el){
    if(sr==undefined || sr.Shapes.Count==0){
        if(glMemory) glMemory.RemoveAll();
        glMemory = undefined;
        if(el!=undefined) el.style.backgroundColor = "";
    }else{
        glMemory = sr;
        if(el!=undefined) el.style.backgroundColor = "salmon";
    }
    return glMemory;
}

// Функция для генерации всех возможных перестановок
function generatePermutations(count) {
    var result = [];
    var elements = [];
    
    // Создаем массив элементов от 0 до count-1
    for (var i = 0; i < count; i++) {
        elements.push(i);
    }
    
    // Рекурсивная функция для генерации перестановок
    function permute(arr, used, current) {
        // Если текущая перестановка завершена
        if (current.length == count) {
            var perm = [];
            for (var j = 0; j < current.length; j++) {
                perm.push(current[j]);
            }
            result.push(perm);
            return;
        }
        
        // Перебираем все возможные элементы для текущей позиции
        for (var k = 0; k < arr.length; k++) {
            if (!used[k]) {
                used[k] = true;
                current.push(arr[k]);
                permute(arr, used, current);
                current.pop();
                used[k] = false;
            }
        }
    }
    
    // Инициализируем массив использованных элементов
    var used = [];
    for (var m = 0; m < count; m++) {
        used.push(false);
    }
    
    // Запускаем генерацию
    permute(elements, used, []);
    
    return result;
}

function getRandom(max, min,dig) {
	if(max === undefined) max = 10;
	if(min === undefined) min = 1;
	if(dig === undefined) dig = 4;
    min = Math.ceil(min);
    max = Math.floor(max);
    return getRound(Math.random() * (max - min + 1),dig) + min;
}
function getRound(val,dig){
	if(dig === undefined) dig = 4;
	ret = vall(val, false);
	if(dig>-1){
		ret = ret.toString();
		ind = ret.indexOf(".");
		if (ind<1) ind = ret.length;
		ret = ret.substring(0,ind+dig+1);
		ret*=1;
	}
    return ret;
}

function calcGap(va){
    var ret = 10000;
    var iva = getRound(va,0);
    var digs = Math.pow(10,iva.toString().length-1);
    if (digs>500) digs = 200;
    ret = (getRound(iva/digs,0)+1)*digs;
    return ret;
}

function calc(string, check) {
    if(check === undefined) check = false;

    if (check){
        var stt = string.replace(/[^\d^\.^\+^\-^\/^\*^\(^\)]*/g,"");
        if (stt!=string) return string;
    }
    //alert(string);
    //string = "*5+4*2";
    string += "";
    string = string.replace("\\","/");
    string = string.replace(" ","");
    string = string.replace(",",".");
    string = string.replace(/[^\d^\.^\+^\-^\/^\*^\(^\)]*/g,"");
    string = string.replace(/^[\*\/]*/g,"");
    string = string.replace(/^0*/g,"");
    if (string.length<1) string = 0;
    var res = eval(string);
    return res;
}


function vall(srcc, scale, round, sha, pref){
    if(sha === undefined) sha = false;
    if(scale === undefined) scale = true;
    if(round === undefined) round = -1;
    var scal = (scale) ? wScale : 1;
	var src = srcc+"";
    if (src!=null){
        if (sha){
            if(pref === undefined) pref = "no";
            switch (pref.toLowerCase()){
                case "l": pref = sha.DisplayCurve.length; break;
                case "h": pref = sha.SizeHeight; break;
                case "w": pref = sha.SizeWidth; break;
                case "o": pref = (sha.Outline.Type==1) ?  sha.Outline.Width : 0; break;
                case "no":pref = 0; break;
                default:  pref = max_size(sha); break;
            }
            src = (/^[\*\+\-\/]/.test(src)) ? pref * scal + src: src+"";
            if (isDCurve(sha)) src = src.replace(/[lL]{1,}/g,sha.DisplayCurve.length);
            if (sha.Shapes.Count==0) src = src.replace(/[oO]{1,}/g,(sha.Outline.Type==1) ? sha.Outline.Width : 0);
            src = src.replace(/[hH]{1,}/g,sha.SizeHeight*scal);
            src = src.replace(/[wW]{1,}/g,sha.SizeWidth*scal);
        }else if (parseInt(src)+""!=src){
            src = src.replace(/^[^\d^\-]{1,}/g,"");
        }
		src = (isNaN(parseInt(src))) ? 0 : calc(src) / scal;
		if(round>-1) src = getRound(src,round);
		return src;
	}else{
		return false;
	}
}

function fixOS(OS){
    if (OS!=undefined && OS.Shapes.Count>0){
        for (var i=1; i<=OS.Shapes.Count; i++){
            if (!vbgetExist(OS.Shapes(i))){
                OS.Remove(i);
            }
            if (i==0) break;
        }
    }
}

function defdoc(){
    if (!host) return false;
	wScale = 1;
	var ret = false;
	if(host.ActiveDocument){
		host.ActiveDocument.Unit=glUnit;
		host.ActiveDocument.ReferencePoint = 9;
		wScale = host.ActiveDocument.WorldScale;
		ret = true;
	}
	return ret;
}


// VBA functions

function vbWriteFile(fname, data){
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.WriteFile", fname, data);
	return ret;
}

function vbReadFile(name, split, glue ){
	if(split === undefined) split = "";
	if(glue === undefined) glue = "!NONO!";
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.ReadFile", name);
    if (ret){
        if (split.length>0){
            ret =ret.split(split);
            if (glue!="!NONO!") ret = ret.join(glue);
        }
    }else{
        ret = [];
    }
	return ret;
}


function vbWriteFileUTF(fname, data){
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.WriteFileUTF", fname, data);
	return ret;
}

function vbReadFileUTF(name, split, glue ){
	if(split === undefined) split = "";
	if(glue === undefined) glue = "!NONO!";
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.ReadFileUTF", name);
    if (ret){
        if (split.length>0){
            ret =ret.split(split);
            if (glue!="!NONO!") ret = ret.join(glue);
        }
    }else{
        ret = [];
    }
	return ret;
}

function vbReadFolder(name, filter){
    if (filter===undefined) filter = "*.*";
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.ReadFolder", name, filter);
	ret = (ret) ? ret.split(chr(10)) : [];
	return ret;
}
function vbgetClick(){
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.getClick");
	ret = (ret) ? ret.split(":") : [];
	return vallArr(ret);
}

function vbGetPointPositionAt(seg, off){
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.GetPointPositionAtXY", seg, off);
	ret = (ret) ? ret.split(":") : [];
	return vallArr(ret);
}

function vbFindClosestSegmentXY(s, X, Y, split, join){
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.FindClosestSegmentXY", s, X, Y, split, join);
	ret = (ret) ? ret.split(":") : [];
	return vallArr(ret);
}

function vallArr(arr){
    for (var key in arr) arr[key] = vall(arr[key],false);
    return arr;
}
 
function getCopy(el){
    if (Shift()==4) if (el.value.length>0) vbCopy(el.value);
    return false;
}

function getbyName(name, OS, ingroup, strong){
    if (strong === undefined) strong = true;
    if (ingroup === undefined) ingroup = false; //true - search in group, false - search in all shapes
    if (OS===undefined) OS = host.ActivePage.SelectableShapes.All();
    var qry = (strong) ? "@name='" + name + "'" : "@name.indexOf('" + name + "')>=0";
    return vbdoQuery(OS.Shapes, qry, ingroup);
  }

function vbcorrect_perspective(os){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.correct_perspective", os);}
function vbget_qrcode(text, tip, withtxt, src, dpi){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.get_qrcode", text, tip, withtxt, src, dpi);}
function vbdoQuery(shapes, query, ingroup){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.do_query", shapes, query, ingroup);}
function vbGetShapeSize(shape, shift, mode){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.get_size_from_shape", shape, shift, mode);}
function vbMoveIt(){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.start_moveit");}
function vbLastofUs(){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.start_lastofus");}
function vbDel(name){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.regD", name);}
function vbRead(name){
    if(readact[name] === undefined) readact[name] = 0;
    readact[name]++;
    if (!host || name.length<3) return false;
    var val = host.GMSManager.RunMacro("wpanel", "Macros.RegRead", name);

    if (val=="false") val = false;
    if (val=="true") val = true;
    if (!val && val!==false) val = undefined;
    return val;
}
function vbWrite(name,val){if (!host) return false; return host.GMSManager.RunMacro("wpanel", "Macros.regWrite", name, val);}
function vbmkdir(path){return host.GMSManager.RunMacro("wpanel", "Macros.make_dir", path);}
function vbfileExist(path){return host.GMSManager.RunMacro("wpanel", "Macros.file_exist", path);}
function vbExport(fpath, ftype, select, expopt){return host.GMSManager.RunMacro("wpanel", "Macros.export_type", fpath, ftype, select, expopt);}
function vbStatSend(ver){return host.GMSManager.RunMacro("wpanel", "Macros.stat_send",ver);}
function vbgetExist(sha){return host.GMSManager.RunMacro("wpanel", "Macros.get_exist",sha);}
function vbEval(sha, query){return host.GMSManager.RunMacro("wpanel", "Macros.sEval",sha, query);}
//function vbgetbyName(name, OS){return host.GMSManager.RunMacro("wpanel", "Macros.get_by_name",name, OS);}
function vbgetSegOffbyXY(seg,xx,yy){return host.GMSManager.RunMacro("wpanel", "Macros.getSegOffbyXY", seg, xx, yy);}
function vbBreakSubPathAtXY(sp,xx,yy, bynode){return host.GMSManager.RunMacro("wpanel", "Macros.BreakSubPathAtXY", sp,xx,yy, bynode);}
function vbBreakSNodes(s,arr, split2){return host.GMSManager.RunMacro("wpanel", "Macros.BreakSNodes", s,arr.join(","), split2);}
function vbMakeSize(dir, shft, start){return host.GMSManager.RunMacro("wpanel", "Macros.make_sizes_sep", dir, shft, start);}
function vbRun(path, soft){return host.GMSManager.RunMacro("wpanel", "Macros.run_soft", path, soft);}
function vbImportFile(path, type){return host.GMSManager.RunMacro("wpanel", "Macros.ImportFile", path, type);}
function vbCopy(text){return host.GMSManager.RunMacro("wpanel", "Macros.TxtCopy", text);}

function vbAlign(hh, vv, outl){return host.GMSManager.RunMacro("wpanel", "Macros.AlignAndDistribute", hh, vv, outl);}
function vbCustomCommand(sr, comp, comm){return host.GMSManager.RunMacro("wpanel", "Macros.CustmCommnd", sr, comp, comm);}
function vbTemplFileAdd(path){return host.GMSManager.RunMacro("wpanel", "Macros.TemplFileAdd", path);}
function vbTemplFileDel(path, fname, title, msg){return host.GMSManager.RunMacro("wpanel", "Macros.TemplFileDel", path, fname, title, msg);}
function vbRenameTemplate(path, oldName, newName){return host.GMSManager.RunMacro("wpanel", "Macros.vbRenameTemplate", path, oldName, newName);}
function vbTemplCatAdd(path, title, msg, msgexist){return host.GMSManager.RunMacro("wpanel", "Macros.TemplCatAdd", path, title, msg, msgexist);}
function vbTemplCatDel(path, cat, title, msg){return host.GMSManager.RunMacro("wpanel", "Macros.TemplCatDel", path, cat, title, msg);}
function vbTemplPath(path, title, files){return host.GMSManager.RunMacro("wpanel", "Macros.TemplPath", path, title, files);}
function vbTemplList(path, title, msg){
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.TemplList", path, title, msg);
	ret = (ret) ? ret.split(";") : [];
	return ret;
}
function vbTemplFiles(path){
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.TemplFiles", path);
	ret = (ret) ? ret.split(";") : [];
	return ret;
}
function vbfileList(path, filter){
	if(filter === undefined) filter = "";
	var ret = host.GMSManager.RunMacro("wpanel", "Macros.file_list", path, filter);
	ret = (ret) ? ret.split(";") : [];
	return ret;
}

function vbWebcamGetImg(resX, resY){return host.GMSManager.RunMacro("wpanel", "webcam.WebcamGetImg", resX, resY);}
function vbWebcamCorrect(shape){return host.GMSManager.RunMacro("wpanel", "webcam.CorrectImg", shape);}
function vbWebcamSaveDis(mode){return host.GMSManager.RunMacro("wpanel", "webcam.CorrectDistortion", mode);}

/* To rewrite */
function curves_to_curve(){vbCurveToCurve(Shift());}
function corners_off(){vbCornersOff(Shift());}
function delete_overlap(){vbDeleteOverlap(Shift());}
function make_monoline_font(){vbMonoline(Shift());}
function clepto_main(){vbCleptoMain(Shift(), getVal("ch_sett_sel"));}

function vbCurveToCurve(mode){return host.GMSManager.RunMacro("wpanel", "Macros.curves_to_curve", mode);}
function vbCornersOff(){return host.GMSManager.RunMacro("wpanel", "Macros.do_corner_off");}
function vbDeleteOverlap(mode){return host.GMSManager.RunMacro("wpanel", "Macros.delete_overlap_make", mode);}
function vbCleptoMain(mode, page){return host.GMSManager.RunMacro("wpanel", "Macros.clepto_main", mode, page);}
function vbMonoline(mode){return host.GMSManager.RunMacro("wpanel", "Macros.monoline_from_font", mode);}
function vbSmartGroup(){return host.GMSManager.RunMacro("wpanel", "Macros.do_smart_group");}

function vbKill(path){return host.GMSManager.RunMacro("wpanel", "Macros.del_file", path);}
function vbBarcodes(os, btype, bftype, btext, bback, errcorr){return host.GMSManager.RunMacro("wpanel", "Macros.make_barcode", os, btype, bftype, btext, bback, errcorr);}




function angle2planes(alpha, beta, gamma) {
  /**
   * Вычисляет угол между двумя плоскостями, зная их углы наклона к третьей плоскости и угол между проекциями их линий пересечения на третью плоскость.
   *
   * Args:
   *   alpha: Угол наклона первой плоскости к третьей плоскости (в градусах).
   *   beta: Угол наклона второй плоскости к третьей плоскости (в градусах).
   *   gamma: Угол между проекциями линий пересечения плоскостей на третью плоскость (в градусах).
   *
   * Returns:
   *   Угол между плоскостями в градусах. Возвращает NaN, если входные данные некорректны.
   */
	if(alpha === undefined) alpha = 90;
	if(beta === undefined) beta = 90;
	if(gamma === undefined) gamma = 90;

  // Проверка на корректность входных данных
  if (alpha < 0 || alpha > 90 || beta < 0 || beta > 90 || gamma < 0 || gamma > 180) {
    return NaN;
  }

  // Преобразование углов в радианы
  var alpha = alpha * Math.PI / 180;
  var beta = beta * Math.PI / 180;
  var gamma = gamma * Math.PI / 180;


  // Используем теорему косинусов для сферического треугольника
  var cosTheta = Math.cos(alpha) * Math.cos(beta) + Math.sin(alpha) * Math.sin(beta) * Math.cos(gamma);

  // Угол между плоскостями в радианах
  var theta = Math.acos(cosTheta);

  // Угол между плоскостями в градусах
  theta = theta * 180 / Math.PI;

  return theta;
}


function rotatePoint(x, y, angle, xR, yR) {
    if (xR === undefined) xR = 0;
    if (yR === undefined) yR = 0;
    
    var angleRad = angle * Math.PI / 180;

    var cosA = Math.cos(angleRad);
    var sinA = Math.sin(angleRad);
    
    // Сдвигаем точку относительно центра вращения
    var dx = x - xR;
    var dy = y - yR;
    
    // Поворачиваем сдвинутую точку
    var rotatedX = dx * cosA - dy * sinA;
    var rotatedY = dx * sinA + dy * cosA;
    
    // Возвращаем в исходную систему координат
    return {
      x: rotatedX + xR,
      y: rotatedY + yR
    };
  }

  function getLineAngle(x1, y1, x2, y2, inDegrees) {
    if (inDegrees === undefined) inDegrees = false;
    if (x2 === undefined && y2 === undefined) {
        x2 = x1;
        y2 = y1;
        x1 = 0;
        y1 = 0;
    }
    var angle = Math.atan2(y2 - y1, x2 - x1); // угол в радианах
    return inDegrees ? angle * (180 / Math.PI) : angle;
  }

function resizePoints(points, width, height) {
  if (!points || points.length < 2) {
    return points;
  }

  var numPoints = points.length;
  var x1 = points[1][0];
  var y1 = points[1][1];
  var x2 = points[numPoints - 1][0];
  var y2 = points[numPoints - 1][1];

  var centerX = (x1 + x2) / 2;
  var centerY = (y1 + y2) / 2;

  var angle = Math.atan2(y2 - y1, x2 - x1);
  var cosAngle = Math.cos(-angle);
  var sinAngle = Math.sin(-angle);
  var cosAngleBack = Math.cos(angle);
  var sinAngleBack = Math.sin(angle);

  var minX = Infinity;
  var minY = Infinity;
  var maxX = -Infinity;
  var maxY = -Infinity;
  var rotatedPoints = [];

  for (var i = 1; i < numPoints; i++) {
    var x = points[i][0];
    var y = points[i][1];
    
    //var rotatedX = (x - centerX) * cosAngle - (y - centerY) * sinAngle + centerX;
    //var rotatedY = (x - centerX) * sinAngle + (y - centerY) * cosAngle + centerY;
    var rotatedX = rotatePoint(x - centerX, y - centerY, -angle).x + centerX;
    var rotatedY = rotatePoint(x - centerX, y - centerY, -angle).y + centerY;

    rotatedPoints[i] = [rotatedX, rotatedY];

    if (rotatedX < minX) minX = rotatedX;
    if (rotatedY < minY) minY = rotatedY;
    if (rotatedX > maxX) maxX = rotatedX;
    if (rotatedY > maxY) maxY = rotatedY;
  }

  var originalWidth = maxX - minX;
  var originalHeight = maxY - minY;

  if (width==0) width = originalWidth;
  if (height==0) height = originalHeight;

  var scaleX = width / originalWidth;
  var scaleY = height / originalHeight;

  var resizedPoints = [];

  for (var i = 1; i < numPoints; i++) {
    var x = rotatedPoints[i][0];
    var y = rotatedPoints[i][1];

    var scaledX = (x - centerX) * scaleX + centerX;
    var scaledY = (y - centerY) * scaleY + centerY;

    var rotatedBackX = (scaledX - centerX) * cosAngleBack - (scaledY - centerY) * sinAngleBack + centerX;
    var rotatedBackY = (scaledX - centerX) * sinAngleBack + (scaledY - centerY) * cosAngleBack + centerY;


    resizedPoints[i] = [rotatedBackX, rotatedBackY];
  }

  return resizedPoints;
}


function centerPoints(points) {
  if (points.length < 3) {
    return points;
  }

  var firstPoint = points[1];
  var lastPoint = points[points.length - 1];
  var centerX = (firstPoint[0] + lastPoint[0]) / 2;
  var centerY = (firstPoint[1] + lastPoint[1]) / 2;

  var angle = Math.atan2(lastPoint[1] - firstPoint[1], lastPoint[0] - firstPoint[0]);
  var cosAngle = Math.cos(-angle); // Косинус обратного угла для вращения
  var sinAngle = Math.sin(-angle); // Синус обратного угла для вращения

  // Вращение и расчет ограничивающего прямоугольника
  var minX = Infinity;
  var minY = Infinity;
  var maxX = -Infinity;
  var maxY = -Infinity;

  var rotatedPoints = [];
  for (var i = 1; i < points.length; i++) {
    var x = points[i][0] - centerX;
    var y = points[i][1] - centerY;

    // Вращение (против угла angle)
    var rotatedX = x * cosAngle - y * sinAngle;
    var rotatedY = x * sinAngle + y * cosAngle;

    rotatedX += centerX;
    rotatedY += centerY;

    rotatedPoints[i] = [rotatedX, rotatedY];

    if (i > 1 && i < points.length - 1) { // Исключаем первую и последнюю точки
      if (rotatedX < minX) minX = rotatedX;
      if (rotatedX > maxX) maxX = rotatedX;
      if (rotatedY < minY) minY = rotatedY;
      if (rotatedY > maxY) maxY = rotatedY;
    }
  }

  // Центрирование основания прямоугольника
  var baseLineCenter = (firstPoint[0] + lastPoint[0]) / 2;
  var rectCenter = (minX + maxX) / 2;
  var offsetX = baseLineCenter - rectCenter;

  // Смещение точек и обратное вращение
  cosAngle = Math.cos(angle); // Косинус прямого угла для обратного вращения
  sinAngle = Math.sin(angle); // Синус прямого угла для обратного вращения

  var finalPoints = [];

  for (var i = 1; i < rotatedPoints.length; i++) {
    var rotatedX = rotatedPoints[i][0];
    var rotatedY = rotatedPoints[i][1];

    if (i > 1 && i < points.length - 1) { // Смещаем только внутренние точки
      rotatedX += offsetX;
    }

    x = rotatedX - centerX;
    y = rotatedY - centerY;

    // Обратное вращение (на угол angle)
    var finalX = x * cosAngle - y * sinAngle;
    var finalY = x * sinAngle + y * cosAngle;

    finalX += centerX;
    finalY += centerY;

    finalPoints[i] = [finalX, finalY];
  }

  return finalPoints;
}


function change_thikness(points, oldSize, newSize, tolerance) {
    if(tolerance === undefined) tolerance = 1;
    tolerance /=100;
  var len = points.length;
  if (len < 4) {
    return points; // Недостаточно точек, возвращаем исходный массив.
  }

  // Создаём новый массив для результата.
  var newPoints = [];
  for (var k = 1; k < len; k++) { // Копируем все точки в новый массив.
      newPoints[k] = [points[k][0], points[k][1],  points[k][2]]; // Глубокое копирование точки.
  }

  //alert(points);
  //alert(newPoints);
  for (var i = 1; i < len; i++) {

    // Первый отрезок (newPoints[i] -> newPoints[i+1]).
    var i1 = (i+1>=len) ? i+2-len : i + 1;
    var i2 = (i+2>=len) ? i+3-len : i + 2;
    var i3 = (i+3>=len) ? i+4-len : i + 3;

    var x1 = newPoints[i][0];
    var y1 = newPoints[i][1];
    var x2 = newPoints[i1][0];
    var y2 = newPoints[i1][1];

    var dist1 = Math.sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));

    // Второй отрезок (newPoints[i+2] -> newPoints[i+3]).
    var x3, y3, x4, y4, dist2;
    x3 = newPoints[i2][0];
    y3 = newPoints[i2][1];
    x4 = newPoints[i3][0];
    y4 = newPoints[i3][1];

    dist2 = Math.sqrt((x4 - x3) * (x4 - x3) + (y4 - y3) * (y4 - y3));

    if (Math.abs(dist1 - oldSize) <= tolerance && Math.abs(dist2 - oldSize) <= tolerance) {
      var diff = newSize - oldSize;
      if (len==5) diff = diff/2;

      // Изменяем первый отрезок (в новом массиве).
      var dx1 = x2 - x1;
      var dy1 = y2 - y1;
      var ratio1 = diff / dist1;

      if (len==5){
          newPoints[i][0] = x1 - dx1 * ratio1;
          newPoints[i][1] = y1 - dy1 * ratio1;
      }
      newPoints[i1][0] = x2 + dx1 * ratio1;
      newPoints[i1][1] = y2 + dy1 * ratio1;

      // Изменяем второй отрезок (в новом массиве).
      var dx2 = x3 - x4;
      var dy2 = y3 - y4;
      var ratio2 = diff / dist2;

      if (len==5){
          newPoints[i3][0] = x4 - dx2 * ratio2;
          newPoints[i3][1] = y4 - dy2 * ratio2;
      }
      newPoints[i2][0] = x3 + dx2 * ratio2;
      newPoints[i2][1] = y3 + dy2 * ratio2;
      i = i+3;
    }
  }

  return newPoints; // Возвращаем новый массив.
}

function smartFill(X,Y){
  var s1 = host.ActivePage.CustomCommand("Boundary", "SmartFill", X, Y);
  return s1;
}


function trim(str) {
  return str.replace(/^\s+|\s+$/g, '');
}


function escapeHtml(text, nums) {
    if (nums===undefined) nums = false;

  return text
      .replace(/&/g, "&amp;")
      .replace(/</g, "&lt;")
      .replace(/>/g, "&gt;")
      .replace(/"/g, "&quot;")
      .replace(/'/g, "&#039;")
      .replace(/\n/g, "<br />");
}

function removeRounds(points){
    var len = points.length;
      // Создаём новый массив для результата.
  var newPoints = [];
  for (var k = 1; k < len; k++) { // Копируем все точки в новый массив.
      newPoints[k] = [];
      for (var j=0;j<points[k].length;j++) newPoints[k][j] = points[k][j]; // Глубокое копирование точки.
  }
  for (var i = 1; i < len; i++) { // Копируем все точки в новый массив.
    newPoints[i][0] = newPoints[i][0]+10;
    newPoints[i][1] = newPoints[i][1]+10;
  }
    return newPoints; // Недостаточно точек, возвращаем исходный массив.
}

function getExternalTangents(x1, y1, r1, x2, y2, r2) {
    // Если второй радиус не задан — строим касательные из точки (x2, y2) к окружности (x1, y1, r1)
    var tangentPoints = [];
    var dx = x2 - x1;
    var dy = y2 - y1;
    var d2 = dx * dx + dy * dy;
    var d = Math.sqrt(d2);
  
    if (r2 == null) {
      if (d <= r1) return null; // точка внутри окружности — касательных нет
  
      var angleToPoint = Math.atan2(dy, dx);
      var angleOffset = Math.acos(r1 / d);
  
      for (var i = 0; i < 2; i++) {
        var sign = (i === 0) ? 1 : -1;
        var a = angleToPoint + sign * angleOffset;
        var tx = x1 + r1 * Math.cos(a);
        var ty = y1 + r1 * Math.sin(a);
        tangentPoints.push([{ x: tx, y: ty }, { x: x2, y: y2 }]);
      }
      return tangentPoints;
    }
  
    // Внешние касательные между двумя окружностями
    if (d <= Math.abs(r1 - r2)) return null; // одна окружность внутри другой — внешних касательных нет
  
    var angleBetweenCenters = Math.atan2(dy, dx);
    var angleOffset = Math.acos((r1 - r2) / d);
  
    for (var i = 0; i < 2; i++) {
      var sign = (i === 0) ? 1 : -1;
      var angle = angleBetweenCenters + sign * angleOffset;
      var p1x = x1 + r1 * Math.cos(angle);
      var p1y = y1 + r1 * Math.sin(angle);
      var p2x = x2 + r2 * Math.cos(angle);
      var p2y = y2 + r2 * Math.sin(angle);
      tangentPoints.push([{ x: p1x, y: p1y }, { x: p2x, y: p2y }]);
    }
  
    return tangentPoints;
  }
  

  function fillRandomRectangleWithCircles(x0, y0, width, height, rMin, rMax) {
    var circles = [];
    var maxAttempts = 1000;
  
    function getRandomRadius() {
      return rMin + Math.random() * (rMax - rMin);
    }
  
    function isOverlapping(cx, cy, r) {
      for (var i = 0; i < circles.length; i++) {
        var c = circles[i];
        var dx = cx - c.x;
        var dy = cy - c.y;
        var distSq = dx * dx + dy * dy;
        var minDist = r + c.r;
        if (distSq < minDist * minDist) return true;
      }
      return false;
    }
  
    var attempts = 0;
    while (attempts < maxAttempts) {
      var r = getRandomRadius();
      var cx = x0 + r + Math.random() * (width - 2 * r);
      var cy = y0 + r + Math.random() * (height - 2 * r);
  
      if (!isOverlapping(cx, cy, r)) {
        circles.push({ x: cx, y: cy, r: r });
      }
  
      attempts++;
    }
  
    return circles;
  }

  function generatePointsInRect(xMin, yMin, xMax, yMax, n) {
    var points = [];
    for (var i = 0; i < n; i++) {
      var x = xMin + Math.random() * (xMax - xMin);
      var y = yMin + Math.random() * (yMax - yMin);
      points.push([x, y]);
    }
    return points;
  }

  tmrs.push({name:"sys end",time:new Date().getTime()});
