// Functions for the cat_colors module

// Global variables for layers functionality
var nosel = [];
var layerFilter = "";
var scanAllPages = false;

// 🔧 Безопасная функция получения текста локализации
function getLang(key, defaultValue) {
    if (typeof window.lang !== 'undefined' && window.lang[key]) {
        return window.lang[key];
    }
    if (typeof lang !== 'undefined' && lang[key]) {
        return lang[key];
    }
    return defaultValue !== undefined ? defaultValue : key;
}

// 🔧 Безопасная функция получения подсказки
function getHint(key, defaultValue) {
    if (typeof window.hint !== 'undefined' && window.hint[key]) {
        return window.hint[key];
    }
    if (typeof hint !== 'undefined' && hint[key]) {
        return hint[key];
    }
    return defaultValue !== undefined ? defaultValue : '';
}

function scan_colors(){
	do_events("button_scan_colors");
	var fcolors = [];
	var ffcolors = [];
	var ocolors = [];
	var other = [];
	var effects = [];
	var texts = [];
	var col_btns = document.getElementById("scan_colors_buttons_gen");
	var col_sel = document.getElementById("button_select_colors");
	var OS = get_OS(false);
	var shft = Shift();
	col_btns.innerHTML = '';
	var cnt_all=0;
	for(var i=1;i<OS.Shapes.Count+1;i++){
		var s = OS.Shapes(i);
        var add_other = true;
		if(s.type==7) {
			key = 40;
			if (!other[key]){other[key] = []; other[key]['cnt'] = 0;}
			other[key]['cnt']++;
			other[key]['title'] = getLang('text_type_groups_full', 'Группы') + " (" + other[key]['cnt'] + ")";
			other[key]['ltr'] = getLang('text_type_groups_short', 'Группы') + ": " + other[key]['cnt'] + "";
			cnt_all++;
            add_other = false;
		}
        if(s.type==5){
			cl = get_bitmap_mode(s.Bitmap);
			key = cl['mode'];
			if (!other[key]){other[key]=[]; other[key]['cnt']=0;}
			other[key]['cnt']++;
			other[key]['title']=cl['name'] +" (" + other[key]['cnt'] + ")";
			other[key]['ltr']=cl['name'].substring(0,8) + ": " + other[key]['cnt'] + "";
			cnt_all++;
            add_other = false;
		}
        if(s.PowerClip){
			key = 'pwr';
			if (!other[key]){other[key]=[]; other[key]['cnt']=0;}
			other[key]['cnt']++;
			other[key]['title']=getLang('text_type_pwrclp_full', 'ПврКлип') + " (" + other[key]['cnt'] + ")";
			other[key]['ltr']=getLang('text_type_pwrclp_short', 'ПврКлип') + ": " + other[key]['cnt'] + "";
			cnt_all++;
            add_other = false;
		}
        if(isSimpleShape(s, [6])){
			if(s.Fill.Type==0){
				if (!fcolors[0]){fcolors[0]=[]; fcolors[0]['cnt']=0;}
				fcolors[0]['cnt']++;
				fcolors[0]['stitle']=getLang('text_nofill', 'Без заливки') + ": " + fcolors[0]['cnt'];
				fcolors[0]['title']=getLang('text_nofill', 'Без заливки') + " (" + fcolors[0]['cnt'] + ") ";
				cnt_all++;
			}else if(s.Fill.Type==1){
				var cl = get_color_info(s.Fill.UniformColor);
				var hex = cl['hex'];
				if (!fcolors[hex]){fcolors[hex]=[]; fcolors[hex]['cnt']=0;}
				fcolors[hex]['cnt']++;
				fcolors[hex]['gray'] = cl['gray'];
				fcolors[hex]['stitle']=cl['hint'] + ": " + fcolors[hex]['cnt'];
				fcolors[hex]['title']=cl['hint'] + " (" + fcolors[hex]['cnt'] + ") " + cl['hex'];
				cnt_all++;
			}else if(s.Fill.Type==2){
				var cl = get_color_info(s.Fill.Fountain.Colors, true);
				var hex = cl['hex'];
				if (!ffcolors[hex]){ffcolors[hex]=[]; ffcolors[hex]['cnt']=0;}
				ffcolors[hex]['cnt']++;
				ffcolors[hex]['gray'] = cl['gray'];
				ffcolors[hex]['digs'] = cl['digs'];
				ffcolors[hex]['stitle']=getLang('text_ffill', 'Градиент') + " (" + ffcolors[hex]['cnt'] + ") " + cl['hex'];
				ffcolors[hex]['title']=getLang('text_ffill', 'Градиент') + " " + cl['hint'] + " (" + ffcolors[hex]['cnt'] + ") " + cl['hex'];
				cnt_all++;
			}
			if(s.Outline.Type==0){
				if (!ocolors[0]){ocolors[0]=[]; ocolors[0]['cnt']=0;}
				ocolors[0]['cnt']++;
				ocolors[0]['stitle']=getLang('text_nooutline', 'Без абриса') + ": " + ocolors[0]['cnt'];
				ocolors[0]['title']=getLang('text_nooutline', 'Без абриса') + " (" + ocolors[0]['cnt'] + ") ";
				cnt_all++;
			}else{
				var cl = get_color_info(s.Outline.Color);
				var hex = cl['hex'];
				if (!ocolors[hex]){ocolors[hex]=[]; ocolors[hex]['cnt']=0;}
				ocolors[hex]['cnt']++;
				ocolors[hex]['stitle']=cl['hint'] + ": " + ocolors[hex]['cnt'];
				ocolors[hex]['title']=cl['hint'] + " (" + ocolors[hex]['cnt'] + ") " + cl['hex'];
				cnt_all++;
			}
			if (s.Type==6) {
				var hex = s.Text.Story.Font;
				if (!texts[hex]) { texts[hex] = []; texts[hex]['cnt'] = 0;}
				texts[hex]['cnt']++;
				var fin = hex.indexOf(" ", 4);
				if (fin>8 || fin<0) fin = 8;
				texts[hex]['title'] = hex.substring(0,fin) + ": " + texts[hex]['cnt'];
				texts[hex]['hint'] = hex + " (" + texts[hex]['cnt'] + ")";
				cnt_all++;
			}
            add_other = false;
		}

		if (s.Effect!=null){
			var ef = get_effect_info(s.Effect);
			var key = 20 + ef['type'];
			if (!effects[key]){effects[key]=[]; effects[key]['cnt']=0;}
			effects[key]['cnt']++;
			effects[key]['title']=ef['name'] + " (" + effects[key]['cnt'] + ")";
			effects[key]['ltr']=ef['ltr'] + ": " + effects[key]['cnt'] + "";
			cnt_all++;
            add_other = false;
		}

        if(s.Effects && s.Effects.Count>0){
            for (var ei=1;ei<=s.Effects.Count;ei++){
                var ef = (s.Effects(ei).Type==9) ? get_effect_info(s.Effects(ei), s.Transparency) : get_effect_info(s.Effects(ei));
                var key = 20 + ef['type'];
                if (!effects[key]){effects[key]=[]; effects[key]['cnt']=0;}
                effects[key]['cnt']++;
                effects[key]['title']=ef['name'] + " (" + effects[key]['cnt'] + ")";
                effects[key]['ltr']=ef['ltr'] + ": " + effects[key]['cnt'] + "";
                cnt_all++;
            }
            add_other = false;
        }

        if(add_other){
            var key = 90;
            if (!effects[key]){effects[key]=[]; effects[key]['cnt']=0;}
            effects[key]['cnt']++;
            effects[key]['title']=getLang('text_type_other_full', 'Разное') + " (" + effects[key]['cnt'] + ")";
            effects[key]['ltr']=getLang('text_type_other_short', 'Разное') + ": " + effects[key]['cnt'] + "";
            cnt_all++;
        }
	}
	var out = '';
	var i = 0;
	var btn_cnt = Math.floor(col_btns.offsetWidth/40) || 10;
	var cnt_all = 0;
	// ocolors
	for(var key in ocolors){
		var ids = "ocolor_" + i;
		var styleo = (key!=0) ? "border:solid 3px " + key : "";
		var link  = document.createElement('span');
		var stl, cnt, step;
		if(shft==4 || shft==5){
			stl = "color_btn3";
			cnt = ocolors[key]['stitle'];
			step = ocolors[key]['stitle'];
		}else{
			stl = "color_btn";
			cnt = ocolors[key]['cnt'];
			step = ocolors[key]['cnt'];
		}
		link.innerHTML = '<input type="button" id="'+ids+'" class="'+stl+'" style="'+styleo+'" value="'+cnt+'" step="'+step+'" title="'+ocolors[key]['title']+' '+getHint('buttons_select_colors', 'Выбрать')+'" onClick="select_color('+ids+')" oncontextmenu="glShift=4; select_color('+ids+'); return false;" name="outl" src="'+key+'" />';
		out += link.innerHTML;
		cnt_all++;
		i++;
	}
	if(cnt_all>btn_cnt) {out += '<hr />';}
	// fcolors
	i=0;
	for(var key in fcolors){
		var ids = "fcolor_" + i;
		var stylef = (key!=0) ? "background-color:" + key + ";" : "";
		if (fcolors[key]['gray']) stylef += "color: " + fcolors[key]['gray'] + ";";
		var link  = document.createElement('span');
		var stl, cnt, step;
		if(shft==4 || shft==5){
			stl = "color_btn3";
			cnt = fcolors[key]['stitle'];
			step = fcolors[key]['stitle'];
		}else{
			stl = "color_btn";
			cnt = fcolors[key]['cnt'];
			step = fcolors[key]['cnt'];
		}
		link.innerHTML = '<input type="button" id="'+ids+'" class="'+stl+'" style="'+stylef+'" value="'+cnt+'" step="'+step+'" title="'+fcolors[key]['title']+' '+getHint('buttons_select_colors', 'Выбрать')+'" onClick="select_color('+ids+')" oncontextmenu="glShift=4; select_color('+ids+'); return false;" name="fill" src="'+key+'" />';
		out += link.innerHTML;
		i++;
	}
	// ffcolors (градиенты)
	i=0;
	for(var key in ffcolors){
		var ids = "ffcolor_" + i;
		var skey = ffcolors[key]['digs'];
		var numc = skey.length;
		var stylef = (ffcolors[key]['gray']) ? "color: " + ffcolors[key]['gray'] + ";" : "";
		var link  = document.createElement('span');
		var stl, cnt, step;
		if(shft==4 || shft==5){
			stl = "color_btn3";
			cnt = ffcolors[key]['stitle'];
			step = ffcolors[key]['stitle'];
		}else{
			stl = "color_btn";
			cnt = ffcolors[key]['cnt'];
			step = ffcolors[key]['cnt'];
		}
		divs = '<div class="table_border">' +
			'<div id="'+ids+'" class="ffill_btn" value="'+ffcolors[key]['cnt']+'" step="'+ffcolors[key]['cnt']+'" title="'+ffcolors[key]['title']+' '+hint['buttons_select_colors']+'" onClick="select_color('+ids+')" oncontextmenu="glShift=4; select_color('+ids+'); return false;" name="ffill" src="'+key+'" >'+ffcolors[key]['cnt']+'</div>' +
			'<table border="0" cellspacing="0" cellpadding="0" class="color_btn_eff"><tr>';
		for(var di=0;di<numc;di++){
			//stylef = (skey[0]!=0) ? "background-color:" + skey[0] + ";" : "";
			divs += '<td style="background-color: '+skey[di]['hex']+' ;"></td>';
		}
		divs += '</tr></table></div>';
		link.innerHTML = divs;
		out += link.innerHTML;
		i++;
	}
	// other
	i=0;
	for(var key in other){
		var ids = "other_" + i;
		var link  = document.createElement('span');
		var stl, cnt, step;
		stl = (shft==4 || shft==5) ? "color_btn3" : "color_btn_eff";
        cnt = other[key]['ltr'];
        step = other[key]['ltr'];
    link.innerHTML = '<input type="button" id="'+ids+'" class="'+stl+'" value="'+cnt+'" step="'+step+'" title="'+other[key]['title']+' '+getHint('buttons_select_colors', 'Выбрать')+'" onClick="select_color('+ids+')" oncontextmenu="glShift=4; select_color('+ids+'); return false;" name="other" src="'+key+'" />';
		out += link.innerHTML;
		i++;
	}
	// effects
	i=0;
	for(var key in effects){
		var ids = "effects_" + i;
		var link  = document.createElement('span');
		var stl, cnt, step;
		stl = (shft==4 || shft==5) ? "color_btn3" : "color_btn_eff";
		cnt = effects[key]['ltr'];
		step = effects[key]['ltr'];
		link.innerHTML = '<input type="button" id="'+ids+'" class="'+stl+'" value="'+cnt+'" step="'+step+'" title="'+effects[key]['title']+' '+getHint('buttons_select_colors', 'Выбрать')+'" onClick="select_color('+ids+')" oncontextmenu="glShift=4; select_color('+ids+'); return false;" name="effects" src="'+key+'" />';
		out += link.innerHTML;
		i++;
	}
	// texts
	i=0;
	for(var key in texts){
		var ids = "texts_" + i;
		var link  = document.createElement('span');
		var stl, cnt, step;
		stl = (shft==4 || shft==5) ? "color_btn3" : "color_btn_eff";
		cnt = texts[key]['title'];
		step = texts[key]['title'];
		link.innerHTML = '<input type="button" id="'+ids+'" class="'+stl+'" value="'+cnt+'" step="'+step+'" title="'+texts[key]['hint']+' '+getHint('buttons_select_colors', 'Выбрать')+'" onClick="select_color('+ids+')" oncontextmenu="glShift=4; select_color('+ids+'); return false;" name="texts" src="'+key+'" />';
		out += link.innerHTML;
		i++;
	}
	// Вставка <hr> если много кнопок
   
	if(out.length>10){
		col_btns.innerHTML = out;
		col_sel.disabled = false;
		button_scan_colors.value = getLang('button_scan_colors', 'Поиск') + " (" + cnt_all + ")";
	}else{
		col_sel.disabled = true;
		button_scan_colors.value = getLang('button_scan_colors', 'Поиск');
	}
}

function matchLayerFilter(layerName, filter) {
    if (!filter || filter == "") return true;
    
    // Преобразуем wildcards в регекс
    var regexPattern = filter;
    
    // Экранируем специальные символы регекса кроме * и ?
    regexPattern = regexPattern.replace(/[.+^${}()|[\]\\]/g, '\\$&');
    
    // Заменяем wildcards на регекс
    regexPattern = regexPattern.replace(/\*/g, '.*');  // * = любые символы
    regexPattern = regexPattern.replace(/\?/g, '.');   // ? = один символ
    
    // Добавляем границы для точного поиска
    regexPattern = '^' + regexPattern + '$';
    
    try {
        var regex = new RegExp(regexPattern, 'i'); // i = ignore case
        return regex.test(layerName);
    } catch(e) {
        // Если регекс некорректный - просто ищем подстроку
        return layerName.toLowerCase().indexOf(filter.toLowerCase()) >= 0;
    }
}

function layers_do(el, mode, layer_index){
    if(mode == "save" || mode=="restore"){
        var OS = get_OS();
        var savedCount = 0;
        var restoredCount = 0;
        do_begin("layers_do");
        for (var i=1;i<=OS.Shapes.Count;i++){
            var s = OS.Shapes(i);
            if(mode=="save"){
                // Сохраняем текущий AbsoluteIndex слоя в свойствах объекта
                var currentLayerAbsIndex = s.Layer.AbsoluteIndex;
                s.Properties.DeleteAll("originlayer");
                if(!isCtrl()){
                    s.Properties("originlayer", 1) = currentLayerAbsIndex;
                    s.Properties("originlayer", 2) = s.PositionX;
                    s.Properties("originlayer", 3) = s.PositionY;
                    s.Properties("originlayer", 4) = s.RotationAngle;
                }
                savedCount++;
            }
            
            if(mode=="restore"){
                // Восстанавливаем объект на сохраненный слой
                try {
                    var savedLayerAbsIndex = s.Properties("originlayer", 1);
                    if(savedLayerAbsIndex && savedLayerAbsIndex != s.Layer.AbsoluteIndex) {
                        // Ищем слой по AbsoluteIndex
                        var targetLayer = null;
                        for (var j = 1; j <= host.ActivePage.Layers.Count; j++) {
                            if (host.ActivePage.Layers(j).AbsoluteIndex == savedLayerAbsIndex) {
                                targetLayer = host.ActivePage.Layers(j);
                                break;
                            }
                        }
                        
                        if(targetLayer) {
                            s.MoveToLayer(targetLayer);
                            if(isAlt())s.RotationAngle = s.Properties("originlayer", 4);
                            if(isCtrl()){
                                s.Move(s.Properties("originlayer", 2)-s.PositionX, s.Properties("originlayer", 3)-s.PositionY);
                            }
                            restoredCount++;
                        }
                    }
                } catch(e) {
                    // Объект не имеет сохраненного слоя - пропускаем
                }
            }
        }
        do_end();
        
        // Показываем результат
        if(mode=="save") {
            if(isCtrl()){
                dbg(lang['layers_cleared_positions'].replace("{0}", savedCount));
            }else{
                dbg(lang['layers_saved_positions'].replace("{0}", savedCount));
            }
        } else {
            dbg(lang['layers_restored_objects'].replace("{0}", restoredCount));
        }
        
        return;
    }

    if(mode == "uncheck"){
        nosel[layer_index] = (!el.checked) ? layer_index : 0;
        if (layer_index == "all") {
            // Определяем какие страницы обрабатывать
            var pages = [];
            if (scanAllPages) {
                for (var p = 1; p <= host.ActiveDocument.Pages.Count; p++) {
                    pages.push(host.ActiveDocument.Pages(p));
                }
            } else {
                pages.push(host.ActivePage);
            }
            
            // Проходим по всем выбранным страницам
            for (var pageIdx = 0; pageIdx < pages.length; pageIdx++) {
                var currentPage = pages[pageIdx];
                
                for (var i = 1; i <= currentPage.Layers.Count; i++) {
                    var layer = currentPage.Layers(i);
                    var absIndex = layer.AbsoluteIndex;
                    
                    // Применяем фильтр
                    if (!matchLayerFilter(layer.Name, layerFilter)) {
                        continue;
                    }
                    
                    nosel[absIndex] = (!el.checked) ? absIndex : 0;
                }
            }
        }
        // После изменения uncheck - обновим таблицу
        layers_refresh();
        return;
    }
    
    if(mode == "scan"){
        if(el.id && el.id=="layers_scan"){nosel = [];}
        
        // Получаем фильтр из поля ввода
        var filterInput = document.getElementById("layer_filter_input");
        if(filterInput) {
            layerFilter = filterInput.value;
        }
        
        layers_refresh();
        return;
    }
    
    if(mode == "toggle_all_pages"){
        scanAllPages = el.checked;
        layers_refresh();
        return;
    }
    

    
    // Обработка режима "all" для массовых операций
    if (layer_index == "all") {
        // Определяем какие страницы обрабатывать
        var pages = [];
        if (scanAllPages) {
            for (var p = 1; p <= host.ActiveDocument.Pages.Count; p++) {
                pages.push(host.ActiveDocument.Pages(p));
            }
        } else {
            pages.push(host.ActivePage);
        }
        
        // Проходим по всем выбранным страницам
        for (var pageIdx = 0; pageIdx < pages.length; pageIdx++) {
            var currentPage = pages[pageIdx];
            
            for (var i = 1; i <= currentPage.Layers.Count; i++) {
                var lay = currentPage.Layers(i);
                var absIndex = lay.AbsoluteIndex;
                
                // Применяем фильтр - обрабатываем только отфильтрованные слои
                if (!matchLayerFilter(lay.Name, layerFilter)) {
                    continue;
                }
                
                if (mode == "print" && !document.getElementById("lay_print_"+absIndex).disabled) lay.Printable = el.checked;
                if (mode == "visible" && !document.getElementById("lay_visible_"+absIndex).disabled) lay.Visible = el.checked;
                if (mode == "editable" && !document.getElementById("lay_edit_"+absIndex).disabled) lay.Editable = !el.checked;
                if (mode == "move") host.ActiveSelectionRange.MoveToLayer(lay);
            }
        }
        
        // После массового изменения - обновим таблицу
        if (mode != "move") {
            layers_refresh();
        }
    }else if (layer_index && layer_index != "all") {
        // Найдем слой по AbsoluteIndex
        var lay = null;
        var layerPosition = -1;
        for (var i = 1; i <= host.ActivePage.Layers.Count; i++) {
            if (host.ActivePage.Layers(i).AbsoluteIndex == layer_index) {
                lay = host.ActivePage.Layers(i);
                layerPosition = i;
                break;
            }
        }
        
        if (lay) {
            if (mode == "print") lay.Printable = el.checked;
            if (mode == "visible") lay.Visible = el.checked;
            if (mode == "editable") lay.Editable = !el.checked;
            if (mode == "move") host.ActiveSelectionRange.MoveToLayer(lay);
            
            // Перемещение слоев вверх/вниз
            if (mode == "moveup") {
                // Проверяем клавишу Shift для перемещения в самый верх
                if (Shift() == 1) {
                    // Перемещаем в самый верх (выше всех слоев)
                    var topLayer = host.ActivePage.Layers(1);
                    if (lay != topLayer) {
                        lay.MoveAbove(topLayer);
                        dbg("Слой '" + lay.Name + "' перемещен в самый верх");
                    }
                } else {
                    // Обычное перемещение вверх (выше предыдущего)
                    if (layerPosition > 1) {
                        var targetLayer = host.ActivePage.Layers(layerPosition - 1);
                        lay.MoveAbove(targetLayer);
                        dbg("Слой '" + lay.Name + "' перемещен вверх");
                    }
                }
            }
            
            if (mode == "movedown") {
                // Проверяем клавишу Shift для перемещения в самый низ
                if (Shift() == 1) {
                    // Перемещаем в самый низ (ниже всех слоев)
                    var bottomLayer = host.ActivePage.Layers(host.ActivePage.Layers.Count);
                    if (lay != bottomLayer) {
                        lay.MoveBelow(bottomLayer);
                        dbg("Слой '" + lay.Name + "' перемещен в самый низ");
                    }
                } else {
                    // Обычное перемещение вниз (ниже следующего)
                    if (layerPosition < host.ActivePage.Layers.Count) {
                        var targetLayer = host.ActivePage.Layers(layerPosition + 1);
                        lay.MoveBelow(targetLayer);
                        dbg("Слой '" + lay.Name + "' перемещен вниз");
                    }
                }
            }
            
            if (mode == "delete") {
                // Удаление слоя
                var layerName = lay.Name;
                var shouldDelete = false;
                
                // Проверяем клавишу Alt для удаления без подтверждения
                if (Shift() == 4) {
                    // Alt нажат - удаляем без подтверждения
                    shouldDelete = true;
                    dbg("Быстрое удаление слоя '" + layerName + "' (Alt+Click)");
                } else {
                    // Обычное удаление с подтверждением
                    shouldDelete = confirm(lang['layers_delete_confirm'].replace("{0}", layerName));
                }
                
                if (shouldDelete) {
                    try {
                        lay.Delete();
                        dbg("Слой '" + layerName + "' удален");
                    } catch(e) {
                        alert(lang['layers_delete_error'].replace("{0}", e.message));
                    }
                }
            }
        }
        
        // После изменения отдельного слоя - обновим таблицу
        if (mode != "move") {
            layers_refresh();
        }
    }
}

function layers_refresh(){
    // Инициализируем layers_selectors если еще не инициализирован
    if (!layers_selectors) {
        layers_selectors = document.getElementById("layers_selectors");
    }
    if (!layers_selectors) return; // Если элемент не найден, выходим
    
    var arLayers = [];
    var arlch = {
        'printable': [],
        'visible': [],
        'editable': []
    };
    var nole = 0;
    
    // Определяем какие страницы сканировать
    var pages = [];
    if (scanAllPages) {
        for (var p = 1; p <= host.ActiveDocument.Pages.Count; p++) {
            pages.push(host.ActiveDocument.Pages(p));
        }
    } else {
        pages.push(host.ActivePage);
    }
    
    // Проходим по всем выбранным страницам
    for (var pageIdx = 0; pageIdx < pages.length; pageIdx++) {
        var currentPage = pages[pageIdx];
        
        for (var i = 1; i <= currentPage.Layers.Count; i++) {
            var layer = currentPage.Layers(i);
            var absIndex = layer.AbsoluteIndex;
            
            // Применяем фильтр по имени
            if (!matchLayerFilter(layer.Name, layerFilter)) {
                continue; // Пропускаем слой если не подходит под фильтр
            }
            
            var layerName = layer.Name;
            if (scanAllPages && pages.length > 1) {
                layerName += "<br /><sup>" + currentPage.Name + "</sup>"; // Добавляем имя страницы
            }
            
            arLayers.push({
                name: layerName,  
                index: i,
                absIndex: absIndex,
                type: layer.Type, 
                printable: layer.Printable, 
                visible: layer.Visible, 
                editable: layer.Editable,
                page: currentPage
            });
            
            // Подсчет активных слоев (не отключенных через uncheck)
            var isDisabled = (nosel[absIndex] == absIndex);
            if (!isDisabled) {
                if (layer.Printable) arlch['printable'].push(absIndex);
                if (layer.Visible) arlch['visible'].push(absIndex);
                if (!layer.Editable) arlch['editable'].push(absIndex);
            }
            if (isDisabled) nole++;
        }
    }
    
    layers_selectors.innerHTML = "";
    
    // Добавляем поле фильтра и галочку "все страницы"
    var out = '<div style="margin-bottom:5px;">';
    out += lang['layers_filter_placeholder']+'<input type="text" id="layer_filter_input" placeholder="' + hint['layers_filter_placeholder'] + '" value="' + layerFilter + '" style="width:70%;" onchange="layers_do(this, \'scan\')" />';
    out += '</div>';
    
    out += '<table><tr><td class="midfnt">' + lang['text_caption'] + '</td>';
    out += '<td class="bigfnt" title="'+hint['layers_toprint']+'">🖶</td>';
    out += '<td class="bigfnt" title="'+hint['layers_tovisible']+'">👁</td>';
    out += '<td class="bigfnt" title="'+hint['layers_toedit']+'">🔒</td>';
    out += '<td class="bigfnt" title="'+hint['layers_tomove']+'">⛟</td>';
    out += '<td class="bigfnt" title="'+hint['layers_toselect']+'">✔</td>';
    out += '<td class="bigfnt" title="'+hint['layers_order']+'">↕</td>';
    out += '<td class="bigfnt" title="'+hint['layers_delete']+'">🗑</td>';
    out += '</tr>';
    var arl = arLayers.length;
    var activeLayersCount = arl - nole;
    
    for (var i = 0; i < arl; i++) {
        var absIndex = arLayers[i].absIndex;
        var isFirst = (i == 0);
        var isLast = (i == arl - 1);
        
        out += '<tr>';
        out += '<td class="midfnt">' + arLayers[i].name + '</td>';
        out += '<td class="midfnt"><input type="checkbox" class="noborder" id="lay_print_'+absIndex+'" onClick="layers_do(this, \'print\', ' + absIndex + ')" ' + (arLayers[i].printable ? 'checked' : '') + ' /></td>';
        out += '<td class="midfnt"><input type="checkbox" class="noborder" id="lay_visible_'+absIndex+'" onClick="layers_do(this, \'visible\', ' + absIndex + ')" ' + (arLayers[i].visible ? 'checked' : '') + ' /></td>';
        out += '<td class="midfnt"><input type="checkbox" class="noborder" id="lay_edit_'+absIndex+'" onClick="layers_do(this, \'editable\', ' + absIndex + ')" ' + (arLayers[i].editable ? '' : 'checked') + ' /></td>';
        out += '<td class="midfnt"><input type="button" class="bigfnt noborder" value="&#8656;" onClick="layers_do(this, \'move\', ' + absIndex + ')" /></td>';
        out += '<td class="midfnt"><input type="checkbox" class="noborder" id="lay_sel_'+absIndex+'" ' + (nosel[absIndex]==absIndex ? '' : 'checked') + ' onClick="layers_do(this, \'uncheck\', ' + absIndex + ')" /></td>';
        
        // Кнопки перемещения вверх/вниз
        out += '<td class="midfnt">';
        if (!isFirst) {
            out += '<input type="button" class="noborder" style="font-size:10px;" value="▲" onClick="layers_do(this, \'moveup\', ' + absIndex + ')" title="'+hint['layers_moveup']+'" />';
        }
        if (!isLast) {
            out += '<input type="button" class="noborder" style="font-size:10px;" value="▼" onClick="layers_do(this, \'movedown\', ' + absIndex + ')" title="'+hint['layers_movedown']+'" />';
        }
        out += '</td>';
        
        // Кнопка удаления (только если не единственный слой)
        out += '<td class="midfnt">';
        if (arl > 1) {
            out += '<input type="button" class="noborder" style="font-size:12px; color:red;" value="✕" onClick="layers_do(this, \'delete\', ' + absIndex + ')" title="'+hint['layers_delete_fast']+'" />';
        }
        out += '</td>';
        
        out += "</tr>";
    }
    
    // Кнопки "все" - checked только если все активные слои имеют нужное состояние
    out += '<tr><td class="bigfnt">&nbsp;</td>';
    out += '<td class="bigfnt"><input type="checkbox" class="noborder" onClick="layers_do(this, \'print\',\'all\')" ' + (arlch['printable'].length == activeLayersCount ? 'checked' : '') + ' /></td>';
    out += '<td class="bigfnt"><input type="checkbox" class="noborder" onClick="layers_do(this, \'visible\',\'all\')" ' + (arlch['visible'].length == activeLayersCount ? 'checked' : '') + ' /></td>';
    out += '<td class="bigfnt"><input type="checkbox" class="noborder" onClick="layers_do(this, \'editable\',\'all\')" ' + (arlch['editable'].length == activeLayersCount ? 'checked' : '') + ' /></td>';
    out += '<td class="bigfnt">&nbsp;</td>';
    out += '<td class="bigfnt"><input type="checkbox" class="noborder" onClick="layers_do(this, \'uncheck\', \'all\')" ' + (nole == 0 ? 'checked' : '') + ' /></td>';
    out += '<td class="bigfnt">&nbsp;</td>';
    out += '<td class="bigfnt">&nbsp;</td>';
    out += '</tr>';

    out += "</table>";

    out += '<div align="left"><label style="margin-left:10px;"><input type="checkbox" class="noborder" onClick="layers_do(this, \'toggle_all_pages\')" ' + (scanAllPages ? 'checked' : '') + ' /> ' + lang['layers_all_pages'] + '</label></div>';

    layers_selectors.innerHTML = out;
    
    // Отключаем чекбоксы для неактивных слоев (используем AbsoluteIndex)
    for(var i = 0; i < nosel.length; i++){
        if(nosel[i]) {
            var absIndex = nosel[i];
            var editEl = document.getElementById("lay_edit_" + absIndex);
            var visibleEl = document.getElementById("lay_visible_" + absIndex);
            var printEl = document.getElementById("lay_print_" + absIndex);
            
            if(editEl) editEl.disabled = true;
            if(visibleEl) visibleEl.disabled = true;
            if(printEl) printEl.disabled = true;
        }
    }
}

// color replace
// Функция для проверки и коррекции на чистые цвета
function pureColor(cmykObj, simplification) {
    // Проверяем каждый чистый цвет из списка namesCMYK
    for (var i = 0; i < namesCMYK.length; i++) {
        var colorEntry = namesCMYK[i];
        
        // Пропускаем цвета без флага pure
        if (!colorEntry.pure) continue;
        
        // Проверяем, приближается ли текущий цвет к чистому в пределах simplification
        var diffC = Math.abs(cmykObj.c - colorEntry.c);
        var diffM = Math.abs(cmykObj.m - colorEntry.m);
        var diffY = Math.abs(cmykObj.y - colorEntry.y);
        var diffK = Math.abs(cmykObj.k - colorEntry.k);
        
        // Если все различия не превышают шаг упрощения, возвращаем чистый цвет
        if (diffC <= simplification && diffM <= simplification && 
            diffY <= simplification && diffK <= simplification) {
            return {c: colorEntry.c, m: colorEntry.m, y: colorEntry.y, k: colorEntry.k};
        }
    }
    
    // Если не нашли близкий чистый цвет, возвращаем исходный
    return cmykObj;
}

// Функция для поиска названия CMYK цвета
function findCMYKColorName(c, m, y, k, tolerance) {
    tolerance = tolerance || 2; // По умолчанию допуск 2%
    
    for (var i = 0; i < namesCMYK.length; i++) {
        var colorEntry = namesCMYK[i];
        
        var diffC = Math.abs(c - colorEntry.c);
        var diffM = Math.abs(m - colorEntry.m);
        var diffY = Math.abs(y - colorEntry.y);
        var diffK = Math.abs(k - colorEntry.k);
        
        // Если все различия в пределах допуска, возвращаем название
        if (diffC <= tolerance && diffM <= tolerance && 
            diffY <= tolerance && diffK <= tolerance) {
            return colorEntry.name;
        }
    }
    
    return null; // Название не найдено
}

// Функция для поиска названия RGB цвета
function findRGBColorName(r, g, b, tolerance) {
    tolerance = tolerance || 5; // По умолчанию допуск 5 единиц
    
    for (var i = 0; i < namesRGB.length; i++) {
        var colorEntry = namesRGB[i];
        
        var diffR = Math.abs(r - colorEntry.r);
        var diffG = Math.abs(g - colorEntry.g);
        var diffB = Math.abs(b - colorEntry.b);
        
        // Если все различия в пределах допуска, возвращаем название
        if (diffR <= tolerance && diffG <= tolerance && diffB <= tolerance) {
            return colorEntry.name;
        }
    }
    
    return null; // Название не найдено
}

// Функция для кастомной конвертации цветов
function customConvert(color, mode, params) {
    // params.simple = шаг округления, params.white1 = чистый белый, params.pure = чистые цвета
    var simpleStep = (params && params.simple) ? params.simple : 5;
    var useWhite1 = (params && params.white) ? params.white : false;
    var usePure = (params && params.pure) ? params.pure : false;
    switch (mode.toLowerCase()) {
        case 'rgb':
            if (color.Type != 5) color.ConvertToRGB();
            return (color.Type == 5);
        case 'cmyk':
            if (color.Type != 2) color.ConvertToCMYK();
            
            // Если конвертация успешна, применяем дополнительную обработку
            if (color.Type == 2) {
                var c = color.CMYKCyan;
                var m = color.CMYKMagenta;
                var y = color.CMYKYellow;
                var k = color.CMYKBlack;
                
                // Обработка белого цвета
                if (c <= simpleStep && m <= simpleStep && y <= simpleStep && k <= simpleStep) {
                    if (useWhite1 == "w0") {
                        color.CMYKAssign(0, 0, 0, 0); // Чистый белый
                    } else if (useWhite1 == "c1") {
                        color.CMYKAssign(1, 0, 0, 0); // Белый с минимальным цианом
                    } else if (useWhite1 == "k1") {
                        color.CMYKAssign(0, 0, 0, 1); // Чистый белый
                    }
                } else if (usePure) {
                    // Применяем чистые цвета если включена опция
                    var cmykObj = {c: c, m: m, y: y, k: k};
                    var pureResult = pureColor(cmykObj, simpleStep); // Для стандартного CMYK используем допуск 5%
                    color.CMYKAssign(pureResult.c, pureResult.m, pureResult.y, pureResult.k);
                }
            }
            return (color.Type == 2);
        case 'gray':
            if (color.Type != 9) color.ConvertToGray();
            return (color.Type == 9);
        case 'cmyksimple':
        // Упрощенная CMYK конвертация с округлением кратно simple
        try {
            // Сначала конвертируем в CMYK если это не CMYK
            if (color.Type != 2) {
                color.ConvertToCMYK();
            }
            
            if (color.Type == 2) {
                // Получаем текущие значения CMYK
                var c = color.CMYKCyan;
                var m = color.CMYKMagenta;
                var y = color.CMYKYellow;
                var k = color.CMYKBlack;

                // Проверяем на белый цвет и применяем правило white1
                if (c <= simpleStep && m <= simpleStep && y <= simpleStep && k <= simpleStep) {
                    if (useWhite1 == "w0") {
                        color.CMYKAssign(0, 0, 0, 0); // Чистый белый
                    } else if (useWhite1 == "c1") {
                        color.CMYKAssign(1, 0, 0, 0); // Белый с минимальным цианом
                    } else if (useWhite1 == "k1") {
                        color.CMYKAssign(0, 0, 0, 1); // Чистый белый
                    }
                    return true;
                }

                if (c < 3) c = 0;
                if (m < 3) m = 0;
                if (y < 3) y = 0;
                if (k < 3) k = 0;
                
                // Округляем кратно simpleStep
                var roundedC = Math.round(c / simpleStep) * simpleStep;
                var roundedM = Math.round(m / simpleStep) * simpleStep;
                var roundedY = Math.round(y / simpleStep) * simpleStep;
                var roundedK = Math.round(k / simpleStep) * simpleStep;
                
                // Ограничиваем значения в диапазоне 0-100
                roundedC = Math.max(0, Math.min(100, roundedC));
                roundedM = Math.max(0, Math.min(100, roundedM));
                roundedY = Math.max(0, Math.min(100, roundedY));
                roundedK = Math.max(0, Math.min(100, roundedK));
                
                // Если включены чистые цвета, проверяем приближение к ним
                if (usePure) {
                    var cmykObj = {c: roundedC, m: roundedM, y: roundedY, k: roundedK};
                    var pureResult = pureColor(cmykObj, simpleStep);
                    roundedC = pureResult.c;
                    roundedM = pureResult.m;
                    roundedY = pureResult.y;
                    roundedK = pureResult.k;
                }
                
                // Применяем округленные значения
                color.CMYKAssign(roundedC, roundedM, roundedY, roundedK);
                
                return true; // успешная конвертация
            }
            return false;
        } catch (e) {
            dbg(e);
            return false; // ошибка конвертации
        }
            
        case 'flex':
            // Флексографская конвертация по полиграфическим правилам
            try {
                // Spot-цвета оставляем как есть
                if (color.Type == 1 || color.Type == 99) { // PANTONE или spot
                    return false; // Spot-цвета не трогаем
                }
                
                // Все остальные конвертируем в CMYK
                if (color.Type != 2) {
                    color.ConvertToCMYK();
                }
                
                if (color.Type == 2) {
                    var c = color.CMYKCyan;
                    var m = color.CMYKMagenta;
                    var y = color.CMYKYellow;
                    var k = color.CMYKBlack;
                    
                                        // Проверяем на белый цвет (низкие значения всех красок)
                if (c <= simpleStep && m <= simpleStep && y <= simpleStep && k <= simpleStep) {
                    if (useWhite1 == "w0") {
                        // Чистый белый: C=0, M=0, Y=0, K=0
                        color.CMYKAssign(0, 0, 0, 0);
                    } else if (useWhite1 == "c1") {
                        // Белый с минимальным цианом: C=1, M=0, Y=0, K=0
                        color.CMYKAssign(1, 0, 0, 0);
                    } else if (useWhite1 == "k1") {
                        // Чистый белый: C=0, M=0, Y=0, K=1
                        color.CMYKAssign(0, 0, 0, 1);
                    }
                    return true;
                }
                    
                    // Проверяем на черный цвет (высокое значение K и низкие CMY)
                    if (k >= 90 && c <= simpleStep && m <= simpleStep && y <= simpleStep) {
                        // Чистый черный: C=0, M=0, Y=0, K=100
                        color.CMYKAssign(0, 0, 0, 100);
                        return true;
                    }
                    
                    // Проверяем на темный цвет для составного черного
                    var totalInk = c + m + y + k;
                    if (totalInk >= 280 && k >= 60) {
                        // Rich Black: C=60, M=40, Y=40, K=100
                        color.CMYKAssign(60, 40, 40, 100);
                        return true;
                    }
                    
                                        // Проверяем на чистые цвета используя функцию pureColor
                if (usePure) {
                    var cmykObj = {c: c, m: m, y: y, k: k};
                    var pureResult = pureColor(cmykObj, simpleStep); // Для flex используем допуск simpleStep%
                    
                    // Если цвет был заменен на чистый
                    if (pureResult.c != c || pureResult.m != m || pureResult.y != y || pureResult.k != k) {
                        color.CMYKAssign(pureResult.c, pureResult.m, pureResult.y, pureResult.k);
                        return true;
                    }
                }
                    
                    // Оптимизируем обычные цвета
                    // Убираем небольшие значения (менее 3%)
                    if (c < 3) c = 0;
                    if (m < 3) m = 0;
                    if (y < 3) y = 0;
                    if (k < 3) k = 0;
                    
                    // Ограничиваем общее количество краски (макс 300%)
                    var newTotal = c + m + y + k;
                    if (newTotal > 300) {
                        var scale = 300 / newTotal;
                        c = Math.round(c * scale);
                        m = Math.round(m * scale);
                        y = Math.round(y * scale);
                        k = Math.round(k * scale);
                    }
                    
                    color.CMYKAssign(c, m, y, k);
                    return true;
                }
                return false;
            } catch (e) {
                dbg(e);
                return false;
            }
            
        case 'palette':
            // TODO: конвертация в палитру
            return false; // пока не реализовано
        case 'pantone':
            // TODO: конвертация в Pantone
            return false; // пока не реализовано
        case 'custom':
            // TODO: пользовательская конвертация
            return false; // пока не реализовано
        default:
            return false; // неизвестный режим
    }
    return false;
}

// Функция для получения строки формата цвета (только значения без названий)
function getColorFormat(color) {
    switch (color.Type) {
        case 2: // CMYK
            var c = Math.round(color.CMYKCyan);
            var m = Math.round(color.CMYKMagenta);
            var y = Math.round(color.CMYKYellow);
            var k = Math.round(color.CMYKBlack);
            return "CMYK(" + c + "," + m + "," + y + "," + k + ")";
            
        case 5: // RGB
            var r = Math.round(color.RGBRed);
            var g = Math.round(color.RGBGreen);
            var b = Math.round(color.RGBBlue);
            return "RGB(" + r + "," + g + "," + b + ")";
            
        case 6: // HSB
            return "HSB(" + Math.round(color.HSBHue) + "," + Math.round(color.HSBSaturation) + "," + Math.round(color.HSBBrightness) + ")";
            
        case 12: // LAB
            return "LAB(" + Math.round(color.LABLightness) + "," + Math.round(color.LABa) + "," + Math.round(color.LABb) + ")";
            
        case 1: // PANTONE
        case 9: // Gray 
            return "Gray " + color.Gray;
            
        case 14: // PANTONE Hex
            return "PANTONE";
            
        case 0: // NO COLOR
            return "NO COLOR";
            
        default:
            return COLORS[color.Type] || "Unknown";
    }
}

function getFillKey(clr1){
    var arrind = clr1.Type + "_" + clr1.UniformColor.RGBvalue;
    if (clr1.Type==2){
        var hex = "";
        for(var ci=0; ci<clr1.Fountain.Colors.Count; ci++) hex += clr1.Fountain.Colors(ci).color.HexValue.substring(1);
        arrind = clr1.Type + "_" + hex;
    }
    return arrind;
}

function make_color_replace(mode){
    fixOS(glMemory);
    if (mode===undefined) mode = "scan";
    var OS = get_OS();
    var OScnt = OS.Shapes.Count;
    if (OScnt==0) return;
   
    do_begin("color_replace");

    var replMode = getVal("color_replace_mode");
    var replParams = {
        simple: getVal(val_color_replace_simple),
        white: getVal(color_replace_whitemode),
        pure: getVal(ch_color_replace_pure)
    };

    var shft = Shift();
    if (mode=="memory"){
        setglMemory((shft==2) ? undefined : OS, button_color_replace_memory);
    }else if (mode=="fill" || mode=="outline"){
        if (isAlt(shft)){
            for (var i=1; i<=OScnt; i++){
                var s = OS.Shapes(i); 
                if (mode=="outline"){
                    var colr = host.CreateColor();
                    colr.CopyAssign(s.Outline.Color);
                    customConvert(colr, replMode, replParams);
                    s.Outline.Color.CopyAssign(colr);
                }else{
                    if (s.Fill.Type==2){
                        for (var j=0; j<s.Fill.Fountain.Colors.Count; j++){
                            var colr = host.CreateColor();
                            colr.CopyAssign(s.Fill.Fountain.Colors(j).color);
                            customConvert(colr, replMode, replParams);
                            s.Fill.Fountain.Colors(j).color.CopyAssign(colr);
                        }
                    }else{
                        var colr = host.CreateColor();
                        colr.CopyAssign(s.Fill.UniformColor);
                        customConvert(colr, replMode, replParams);
                        s.Fill.UniformColor.CopyAssign(colr);
                    }
                }
            }
        }else if(glMemory){
            if (mode=="fill" && OScnt==1){
                var fir = OS.Shapes(1);
                if(fir.Fill.Type==2){
                    var resSort = sort_align(glMemory, "centery", "centerx", false, undefined,1);
                    resSort = resSort[0];
                    for (var i=0; i<fir.Fill.Fountain.Colors.Count; i++){
                        fir.Fill.Fountain.Colors(i).color.CopyAssign(glMemory.Shapes(resSort[i].index).Fill.UniformColor);
                    }
                    return true;
                }
            }
            var resSort = sort_align(glMemory, "centery", "centerx", false, undefined,1);
            resSort = resSort[1];
            var arReplace = [];
            for (var i=0; i<resSort.length; i++){
                for (var j=0; j<resSort[i].length-1; j++){
                    var sSearch = glMemory.Shapes(resSort[i][j].index);
                    var clr1 = sSearch.Fill;
                    var arrind = getFillKey(clr1);
                    arReplace[arrind] = resSort[i][resSort[i].length-1].index;
                    //glMemory.Shapes(resSort[i][resSort[i].length-1].index).CreateSelection();
                }
            }
            for (var i=1; i<=OScnt; i++){
                var s = OS.Shapes(i); 
                if (mode=="outline"){
                    var arrind = s.Outline.Type + "_" + s.Outline.Color.RGBvalue;
                    if (arReplace[arrind]) {
                        s.Outline.Color.CopyAssign(glMemory.Shapes(arReplace[arrind]).Fill.UniformColor);
                    }            
                }else{
                    var arrind = getFillKey(s.Fill);
                    if (arReplace[arrind]) {
                        s.Fill.CopyAssign(glMemory.Shapes(arReplace[arrind]).Fill);
                    }            
                }
            }
        }
    }else if (mode=="scan"){
        setglMemory(undefined, button_color_replace_memory);
        var out = "";
        var srSquares = get_EOS();
        var srFills = get_EOS();
        var srOutlines = get_EOS();
        var COLORS = {0: "NO COLOR", 1: "PANTONE", 2: "CMYK", 4: "CMY", 5: "RGB", 6: "HSB", 7: "HLS", 8: "black-and-white", 9: "grayscale", 11: "YIQ", 12: "LAB", 14: "PANTONE Hex", 20: "registration", 22: "multi-channel", 25: "user ink", 26: "mixed", 99: "spot"};
        var FillTypes = {0: "NO FILL", 1: "UNIFORM", 2: "FOUNTAIN", 3: "POSTSCRIPT", 4: "UNIFORM", 8: "TEXTURE", 9: "PATTERN", 10: "HATCH"};
                var OutlineTypes = {0: "NO OUTLINE", 1: "OUTLINE", 2: "ENHANCED"};
            var nonamecolor = host.createRGBColor(1,7,157).Name;
    
        var outArr = [];
        outArr['cnt'] = 0;
        outArr['unique'] = 0;
        outArr['fill'] = [];
        outArr['fill']['items'] = [];
        outArr['fill']['cnt'] = 0;
        outArr['fill']['unique'] = 0;
        outArr['outline'] = [];
        outArr['outline']['items'] = [];
        outArr['outline']['cnt'] = 0;
        outArr['outline']['unique'] = 0;
        for (var i=1; i<=OScnt; i++){
            var s = OS.Shapes(i);
            //out += "qr:" + vbEval(s, @fill.Color().Name()) + "\n";
            //out += "fill:" + s.Fill.UniformColor.Name + " - " + s.Fill.Type + "\n";
            for (var j=0; j<2; j++){
                if (j==1 && !getVal(ch_color_replace_scan_outline)) continue;
                var mode = (j==0) ? 'fill' : 'outline';
    
                var obj = (j==0) ? s.Fill : s.Outline;
    
                //dbg("obj.Type: " + obj.Type);
    
                if (!outArr[mode]['items'][obj.Type]){
                    outArr[mode]['items'][obj.Type] = [];
                    outArr[mode]['items'][obj.Type]['items'] = [];
                    outArr[mode]['items'][obj.Type]['cnt'] = 0;
                    outArr[mode]['items'][obj.Type]['name'] = (j==0) ? FillTypes[obj.Type] : OutlineTypes[obj.Type];
                    outArr[mode]['items'][obj.Type]['unique'] = 0;
                }
                
                // Определяем цвет правильно для fill и outline
                var colr;
                var hex = "NO HEX";

                if (j == 0) { // fill
                    switch (s.Fill.Type){
                        case 2: colr = s.Fill.Fountain; break; // Для градиента берем начальный цвет
                        case 3: colr = s.Fill.Postscript; break;
                        case 8: colr = s.Fill.Texture; break;
                        case 9: colr = s.Fill.Pattern; break;
                        case 10: colr = s.Fill.Hatch; break;
                        default: 
                            colr = s.Fill.UniformColor; 
                            hex = colr.HexValue.substring(1);
                        break;
                    }
                    if(s.Fill.Type==2){
                        hex = "";
                        for(var ci=0; ci<colr.Colors.Count; ci++){
                            hex += colr.Colors(ci).color.HexValue.substring(1);
                        }
                    }
                } else { // outline
                    colr = s.Outline.Color;
                    var hex = colr.HexValue.substring(1);
                }
    
                var cType = colr.Type;
                var cName = hex ? hex : (colr.Name!==undefined) ? colr.Name : "NO NAME";
                if (cType == 0) cName = "NO COLOR";
    
                if (!outArr[mode]['items'][obj.Type]['items'][cType]){
                    outArr[mode]['items'][obj.Type]['unique']++;
                    outArr[mode]['items'][obj.Type]['items'][cType] = [];
                    outArr[mode]['items'][obj.Type]['items'][cType]['items'] = [];
                    outArr[mode]['items'][obj.Type]['items'][cType]['cnt'] = 0;
                    outArr[mode]['items'][obj.Type]['items'][cType]['unique'] = 0;
                    outArr[mode]['items'][obj.Type]['items'][cType]['name'] = COLORS[cType];
                }
                if (!outArr[mode]['items'][obj.Type]['items'][cType]['items'][cName]){
                    outArr['unique']++;//total unique
                    outArr[mode]['unique']++;//total unique by mode
                    outArr[mode]['items'][obj.Type]['items'][cType]['unique']++;  // unique for type
                    outArr[mode]['items'][obj.Type]['items'][cType]['items'][cName] = [];
                    outArr[mode]['items'][obj.Type]['items'][cType]['items'][cName]['cnt'] = 0;
                    outArr[mode]['items'][obj.Type]['items'][cType]['items'][cName]['name'] = (colr.Name!==undefined) ? colr.Name : hex;
                    outArr[mode]['items'][obj.Type]['items'][cType]['items'][cName]['color'] = obj;
                }
                outArr['cnt']++;//total
                outArr[mode]['cnt']++; // total by mode
                outArr[mode]['items'][obj.Type]['cnt']++; // total for type
                outArr[mode]['items'][obj.Type]['items'][cType]['cnt']++; // total for type and color
                outArr[mode]['items'][obj.Type]['items'][cType]['items'][cName]['cnt']++; // total for type and color and name
            }
        }
    
        out += "All: " + outArr['cnt'] + " U: " + outArr['unique'] + "\n";
        for (var keyMode in outArr){
            if (keyMode == 'cnt' || keyMode == 'unique') continue;
            var mode = outArr[keyMode]; 
            out += keyMode + " All: " + mode.cnt + " U: " + mode.unique + "\n";
            for (var keyObjType in mode['items']){
                var objType = mode['items'][keyObjType];
                out += "---" + keyObjType + " - " + objType.name + " All: " + objType.cnt + " U: " + objType.unique + "\n";
                for (var keyColorType in objType['items']){
                    var colorType = objType['items'][keyColorType];
                    out += "------" + keyColorType + " - " + colorType.name + " All: " + colorType.cnt + " U: " + colorType.unique + "\n";
                    for (var keyColorName in colorType['items']){
                        var color = colorType['items'][keyColorName];
                        out += "---------" + keyColorName + " - " + color.name + " All: " + color.cnt + "\n";
    
                    }
                }
                out += "--\n";
            }
            out += "\n\n\n";
        }
    
        //dbg(out);
    
    
        // Создаем квадратики с цветами
        var startX = 0; // стартовая позиция, будет перемещена в конце
        var columnGap = 20; // зазор между столбиками в мм
    
        // Подсчитываем максимальное количество уникальных цветов в столбике
        var maxColors = Math.max(outArr['fill']['unique'], outArr['outline']['unique']);
    
        // Рассчитываем размер квадратика по высоте с ограничением
        var calculatedSize = OS.SizeHeight / (maxColors + (maxColors - 1) * 0.5);
        var maxSize = OS.SizeHeight * 0.2; // максимум 20% от высоты объектов
        var squareSize = Math.min(calculatedSize, maxSize);
        var gap = squareSize * 0.5; // зазор = 0.5 от высоты квадрата
    
        var currentY = OS.TopY;
        var currentX = startX;
        var currentColumn = 0;
    
        // Проходим по режимам fill и outline
        for (var modeKey in outArr) {
            if (modeKey == 'cnt' || modeKey == 'unique') continue;
            
            var mode = outArr[modeKey];
            var currentSR = (modeKey == 'fill') ? srFills : srOutlines;
            currentY = OS.TopY; // сбрасываем Y для нового режима
            currentX = 0; // сбрасываем X для нового режима
            
            // Проходим по всем цветам в режиме
            for (var keyObjType in mode['items']) {
                var objType = mode['items'][keyObjType];
                for (var keyColorType in objType['items']) {
                    var colorType = objType['items'][keyColorType];
                    for (var keyColorName in colorType['items']) {
                        var colorItem = colorType['items'][keyColorName];
                        
                        // Создаем оригинальный квадратик (слева)
                        var xl = currentX;
                        var yt = currentY;
                        var xr = currentX + squareSize;
                        var yb = currentY - squareSize;
                        var xl2 = currentX + squareSize + 5;
                        var xr2 = xl2 + squareSize;
                        
                        var square1 = host.ActiveLayer.CreateRectangle(xl, yt, xr, yb, 0);
                        var square2 = host.ActiveLayer.CreateRectangle(xl2, yt, xr2, yb, 0);
                       
                        // Копируем всю заливку от исходного объекта
                        if (modeKey == 'fill') {
                            square1.Fill.CopyAssign(colorItem.color);
                            srSquares.add(square1);
                            square2.Fill.CopyAssign(colorItem.color);
                            srSquares.add(square2);
                        } else { // outline
                            if (colorItem.color.Type == 0) {
                                square1.Fill.ApplyNoFill();    
                                square2.Fill.ApplyNoFill();    
                            } else {
                                square1.Fill.UniformColor.CopyAssign(colorItem.color.color);
                                square2.Fill.UniformColor.CopyAssign(colorItem.color.color);
                            }
                        }

                        var newColor = square2.Fill;

                        
                        currentSR.add(square1);
                        var conversionSuccess = false;
                        
                        // Для UniformColor - пытаемся конвертировать, для остальных - дублируем
                        if (inArray(newColor.Type, [1,2])) {


                            if (newColor.Type==1){
                                var strt = 0;
                                var end = 1;
                            }else{
                                var strt = 0;
                                var end = newColor.Fountain.Colors.Count-1;
                            }

                            for (var i=strt; i<=end; i++){
                                // Создаем копию цвета для конвертации
                                var sourceColor = newColor.Type==2 ? newColor.Fountain.Colors(i).color : newColor.UniformColor;
                                var convertedColor = host.CreateColor();
                                convertedColor.CopyAssign(sourceColor);
                                // Пытаемся конвертировать
                                var customResult = customConvert(convertedColor, replMode, replParams);
                                if(customResult && newColor.Type==2){
                                    newColor.Fountain.Colors(i).color.CopyAssign(convertedColor);
                                }
                                conversionSuccess = (customResult !== false && customResult !== null);                            
                            }
                            // Применяем результат конвертации
                            if(newColor.Type==2){
                                square2.Fill.CopyAssign(newColor);

                                if(getVal(ch_color_replace_scan_fountain)){
                                    var smstep = squareSize*0.1;
                                    var fgap = (newColor.Fountain.Colors.Count-1)*smstep;
                                    if (fgap>squareSize){
                                         fgap = smstep;
                                         smstep = smstep/4;
                                    }
                                    var fstep = (squareSize - fgap)/newColor.Fountain.Colors.Count;
                                    for(var i=0; i<newColor.Fountain.Colors.Count; i++){
                                        var newColor2 = host.CreateColor();
                                        newColor2.CopyAssign(newColor.Fountain.Colors(i).color);
                                        var frec = host.ActiveLayer.CreateRectangle2(xl2+(fstep+smstep)*i, yb-squareSize/10*4, fstep, squareSize/10*3, 0);
                                        frec.Fill.UniformColor.CopyAssign(newColor2);
                                        currentSR.add(frec);
                                    }
                                }
                            }else{
                                square2.Fill.UniformColor.CopyAssign(convertedColor);
                            }
                            
                        }
                        
                        currentSR.add(square2);
                        
                        if (getVal(ch_color_replace_titles)) {
                            // Создаем текстовую информацию для оригинального цвета
                            var colorInfo1 = "";
                            var colorFormat1 = "";
                            
                            if (modeKey == 'fill') {
                                colorInfo1 = FillTypes[colorItem.color.Type] || "Unknown";
                                if (colorItem.color.Type == 1) {
                                    var clr = colorItem.color.UniformColor;
                                    
                                    // Сначала ищем название в наших списках
                                    var foundName = null;
                                    if (clr.Type == 2) { // CMYK
                                        foundName = findCMYKColorName(clr.CMYKCyan, clr.CMYKMagenta, clr.CMYKYellow, clr.CMYKBlack);
                                    } else if (clr.Type == 5) { // RGB
                                        foundName = findRGBColorName(clr.RGBRed, clr.RGBGreen, clr.RGBBlue);
                                    }
                                    
                                    // Используем найденное название или оригинальное имя цвета
                                    if (foundName) {
                                        colorInfo1 = foundName;
                                    } else if (clr.Name && clr.Name != nonamecolor) {
                                        colorInfo1 = clr.Name;
                                    } else {
                                        colorInfo1 = "";
                                    }
                                    colorFormat1 = getColorFormat(clr);
                                }else if (colorItem.color.Type == 2){
                                    for (var i=0; i<colorItem.color.Fountain.Colors.Count; i++){
                                        colorFormat1 += getColorFormat(colorItem.color.Fountain.Colors(i).color) + "\r\n";
                                    }
                                }
                            } else { // outline
                                var clr = colorItem.color.color;
                                if (clr) {
                                    // Ищем название в наших списках
                                    var foundName = null;
                                    if (clr.Type == 2) { // CMYK
                                        foundName = findCMYKColorName(clr.CMYKCyan, clr.CMYKMagenta, clr.CMYKYellow, clr.CMYKBlack);
                                    } else if (clr.Type == 5) { // RGB
                                        foundName = findRGBColorName(clr.RGBRed, clr.RGBGreen, clr.RGBBlue);
                                    }
                                    
                                    // Используем найденное название или оригинальное имя цвета
                                    if (foundName) {
                                        colorInfo1 = foundName;
                                    } else if (clr.Name && clr.Name != nonamecolor) {
                                        colorInfo1 = clr.Name;
                                    } else {
                                        colorInfo1 = "";
                                    }
                                    
                                    colorFormat1 = getColorFormat(clr);
                                } else {
                                    colorInfo1 = "No Color";
                                    colorFormat1 = "";
                                }
                            }
    
                            var newline = "\r\n";
                            if (!colorInfo1 || colorInfo1 == ""){
                                newline = "";
                            }
    
                            // Создаем текст для оригинального квадратика
                            var textContent1 = colorInfo1 + (colorFormat1 ? newline + colorFormat1 : "");
                            var textY = yt - squareSize/2;
                            if (textContent1.replace(/^\s+|\s+$/g, "")) {
                                var text1 = host.ActiveLayer.CreateArtisticText(xl, textY, textContent1);
                                text1.Text.Story.Alignment=2;
                                
                                // Проверяем и ограничиваем размер текста
                                if (text1.SizeHeight > squareSize * 0.8)  text1.SetSize(0, squareSize * 0.8);
                                // Выравниваем по центру квадратика и позиционируем слева
                                text1.CenterY = yt - squareSize/2;
                                text1.RightX = xl - squareSize/2;
                                currentSR.add(text1);
                            }
                            
                            // Создаем текст для второго квадратика
                            var colorInfo2 = "";
                            var colorFormat2 = "";
                            
                            // Определяем что показывать во втором квадратике
                            if (conversionSuccess) {
                                // Конвертация успешна - показываем информацию о сконвертированном цвете
                                var convertedClr = square2.Fill.UniformColor;
    
                                // Ищем название в наших списках
                                var foundName2 = null;
                                if (convertedClr.Type == 2) { // CMYK
                                    foundName2 = findCMYKColorName(convertedClr.CMYKCyan, convertedClr.CMYKMagenta, convertedClr.CMYKYellow, convertedClr.CMYKBlack);
                                } else if (convertedClr.Type == 5) { // RGB
                                    foundName2 = findRGBColorName(convertedClr.RGBRed, convertedClr.RGBGreen, convertedClr.RGBBlue);
                                }
                                
                                if (foundName2) {
                                    colorInfo2 = foundName2;
                                }
                                if (newColor.Type == 2){
                                    for (var i=0; i<newColor.Fountain.Colors.Count; i++){
                                        colorFormat2 += getColorFormat(newColor.Fountain.Colors(i).color) + "\r\n";
                                    }
                                }else{
                                    colorFormat2 = getColorFormat(convertedClr);
                                }
                            } else {
                                // Конвертация не удалась - показываем информацию об оригинальном цвете
                                if ((modeKey == 'fill' && (colorItem.color.Type == 1 || colorItem.color.Type == 4)) ||
                                    (modeKey == 'outline' && colorItem.color.Type != 0)) {
                                    // Для UniformColor показываем формат оригинального цвета
                                    colorFormat2 = getColorFormat(square2.Fill.UniformColor);
                                } else {
                                    // Для сложных заливок показываем тип
                                    if (modeKey == 'fill') {
                                        colorFormat2 = FillTypes[colorItem.color.Type] || "Unknown";
                                    } else {
                                        colorFormat2 = "OUTLINE";
                                    }
                                }
                            }
                            
                            var newline = "\r\n";
                            if (!colorInfo2 || colorInfo2 == ""){
                                newline = "";
                            }
    
                            var textContent2 = colorInfo2 + (colorFormat2 ? newline + colorFormat2 : "");
                            if (textContent2.replace(/^\s+|\s+$/g, "")) {
                                var xl2 = currentX + squareSize + 5;
                                var xr2 = xl2 + squareSize;
                                var text2 = host.ActiveLayer.CreateArtisticText(xr2, textY, textContent2);
                                
                                // Проверяем и ограничиваем размер текста
                                if (text2.SizeHeight > squareSize * 0.8)  text2.SetSize(0, squareSize * 0.8);
                                // Выравниваем по центру квадратика и позиционируем справа
                                text2.CenterY = yt - squareSize/2;
                                text2.LeftX = xr2 + squareSize/2;
                                
                                // Красим текст в красный если не конвертировали
                                if (!conversionSuccess) {
                                    text2.Fill.UniformColor.RGBAssign(255, 0, 0); // красный цвет
                                }
                                
                                currentSR.add(text2);
                            }
                        }
                        
                        // Переходим к следующей позиции
                        currentY -= (squareSize + gap);
                    }
                }
            }
        }
    
        // Позиционируем созданные группы
        if (srFills.Count > 0) {
            srFills.LeftX = OS.RightX + OS.SizeWidth * 0.3;
        }
    
        if (srOutlines.Count > 0) {
            srOutlines.LeftX = (srFills.Count > 0) ? srFills.RightX + 50 : OS.RightX + OS.SizeWidth * 0.3;
        }
        if(srSquares.Shapes.Count>0) {
            srSquares.CreateSelection();
            setglMemory(srSquares, button_color_replace_memory);
        }
    
        //dbg(outArr);
    }
    do_end();

}


// ✅ Делаем функцию глобально доступной для HTML событий
window.scan_colors = scan_colors; 
window.make_color_replace = make_color_replace;
window.layers_do = layers_do;
window.layers_refresh = layers_refresh;
