// Модуль настроек wpanel
// Инициализация модуля cat_settings

function initCatSettings() {
    // Заполняем список языков
    populateLanguageList();
    
    // Заполняем список стилей
    populateStyleList();
    
    // Инициализация полей с текущими значениями путей
    if (typeof val_set_temp_path !== 'undefined') {
        var tempPath = vbRead('val_set_temp_path');
        if (tempPath) val_set_temp_path.value = tempPath;
    }
    
    if (typeof val_set_laser_path !== 'undefined') {
        var laserPath = vbRead('val_set_laser_path');
        if (laserPath) val_set_laser_path.value = laserPath;
    }
}

// Заполнение списка языков с использованием ModuleSystem
function populateLanguageList() {
    var langSelect = document.getElementById('lang');
    if (!langSelect) return;
    
    var langs = {
        // Приоритетные
        'ru': 'Русский',
        'en': 'English',
        'by': 'Беларуская',
        'uk': 'Український',
        'es': 'Español',
        'ar': 'العربية',
        
        // Европа
        'bg': 'Bulgarian',
        'cs': 'Čeština',
        'da': 'Dansk',
        'de': 'Deutsch',
        'et': 'Eesti',
        'fi': 'Suomi',
        'fr': 'Français',
        'lt': 'Lietuvių',
        'lv': 'Latviešu',
        'nl': 'Nederlands',
        'pl': 'Polski',
        'pt-br': 'Brasilian',
        'ro': 'Romanian',
        'sv': 'Svenska',
        
        // Азия
        'id': 'Indonesian',
        'ja': '日本語',
        'ko': '한국어',
        'tr': 'Turkish',
        'zh': '中文',
        
        // Ближний Восток / Африка / Кавказ
        'am': 'հայերէն',
        'kz': 'Казахский',
        'uz': 'Узбекский'
    };
    
    var langKeys = [];
    for (var key in langs) {
        if (key && langs[key]) {
            langKeys.push({key: key, val: langs[key]});
        }
    }
    ModuleSystem.populateList('lang', langKeys);
}

// Заполнение списка стилей с использованием ModuleSystem
function populateStyleList() {
    var styleSelect = document.getElementById('css_style');
    if (!styleSelect) return;
    
    var fldr = vbReadFolder('css', "*.css");
    if (!fldr) return;
    
    var styles = [];
    for (var i = 0; i < fldr.length; i++) {
        var fileName = fldr[i];
        if (fileName && fileName.length > 0) {
            var file = fileName.substring(0, fileName.length - 4);
            styles.push({key: file, val: file});
        }
    }
    
    ModuleSystem.populateList('css_style', styles);
}

// Регистрируем функцию инициализации в глобальном реестре
ModuleInitRegistry['cat_settings'] = initCatSettings; 